#include "stdafx.h"
#include "DViewer.h"
#include "defines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CDViewerApp theApp;
extern WORD Version;						//  ,  
extern WORD LastVersion;
extern HANDLE HeapHandle;
extern TCHAR PortName[];
extern DWORD BaudRate;		
extern BYTE ByteSize;						// Number of bits/byte, 4-8        
extern BYTE Parity;							// 0-4 = None, Odd, Even, Mark, Space    
extern BYTE StopBits;						// 0,1,2 = 1, 1.5, 2               
extern BOOL DTRControlFlag;
extern BOOL RTSControlFlag;
extern COMSTAT ComStat;
extern COMMTIMEOUTS CommTimeOuts;
extern HANDLE hComm;
extern OVERLAPPED osRead;
extern OVERLAPPED osWrite;
extern DCB dcb;
extern DWORD RemoteIPAddress;
extern sockaddr_in Addr;

extern TCHAR FramePath[];
extern TCHAR SettingsPath[];
extern TCHAR PEPsPath[];
extern TCHAR ProgramPath[];
extern LPCTSTR ProgramName;
extern TCHAR LogPath[];
extern char CRLF[];
extern TCHAR ErrorBuffer[256];

extern DWORD GlobalErrorCode;
extern DWORD BackColor; 
extern DWORD ForeColor;
extern COLORREF VRCHCurveColor;
extern COLORREF YellowColor;
extern COLORREF StrobColor;

extern SOCKET Socket;
extern char TextBuffer[];
extern TCHAR TextBufferUnicode[];

extern LPTSTR PortNotOpenString;
extern LPTSTR TimeOutString;
extern LPTSTR UnknownWriteErrorString;
extern LPTSTR UnknownWriteErrorWODelayString;
extern LPTSTR ReadErrorString;
extern LPTSTR UnknownReadErrorString;
extern BOOL StartupSearchFlag;
extern BYTE CurrentLanguage;


LPTSTR EnableString = _T( "ENABLE" );
TCHAR LogName[MAX_PATH];
TCHAR OldLogName[MAX_PATH];


LPVOID AllocateMemory( UINT Size )
{
LPVOID Pointer;

	Pointer = HeapAlloc( HeapHandle, HEAP_ZERO_MEMORY, Size );
	return Pointer;
}


LPVOID ReAllocateMemory( LPVOID Pointer, UINT Size )
{
	Pointer = HeapReAlloc( HeapHandle, HEAP_ZERO_MEMORY, Pointer, Size );
	return Pointer;
}


UINT SizeOfMemory( LPVOID Pointer )
{
	return HeapSize( HeapHandle, 0, Pointer );
}


BOOL FreeMemory( LPVOID BufferPointer )
{
BOOL Retcode;

	Retcode = HeapFree( HeapHandle, 0, BufferPointer );
	BufferPointer = NULL;
	return Retcode;
}

LPVOID AllocateMapMemory( LPTSTR Filename, LPTSTR Name, HANDLEPTR MapHandlePtr, DWORD Length, DWORD FileDesiredAccess, DWORD MapProtect, DWORD MapDesiredAccess )
{
HANDLE hFile;
HANDLE hIndexFileMap;
LPVOID VoidPtr;
SECURITY_ATTRIBUTES sa;

	hFile = CreateFile( Filename, FileDesiredAccess, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL );
	if ( hFile == INVALID_HANDLE_VALUE )
	{
		VoidPtr = NULL;
		goto quit_proc;
	}
	
	sa.nLength = sizeof( SECURITY_ATTRIBUTES );
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;
	hIndexFileMap = CreateFileMapping( hFile, &sa, MapProtect, 0, Length, Name );
	if ( hIndexFileMap == INVALID_HANDLE_VALUE )
	{
		CloseHandle( hFile );
		VoidPtr = NULL;
		goto quit_proc;
	}
	
	if ( CloseHandle( hFile ) == FALSE ) 
	{
		CloseHandle( hIndexFileMap );
		VoidPtr = NULL;
		goto quit_proc;
	}
	
	VoidPtr = MapViewOfFile( hIndexFileMap, MapDesiredAccess, 0, 0, Length );
	*MapHandlePtr = hIndexFileMap;	

quit_proc:	
	return VoidPtr;
}


BYTE HIGHBYTE( WORD i )
{
	return( ( i & 0xff00 ) >> 8 );
}


BYTE LOWBYTE( WORD i )
{
	return( i & 0x00ff );
}


WORD swap( WORD i )
{
	return( ( i >> 8 ) | ( i & 0xff ) << 8 );
}


WORD ControlSum( BYTEPTR BeginAddress, WORD Length )
{
WORD Sum;
WORD OldSum;
WORD i;
WORD j;
WORDPTR WordPointer;

	Sum = 0;
	OldSum = 0;
	i = 0;
	j = Length >> 1;
	WordPointer = ( WORDPTR ) BeginAddress;
	while( i < j )
	{
		Sum += WordPointer[i];
		if ( Sum < OldSum ) Sum++;
		OldSum = Sum;
		i++;
	}
	j = Length >> 1;
	j <<= 1;
	if ( Length != j )
	{
		i = BeginAddress[Length-1];
		i += 0xFF00;
		Sum += i;
		if ( Sum < OldSum ) Sum++;
	}

	return( Sum );
}


WORD PutStringInTextLog( char * TextString )
{
WORD Retcode;
CFile File;
CFileException e;
CString String;
LONG FileLength;
SYSTEMTIME Time;
char TimeBuffer[40];

	GetLocalTime( &Time );
	sprintf( &TimeBuffer[0], "%2.2d:%2.2d:%2.2d %2.2d/%2.2d/%4.4d ", Time.wHour, Time.wMinute, Time.wSecond, Time.wDay, Time.wMonth, Time.wYear );

	wcscpy( &LogName[0], LogPath );
	wcscat( &LogName[0], &ProgramName[0] );
	wcscat( &LogName[0], _T( ".LOG" ) );
	wcscpy( &OldLogName[0], LogPath );
	wcscat( &OldLogName[0], &ProgramName[0] );
	wcscat( &OldLogName[0], _T( ".OLD" ) );

	//   
	if ( File.Open( &LogName[0], CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareDenyNone, NULL ) == FALSE )
	{
		Retcode = 1;
		goto quit_proc;
	}

	if ( File.GetLength() >= 5000000L )
	{
		File.Close();
		CopyFile( &LogName[0], &OldLogName[0], FALSE );
		DeleteFile( &LogName[0] );

		//   log-
		if ( File.Open( &LogName[0], CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareDenyNone, NULL ) == FALSE )
		{
			Retcode = 1;
			goto quit_proc;
		}
		TRY { File.Write( &TextString[0],  0 ); } CATCH( CFileException, e ) { ; } END_CATCH
	}

	FileLength = ( LONG ) File.GetLength();
	File.Seek( FileLength, CFile::begin );

	if ( strcmp( &TextString[0], CRLF ) == 0 )
	{
		TRY { File.Write( &TextString[0],  2 ); } CATCH( CFileException, e ) { ; } END_CATCH
	}
	else
	{
	//   /  
		TRY { File.Write( &TimeBuffer[0], strlen( &TimeBuffer[0] ) ); } CATCH( CFileException, e ) { ; } END_CATCH
		TRY { File.Write( TextString, strlen( TextString ) ); } CATCH( CFileException, e ) { ; } END_CATCH
	}

	File.Close();

	Retcode = 0;

quit_proc:
	return( Retcode );
}


BOOL LoadConfiguration( VOID )
{
BOOL Retcode;
char VarBuffer[200];
CFile File;
BYTEPTR pBuf;
BYTEPTR SectionPtr;
WORD SectionLength;
WORD FileLength;

	if( File.Open( _T( "DViewer.cfg" ), CFile::modeRead | CFile::shareDenyNone, NULL ) == 0 )
	{   
		AfxMessageBox( _T( "   !\n  ." ), MB_OK, 0 );
		Retcode = FALSE;
		goto quit_proc;
	}
	
	FileLength = ( WORD ) File.GetLength();
	pBuf = ( BYTEPTR ) AllocateMemory( FileLength );
	if ( pBuf == NULL )
	{
		Retcode = FALSE;
		goto quit_proc;
	}
	File.Read( pBuf, FileLength );
	File.Close();

	//     SYSTEM
	SectionPtr = GetSectionData( pBuf, "SYSTEM", &SectionLength, FileLength );

	
	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "LANGUAGE_DEFAULT", SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( VarBuffer ) != 0 )
	{
		CurrentLanguage = atoi( ( char * ) &VarBuffer[0] );
	}
	else 
	{
		CurrentLanguage = 0;
	}

	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "IP_ADDRESS", SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( &VarBuffer[0] ) != 0 )
	{
		RemoteIPAddress = inet_addr( &VarBuffer[0] );
	}
	else 
	{
		RemoteIPAddress = inet_addr( "192.168.0.100" );
	}
	//      
	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "STARTUP_SEARCH_FLAG", SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( &VarBuffer[0] ) != 0 )
	{
		StartupSearchFlag = atoi( ( char * ) VarBuffer );
	}
	else
	{
		StartupSearchFlag = FALSE;
	}

	//   
	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "FRAMES_PATH", SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( VarBuffer ) != 0 )
	{
		if ( VarBuffer[strlen(&VarBuffer[0])-1] != '\\' && strlen( &VarBuffer[0] ) != 0  )
			strcat( &VarBuffer[0], "\\" );
		ConvertFromANSIToUnicode( &VarBuffer[0], &FramePath[0] );
	}
	else
	{
		wcscpy( &FramePath[0], _T( "FRAMES\\" ) );
	}

	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "LOG_PATH", SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( VarBuffer ) != 0 )
	{
		if ( VarBuffer[strlen(&VarBuffer[0])-1] != '\\' && strlen( &VarBuffer[0] ) != 0  )
			strcat( &VarBuffer[0], "\\" );
		ConvertFromANSIToUnicode( &VarBuffer[0], &LogPath[0] );
	}
	else
	{
		wcscpy( &LogPath[0], _T( "LOG\\" ) );
	}

	//  ""
	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "BACKGROUND_COLOR", ( WORD ) SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( &VarBuffer[0] ) != 0 )
	{
		BackColor = GetColorFromRGBBuffer( &VarBuffer[0] );
	}
	else
	{
		BackColor = 0x00c0c0c0;
	}

	//  
	Retcode = GetVarNameValue( SectionPtr, ( BYTEPTR ) "FOREGROUND_COLOR", ( WORD ) SectionLength, &VarBuffer[0] );
	if ( Retcode == 0 && strlen( &VarBuffer[0] ) != 0 )
	{
		ForeColor = GetColorFromRGBBuffer( &VarBuffer[0] );
	}
	else
	{
		ForeColor = 0x00000000;
	}


	Retcode = TRUE;

quit_proc:
	return Retcode;
}


BOOL SaveConfiguration( VOID )
{
DWORD i;
char VarBuffer[2000];
CFile File;
char TempBuffer[MAX_PATH];

	if( File.Open( _T( "DViewer.cfg" ), CFile::modeWrite | CFile::shareDenyNone, NULL ) == FALSE )
	{   
		PutStringInTextLog( "   .\n   !" );
		return FALSE;
	}

	File.SetLength( 0 );                                

	strcpy( &VarBuffer[0], "; DViewer program configuration file" );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], "[SYSTEM]" );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; select program language ( RUS=0, ENG=1, TUR=2 )" );
	strcat( &VarBuffer[0], CRLF );
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "LANGUAGE_DEFAULT = %d", CurrentLanguage );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; defectoscope IP address " );
	strcat( &VarBuffer[0], CRLF );
	Addr.sin_addr.S_un.S_addr = RemoteIPAddress;
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "IP_ADDRESS = %s", inet_ntoa( Addr.sin_addr ) );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; flag: searching defectoscope on net while initialization" );
	strcat( &VarBuffer[0], CRLF );
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "STARTUP_SEARCH_FLAG = %d", StartupSearchFlag );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; logfile path" );
	strcat( &VarBuffer[0], CRLF );
	ConvertFromUnicodeToANSI( &LogPath[0], &TempBuffer[0] );
	i = strlen( &TempBuffer[0] );
	if ( i > 2 )
	{
		if ( TempBuffer[i-1] == '\\' && TempBuffer[i-2] != ':' )
		{
			TempBuffer[i-1] = 0;
		}
	}
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "LOG_PATH = %s", &TempBuffer[0] );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; frame files path" );
	strcat( &VarBuffer[0], CRLF );
	ConvertFromUnicodeToANSI( &FramePath[0], &TempBuffer[0] );
	i = strlen( &TempBuffer[0] );
	if ( i > 2 )
	{
		if ( TempBuffer[i-1] == '\\' && TempBuffer[i-2] != ':' )
		{
			TempBuffer[i-1] = 0;
		}
	}
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "FRAMES_PATH = %s", &TempBuffer[0] );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	strcpy( &VarBuffer[0], "; *** program colours ***" );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], "; back colour" );
	strcat( &VarBuffer[0], CRLF );
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "BACKGROUND_COLOR = %d,%d,%d", ( BackColor & 0xff0000 ) >> 16, ( BackColor & 0x00ff00 ) >> 8, ( BackColor & 0x0000ff ) );
	strcat( &VarBuffer[0], CRLF );
	strcat( &VarBuffer[0], "; text colour" );
	strcat( &VarBuffer[0], CRLF );
	sprintf( &VarBuffer[strlen(&VarBuffer[0])], "FOREGROUND_COLOR = %d,%d,%d", ( ForeColor & 0xff0000 ) >> 16, ( ForeColor & 0x00ff00 ) >> 8, ( ForeColor & 0x0000ff ) );
	strcat( &VarBuffer[0], CRLF );
	File.Write( &VarBuffer[0], strlen( &VarBuffer[0] ) );

	File.Close();

	return TRUE;
}


BYTEPTR GetSectionData( BYTEPTR BytePtr, char * SectionName, WORDPTR SectionLength, WORD FileLength )
{
WORD i;
BYTEPTR RetPtr;

	RetPtr = NULL;
	*SectionLength = 0;

	i = 0;
	while( 1 )
	{
		if ( BytePtr[i] != '[' )
			goto next_byte;
		
		i++;
		if ( ( i + strlen( SectionName ) ) >= FileLength )
			goto quit_proc;

		if ( memicmp( &BytePtr[i], SectionName, strlen( SectionName ) ) != 0 )
			goto next_byte;

		i += ( strlen( SectionName ) + 1 );
		while ( BytePtr[i] < 0x30 && i < FileLength )
			i++;
		
		if ( i >= FileLength )
			goto quit_proc;
				 
		RetPtr = &BytePtr[i];
		while ( BytePtr[i] != '[' && i < FileLength )
		{
			i++;
			*SectionLength += 1;
		}

		goto quit_proc;

next_byte:
		i++;
		if ( i >= FileLength )
			break;
	}

quit_proc:
	return RetPtr;
}

BOOL GetVarNameValue( BYTEPTR BytePtr, BYTEPTR VarName, WORD SearchLength, char * VarBuffer )
{
WORD i,j,k;

	i = 0;
	while ( i < SearchLength )
	{
    	while ( 1 )
		{
			if ( BytePtr[i] == ';' )
			{
				while ( 1 )
				{
					if ( BytePtr[i] == 0x0a ) break;
					i++;
				}
				continue;
			}
			if ( BytePtr[i] > 0x20 ) break;
			i++;
    	}
		k = strlen( ( char * ) VarName );
		if ( memicmp( &BytePtr[i], &VarName[0], k ) == 0 && ( BytePtr[i+k] <= 0x20 || BytePtr[i+k] == 0x3d ) )
		{
			i += k;
			while ( 1 )
			{
				if ( BytePtr[i] == 0x3d )
				{
					i++;
					break;
				}
				if ( BytePtr[i] == 0x0D || BytePtr[i] == 0x0A || BytePtr[i] == ';' )
				{
					VarBuffer[0] = 0;
					return( -1 );
				}
				i++;
			}
    		while ( 1 )
   			{
				if ( BytePtr[i] == 0x0D || BytePtr[i] == 0x0A || BytePtr[i] == ';' )
				{
					VarBuffer[0] = 0;
					return( -1 );
				}
   				if ( BytePtr[i] > 0x20 ) break;
	   				i++;
    		}
			j = 0;
			while ( BytePtr[i] >= 0x20 )
			{
				//       199 
				if ( j >= 199 )
					break;
				VarBuffer[j] = BytePtr[i];
				i++; j++;
			}
			VarBuffer[j] = 0;
			return( 0 );
		}
    	while ( 1 )
    	{
			if ( i >= SearchLength )
				return( -1 );
    		if ( BytePtr[i] == 0x0a )
				break;
    		i++;
    	}
	}

	return( -1 );
}


DWORD GetColorFromRGBBuffer( char * VarBuffer )
{
WORD i;
WORD j;
TCHAR TempBuffer[20];
COLORREF Color;

	Color = 0;

	i = 0;
	j = 0;
	while( 1 )
	{
		if ( i == 3 || VarBuffer[j] == ',' || VarBuffer[j] <= 0x20 )
			break;
		if ( VarBuffer[j] <= 0x20 )
			goto quit_proc;
		TempBuffer[i] = VarBuffer[j];
		i++;
		j++;
	}
	TempBuffer[i] = 0;
	Color = _wtoi( TempBuffer );
	if ( VarBuffer[j] <= 0x20 )
		goto quit_proc;

	i = 0;
	j++;
	while( 1 )
	{
		if ( i == 3 || VarBuffer[j] == ',' || VarBuffer[j] <= 0x20 )
			break;
		if ( VarBuffer[j] <= 0x20 )
			goto quit_proc;
		TempBuffer[i] = VarBuffer[j];
		i++;
		j++;
	}
	TempBuffer[i] = 0;
	Color |= ( ( DWORD ) _wtoi( TempBuffer ) << 8 );
	if ( VarBuffer[j] <= 0x20 )
		goto quit_proc;

	i = 0;
	j++;
	while( 1 )
	{
		if ( i == 3 || VarBuffer[j] == ',' || VarBuffer[j] <= 0x20 )
			break;
		TempBuffer[i] = VarBuffer[j];
		i++;
		j++;
	}
	TempBuffer[i] = 0;
	Color |= ( ( DWORD ) _wtoi( TempBuffer ) << 16 );
	if ( VarBuffer[j] <= 0x20 )
		goto quit_proc;

quit_proc:
	return ( Color );
}


WORD GetWordDigit( char * TextString )
{
BYTEPTR EndPtr;
WORD Value;
INT i,j;

	Value = 0;		//   ,    .

	j = strlen( &TextString[0] );
	if ( j == 0 )
	{
		goto quit_proc;
	}
	if ( TextString[0] == '0' && ( TextString[1] == 'x' || TextString[1] == 'X' ) )
	{
		//   
		Value = ( WORD ) strtoul( TextString, ( char** ) &EndPtr, 0 );
		goto quit_proc;
	}
	if ( TextString[j-1] == 'h' ||
	     TextString[j-1] == 'H' )
	{
		//   
		TextString[j-1] = 0;
		j--;
		Value = ( WORD ) strtoul( TextString, ( char** ) &EndPtr, 16 );
		goto quit_proc;
	}
	for ( i=0;i<j;i++ )
	{
		if ( isxdigit( TextString[i] ) != 0 ) break;
	}
	if ( i != j )
	{
		//   
		Value = ( WORD ) strtoul( TextString, ( char** ) &EndPtr, 16 );
		goto quit_proc;
	}
	//   
	Value = atoi( TextString );
	goto quit_proc;

quit_proc:
	return Value;
}


BOOL SetFileLength( LPTSTR Path, DWORD Length )
{
BOOL bRetcode;
CFile File;

	if ( File.Open( Path, CFile::modeWrite | CFile::shareDenyNone, NULL ) == 0 )
	{
		bRetcode = FALSE;
		goto quit_proc;
   	}

	File.SetLength( Length );
	
	File.Close();

	bRetcode = TRUE;
		
quit_proc:
	return bRetcode;
}

//
// DoStartup() initializes the Winsock DLL with Winsock version 2.0
//
BOOL DoStartup( void )
{
WSADATA wsaData;
INT rc;

    rc = WSAStartup ( MAKEWORD ( 2,0 ), &wsaData );
	if ( rc != 0 ) return FALSE;
	else return TRUE;
}


//
// DoCleanup () will close the sockets which were opened successfully using 
// a call to socket (). Additionally, it will call WSACleanup (), if a call
// to WSAStartup () was made successfully.
//
void DoCleanup( void )
{
	WSACleanup();
}



int OpenSocketUDP( SOCKET *s )
{
int rc;

    *s = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP );
    if ( *s == INVALID_SOCKET )
	{
		rc = WSAGetLastError();
		return rc;
    }
	else
	{
		return 0;
    }
}


//
// BindSocket() binds the socket descriptor 's' to the specified
// address. If an endpoint is specified it uses that or it binds to a system 
// assigned port.
//
int BindSocket( SOCKET s, sockaddr_in * psa )
{
int rc;
    
    rc = bind ( s, ( sockaddr * ) psa, sizeof ( sockaddr ) );
    if ( rc == SOCKET_ERROR ) 
	{
		rc = WSAGetLastError();
		return rc;
	}
	else
	{
		return 0;
	}
}



int SendUDPDatagram( SOCKET s, BYTEPTR pBuffer, WORD Length, struct sockaddr_in * psa )
{
int rc;

    rc = sendto( s, ( char * ) pBuffer, Length, 0, ( sockaddr * ) psa, sizeof ( struct sockaddr ) );
    if ( rc == SOCKET_ERROR ) 
	{
		rc = WSAGetLastError();
		return rc;
	}
    else
	{
		return 0;
	}		
}

int ReceiveUDPDatagram( SOCKET s, struct sockaddr_in *AddrIn, BYTEPTR pBuffer, WORD * PacketLength )
{
int rc;
int addrlen;
int ReceiveLength;

	ReceiveLength = 546;
	addrlen = sizeof( struct sockaddr_in );
    rc = recvfrom( s, ( char * ) pBuffer, ReceiveLength, 0, ( struct sockaddr * ) AddrIn, &addrlen );
	if ( rc == SOCKET_ERROR )
	{
		rc = WSAGetLastError();
		*PacketLength = 0;
		return rc;
	}

	*PacketLength = rc;

    return 0;
}



//
//	IntSocketSetOpt() 
//
int IntSocketSetOpt( SOCKET s, WORD Protocol, WORD Optname, int optval )
{
int rc;

	rc = setsockopt( s, Protocol, Optname, ( char * ) &optval, sizeof( int ) );
    if ( rc == SOCKET_ERROR ) return WSAGetLastError();
    else return 0;
}


//
//	BoolSocketSetOpt()
//
int BoolSocketSetOpt( SOCKET s, WORD Protocol, WORD Optname, BOOL optval )
{
int rc;

	rc = setsockopt( s, Protocol, Optname, ( char * ) &optval, sizeof( BOOL ) );
    if ( rc == SOCKET_ERROR ) return WSAGetLastError();
    else return 0;
}



WORD GetTFTPFile( sockaddr_in *AddrOut, char * FileName, BYTEPTR FileBuffer, DWORDPTR FileBufferLength )
{
WORD Retcode;
WORD Type;
WORD ErrorCode;
WORD RequestLength;
WORD AnswerLength;
WORD AnswerDataLength;
DWORD Length;
WORD BlockCounterPacket;
WORD BlockCounter;
struct TFTP_REQUEST_STRUCT *TFTPRequestPtr;
struct TFTP_ANSWER_STRUCT *TFTPAnswerPtr;
sockaddr_in AddrIn;

	TFTPRequestPtr = ( struct TFTP_REQUEST_STRUCT * ) AllocateMemory( 514 );
	TFTPAnswerPtr = ( struct TFTP_ANSWER_STRUCT * ) AllocateMemory( 516 );

	if ( TFTPRequestPtr == NULL || TFTPAnswerPtr == NULL )
	{
		Retcode = 1;
		FreeMemory( TFTPRequestPtr );
		FreeMemory( TFTPAnswerPtr );
		goto quit_proc;
	}
	
	Length = 0;
	BlockCounter = 1;

	//     
	TFTPRequestPtr->Type = htons( TFTP_READ_REQUEST );
	RequestLength = 2;
	strcpy( ( char * ) &TFTPRequestPtr->Data[0], FileName );
	RequestLength += ( strlen( ( char * ) &TFTPRequestPtr->Data[0] ) + 1 );
	strcpy( ( char * ) &TFTPRequestPtr->Data[strlen( ( char * ) &TFTPRequestPtr->Data[0] )+1], "octet" );
	RequestLength += 6;
	SendUDPDatagram( Socket, ( BYTEPTR ) TFTPRequestPtr, RequestLength, AddrOut );

	AddrIn = *AddrOut;
	AddrIn.sin_port = 0;

	while ( 1 )
	{
		ReceiveUDPDatagram( Socket, &AddrIn, ( BYTEPTR ) TFTPAnswerPtr, &AnswerLength );
		
		if ( AnswerLength == 0 )
		{
			sprintf( &TextBuffer[0], "  %s -    ", FileName );
			strcat( &TextBuffer[0], CRLF );
			PutStringInTextLog( &TextBuffer[0] );
			Retcode = 5;
			FreeMemory( TFTPRequestPtr );
			FreeMemory( TFTPAnswerPtr );
			goto quit_proc;
		}

		Type = ntohs( TFTPAnswerPtr->Type );
		if ( Type == TFTP_ERROR )
		{
			ErrorCode = ntohs( TFTPAnswerPtr->ErrorCode );
			sprintf( &TextBuffer[0], " %s - %s", FileName, ( LPTSTR ) &TFTPAnswerPtr->Data[0] );
			strcat( &TextBuffer[0], CRLF );
			PutStringInTextLog( &TextBuffer[0] );
			Retcode = 2;
			break;
		}

		if ( Type == TFTP_DATA )
		{
			BlockCounterPacket = ntohs( TFTPAnswerPtr->ErrorCode );
			AnswerDataLength = AnswerLength - 4;
//			wsprintf( &TextBuffer[0], " %s -   %d ,   %d.", FileName, AnswerDataLength, BlockCounterPacket );
//			wcscat( &TextBuffer[0], CRLF );
//			PutStringInTextLog( &TextBuffer[0] );
			if ( BlockCounter == BlockCounterPacket )
			{
				if ( ( Length + AnswerDataLength ) > ( *FileBufferLength ) )
					AnswerDataLength = ( WORD ) ( ( *FileBufferLength ) - Length );
				Length += AnswerDataLength;
				BlockCounter += 1;
				memcpy( &FileBuffer[512L * ( DWORD ) ( BlockCounterPacket - 1 )], &TFTPAnswerPtr->Data[0], AnswerLength - 4 );
			}
			//    
			*AddrOut = AddrIn;
			TFTPRequestPtr->Type = htons( TFTP_ACKNOWLEDGMENT );
			* ( WORDPTR ) &TFTPRequestPtr->Data[0] = htons( BlockCounterPacket );
			RequestLength = 4;
			SendUDPDatagram( Socket, ( BYTEPTR ) TFTPRequestPtr, RequestLength, AddrOut );
			if ( AnswerDataLength < 512 )
			{
				( *FileBufferLength ) = Length;
				sprintf( &TextBuffer[0], " %s - .  %d ", FileName, Length );
				strcat( &TextBuffer[0], CRLF );
				PutStringInTextLog( &TextBuffer[0] );
				break;
			}
			if ( Length >= ( *FileBufferLength ) )
			{
				sprintf( &TextBuffer[0], " %s - .  %d ,   ", FileName, Length );
				strcat( &TextBuffer[0], CRLF );
				PutStringInTextLog( &TextBuffer[0] );
				break;
			}
			continue;
		}

		sprintf( &TextBuffer[0], " %s -   %d  TFTP -   .", FileName, Type );
		strcat( &TextBuffer[0], CRLF );
		PutStringInTextLog( &TextBuffer[0] );
		break;
	}

	FreeMemory( TFTPRequestPtr );
	FreeMemory( TFTPAnswerPtr );

	Retcode = 0;

quit_proc:
	return Retcode;
}

WORD PutTFTPFile( sockaddr_in *AddrOut, char * FileName, BYTEPTR FileBuffer, DWORD FileLength )
{
WORD Retcode;
WORD Type;
WORD ErrorCode;
WORD RequestLength;
WORD AnswerLength;
DWORD Length;
WORD BlockCounterPacket;
WORD BlockCounter;
struct TFTP_REQUEST_STRUCT *TFTPRequestPtr;
struct TFTP_ANSWER_STRUCT *TFTPAnswerPtr;
sockaddr_in AddrIn;


	TFTPRequestPtr = ( struct TFTP_REQUEST_STRUCT * ) AllocateMemory( 516 );
	TFTPAnswerPtr = ( struct TFTP_ANSWER_STRUCT * ) AllocateMemory( 516 );

	if ( TFTPRequestPtr == NULL || TFTPAnswerPtr == NULL )
	{
		Retcode = 1;
		FreeMemory( TFTPRequestPtr );
		FreeMemory( TFTPAnswerPtr );
		goto quit_proc;
	}
	
	Length = 0;
	BlockCounter = 0;

	//     
	TFTPRequestPtr->Type = htons( TFTP_WRITE_REQUEST );
	RequestLength = 2;
	strcpy( ( char * ) &TFTPRequestPtr->Data[0], FileName );
	RequestLength += ( strlen( ( char * ) &TFTPRequestPtr->Data[0] ) + 1 );
	strcpy( ( char * ) &TFTPRequestPtr->Data[strlen( ( char * ) &TFTPRequestPtr->Data[0] )+1], "octet" );
	RequestLength += 6;
	SendUDPDatagram( Socket, ( BYTEPTR ) TFTPRequestPtr, RequestLength, AddrOut );

	AddrIn = *AddrOut;
	AddrIn.sin_port = 0;

	while ( 1 )
	{
		ReceiveUDPDatagram( Socket, &AddrIn, ( BYTEPTR ) TFTPAnswerPtr, &AnswerLength );
		
		Type = ntohs( TFTPAnswerPtr->Type );
		if ( Type == TFTP_ERROR )
		{
			ErrorCode = ntohs( TFTPAnswerPtr->ErrorCode );
			strcpy( &TextBuffer[0], ( char * ) &TFTPAnswerPtr->Data[0] );
			sprintf( &TextBuffer[0], " %s - %s", FileName, ( char * ) &TFTPAnswerPtr->Data[0] );
			strcat( &TextBuffer[0], CRLF );
			sprintf( &TextBuffer[0], "  = %d", BlockCounter );
			strcat( &TextBuffer[0], CRLF );
			PutStringInTextLog( &TextBuffer[0] );
			Retcode = 2;
			break;
		}

		if ( Type == TFTP_ACKNOWLEDGMENT )
		{
			if ( Length >= FileLength )
			{
				sprintf( &TextBuffer[0], " %s - .  %d ", FileName, Length );
				strcat( &TextBuffer[0], CRLF );
				PutStringInTextLog( &TextBuffer[0] );
				if ( Length == FileLength )
				{
					RequestLength = 0;
					TFTPRequestPtr->Type = htons( TFTP_DATA );
					BlockCounter += 1;
					* ( WORDPTR ) &TFTPRequestPtr->Data[0] = htons( BlockCounter );
					RequestLength += 4;
					SendUDPDatagram( Socket, ( BYTEPTR ) TFTPRequestPtr, RequestLength, AddrOut );
					ReceiveUDPDatagram( Socket, &AddrIn, ( BYTEPTR ) TFTPAnswerPtr, &AnswerLength );
				}
				break;
			}

			BlockCounterPacket = ntohs( TFTPAnswerPtr->ErrorCode );
			if ( BlockCounter == BlockCounterPacket )
			{
				if ( ( FileLength - Length ) > 512 )
					RequestLength = 512;
				else
					RequestLength = ( WORD ) ( FileLength - Length );
				memcpy( &TFTPRequestPtr->Data[2], &FileBuffer[Length], RequestLength );
				Length += RequestLength;
				BlockCounter += 1;
			}
			*AddrOut = AddrIn;
			TFTPRequestPtr->Type = htons( TFTP_DATA );
			* ( WORDPTR ) &TFTPRequestPtr->Data[0] = htons( BlockCounter );
			RequestLength += 4;
			SendUDPDatagram( Socket, ( BYTEPTR ) TFTPRequestPtr, RequestLength, AddrOut );
			continue;
		}

		break;
	}

	FreeMemory( TFTPRequestPtr );
	FreeMemory( TFTPAnswerPtr );

	Retcode = 0;

quit_proc:
	return Retcode;
}


LPTSTR *GetFileList( LPTSTR Path, DWORD * FileNumberPtr )
{
DWORD i;
DWORD k;
DWORD l;
LPTSTR *FileNames;
LPTSTR NamePtr;
WIN32_FIND_DATA FindData;
HANDLE hFile;

	*FileNumberPtr = 0;
	FileNames = ( LPTSTR * ) AllocateMemory( 500 * sizeof( LPTSTR ) );
	if ( FileNames == NULL )
		goto quit_proc;

	hFile = FindFirstFile( Path, &FindData );
	if ( hFile == INVALID_HANDLE_VALUE )
	{
		FreeMemory( FileNames );
		goto quit_proc;
	}
	
	i = ( DWORD ) wcslen ( FindData.cFileName );
	FileNames[*FileNumberPtr] = ( LPTSTR ) AllocateMemory( ( i + 1 ) * sizeof( TCHAR ) );
	if ( FileNames[*FileNumberPtr] == NULL )
	{
		FreeMemory( FileNames );
		FindClose( hFile );
		goto quit_proc;
	}

	wcscpy( FileNames[*FileNumberPtr], FindData.cFileName );
	( *FileNumberPtr ) += 1;

	while ( 1 )
	{
		if ( FindNextFile( hFile, &FindData ) == FALSE )
			break;
	
		i = ( DWORD ) wcslen ( FindData.cFileName );
		FileNames[*FileNumberPtr] = ( LPTSTR ) AllocateMemory( ( i + 1 ) * sizeof( TCHAR ) );
		if ( FileNames[*FileNumberPtr] == NULL )
		{
			break;
		}
		wcscpy( FileNames[*FileNumberPtr], FindData.cFileName );
		( *FileNumberPtr ) += 1;
		if ( ( *FileNumberPtr ) == 500 )
			break;
	}

	FindClose( hFile );

	//     
	k = 0;
	while ( k < ( *FileNumberPtr ) )
	{
		l = k + 1;
		while( l < ( *FileNumberPtr ) )
		{
			if ( wcscmp( FileNames[k], FileNames[l]) > 0 )
			{
				NamePtr = FileNames[l];
				FileNames[l] = FileNames[k];
				FileNames[k] = NamePtr;
			}
			l++;
		}
		k++;
	}

quit_proc:
	return ( FileNames );
}


BOOL CheckTCPConnection( sockaddr * DestinationAddr )
{
BOOL Retcode;
SOCKET Socket;
sockaddr_in SourceAddr;
long arg;
fd_set rset, wset;
struct timeval tval;
DWORD ErrorCode;
WORD nsec = 1;

	//       PING 
	Socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
	if ( Socket == INVALID_SOCKET )
	{
		Retcode = TRUE;
		goto quit_proc;
	}
	SourceAddr.sin_family = AF_INET;
	SourceAddr.sin_port = htons( 0 );
	SourceAddr.sin_addr.S_un.S_addr = INADDR_ANY;
	memset( &SourceAddr.sin_zero, 0, 8 );
	//   "" .
	Retcode = BindSocket( Socket, ( struct sockaddr_in * ) &SourceAddr );
	if ( Retcode != 0 )
	{
		Retcode = TRUE;
		goto quit_proc;
	}	                                                         
	//    nonblocking 
	arg = 0x00000001; 
	Retcode = ioctlsocket( Socket, FIONBIO, ( u_long FAR* ) &arg );
	if ( Retcode != 0 )
	{
		Retcode = TRUE;
		goto quit_proc;
	}	                                                         
                                                                       
	ErrorCode = connect( Socket, ( sockaddr * ) DestinationAddr, sizeof ( struct sockaddr ) );
	if ( ErrorCode != 0 )
	{
		ErrorCode = GetLastError();
		if ( ErrorCode == WSAEWOULDBLOCK )
		{
			FD_ZERO( &rset );
			FD_SET( Socket, &rset );
			wset = rset;
			tval.tv_sec = 0;
			tval.tv_usec = 100000;

			ErrorCode = select( Socket+1, &rset, &wset, NULL, &tval );
			if ( ErrorCode == 0 )
			{
				// 
				Retcode = TRUE;
				goto quit_proc;
			}
			else if ( ErrorCode = SOCKET_ERROR )
			{
				ErrorCode = GetLastError();
			}
		}
		else
		{
			Retcode = TRUE;
			goto quit_proc;
		}
	}

	Retcode = FALSE;

quit_proc:
	if ( Socket != INVALID_SOCKET )
	{
		shutdown( Socket, SD_BOTH );
		closesocket( Socket );
	}

	return Retcode;
}


BOOL ConvertFromANSIToUnicode( char * ANSIBuffer, LPWSTR UnicodeBuffer )
{
	DWORD Length = strlen( ANSIBuffer ) + 1;
	if ( MultiByteToWideChar( CP_ACP, MB_ERR_INVALID_CHARS, ANSIBuffer, Length, UnicodeBuffer, Length ) == 0 )
	{
		return FALSE;
	}
	else return TRUE;
}

BOOL ConvertFromUnicodeToANSI( LPWSTR UnicodeBuffer, char * ANSIBuffer )
{
	DWORD Length = wcslen( UnicodeBuffer ) + 1;
	if ( WideCharToMultiByte( CP_ACP, WC_NO_BEST_FIT_CHARS, UnicodeBuffer, Length, ANSIBuffer, Length, NULL, NULL ) == 0 )
	{
		return FALSE;
	}
	else return TRUE;
}

