// DViewer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DViewer.h"
#include "DViewerDlg.h"
#include "ReadFramesDlg.h"
#include "ReadSettingsDlg.h"
#include "IPEditDlg.h"
#include "AboutDlg.h"
#include "FramePrint.h"
#include "defines.h"
#include "SelectLanguage.h"
#include ".\dviewer.h"

#pragma warning(disable : 4996)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SOCKET_TIMEOUT					300


extern LPTSTR ErrorText;
extern LPTSTR WarningText;
extern LPTSTR EmergencyExitText;
extern LPTSTR ErrorSocketOpenText;
extern LPTSTR ErrorSocketConfigText;
extern LPTSTR ErrorWinsockText;
extern LPTSTR szFrameFilter;
extern LPTSTR szSettingsFilter;


WORD Version;							//  ,  
LPTSTR VersionText = _T( "2.04" );

WORD LastVersion;
WORD Number;
HANDLE HeapHandle;
CDViewerDlg *MainDlg;
HACCEL hAccelTable;

TCHAR ErrorBuffer[256];
char TextBuffer[500];
TCHAR TextBufferUnicode[500];
DWORD BackColor; 
DWORD ForeColor;
DWORD GreenColor = RGB( 0, 255, 255 );
DWORD RedColor = RGB( 255, 0, 0 );
DWORD BlackColor = RGB( 0, 0, 0 ); 
DWORD WhiteColor = RGB( 255, 255, 255 );

char IPAddressSearchTable[2][20];
BYTE CurrentLanguage;

LPTSTR OutputWndClassName = _T( "Output" );
LPTSTR DialogWndClassName = _T( "Dialog" );

LPTSTR SettingsFilenameTable[2] = {
_T( "fds.sdb" ),
_T( "fdc.sdb"  )
};

TCHAR PortName[10];
DWORD BaudRate;		
BYTE ByteSize;							// Number of bits/byte, 4-8        
BYTE Parity;							// 0-4 = None, Odd, Even, Mark, Space    
BYTE StopBits;							// 0,1,2 = 1, 1.5, 2               
BOOL DTRControlFlag;
BOOL RTSControlFlag;
COMSTAT ComStat;
COMMTIMEOUTS CommTimeOuts;
HANDLE hComm;
OVERLAPPED osRead = {0};
OVERLAPPED osWrite = {0};
DCB dcb;
DWORD RemoteIPAddress;

TCHAR FramePath[MAX_PATH];
TCHAR SettingsPath[MAX_PATH];
TCHAR PEPsPath[MAX_PATH];
char CRLF[] = { 0x0d, 0x0a, 0x00 };

sockaddr_in Addr;
SOCKET Socket;

LPCTSTR ProgramName;
TCHAR ProgramExeName[50];
TCHAR ProgramCfgName[50];
TCHAR LogPath[MAX_PATH];
LPCTSTR CommandLine;
TCHAR ProgramPath[MAX_PATH];
TCHAR OutputBuffer[256];
LPTSTR ProgramFile;
BOOL StartFlag;
DWORD FramesFilesNumber;
DWORD FramesFilesCurrentNumber;
LPTSTR *FramesFilesNames;
BOOL SaveConfigurationFlag;
BOOL StartupSearchFlag;

/////////////////////////////////////////////////////////////////////////////
// CDViewerApp

BEGIN_MESSAGE_MAP( CDViewerApp, CWinApp )
	//{{AFX_MSG_MAP( CDViewerApp )
	ON_COMMAND( ID_EXIT, OnExit )
	ON_COMMAND( ID_FRAME_VIEW, OnFrameView )
	ON_COMMAND( ID_SETTINGS_VIEW, OnSettingsView )
	ON_COMMAND( ID_HELP, CWinApp::OnHelp )
	ON_COMMAND( ID_FRAME_READ, OnFrameRead )
	ON_COMMAND( ID_FRAME_EDIT, OnFrameEdit )
	ON_COMMAND( ID_IP_EDIT, OnIpEdit )
	ON_COMMAND( ID_SETTINGS_READ, OnSettingsRead )
	ON_COMMAND(ID_DEFAULT_SETTINGS_WRITE, OnDefaultSettingsWrite)
	ON_COMMAND(ID_SELECT_LANGUAGE, OnSelectLanguage)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_ABOUT_PROGRAM, OnAboutProgram)
	ON_COMMAND(ID_PRINT, OnPrint)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDViewerApp construction

CDViewerApp::CDViewerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDViewerApp object

CDViewerApp theApp;
GdiplusStartupInput gdiplusStartupInput; 
ULONG_PTR gdiplusToken; 

/////////////////////////////////////////////////////////////////////////////
// CDViewerApp initialization

BOOL CDViewerApp::InitInstance()
{
BOOL bRetcode;
DWORD i;
WNDCLASS wc;
MSG msg;
int Retcode;

	bRetcode = FALSE;
	StartFlag = FALSE;
	SaveConfigurationFlag = FALSE;
	StartupSearchFlag = FALSE;
	CurrentLanguage = 0;

	RemoteIPAddress = inet_addr( "192.168.0.100" );

	//    "".
	HeapHandle = HeapCreate( 0, 8000000L, 0 );

	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hbrBackground	= ( HBRUSH ) GetStockObject( GRAY_BRUSH );
	wc.hCursor			= NULL;
	wc.hIcon			= NULL;
	wc.hInstance		= theApp.m_hInstance;
	wc.lpfnWndProc		= DefWindowProc;
	wc.lpszClassName	= OutputWndClassName;
	wc.lpszMenuName		= NULL;
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE;

	bRetcode = RegisterClass( &wc );

	ProgramName = AfxGetAppName();
	wcscpy( &ProgramExeName[0], ProgramName );
	wcscat( &ProgramCfgName[0], _T( ".CFG" ) );
	CommandLine = GetCommandLine();
	GetFullPathName( ProgramExeName, MAX_PATH, &ProgramPath[0], &ProgramFile );

	for ( i=wcslen( &ProgramPath[0] );i>0;i-- )
	{
		if ( ProgramPath[i] == '\\' || i == 0 )
			break;
	}						
	ProgramPath[i+1] = 0;

	bRetcode = LoadConfiguration();
	if ( bRetcode == FALSE )
	{
		ExitProcess( 1 );
	}
	
	ChangeLanguage( CurrentLanguage );

	//  GDI+
	GdiplusStartup( &gdiplusToken, &gdiplusStartupInput, NULL );

	//   UDP    TFTP
	if ( DoStartup() == FALSE )
	{
		Retcode = 1001;
		wsprintf( &TextBufferUnicode[0], ErrorWinsockText, EmergencyExitText, Retcode );
		MessageBox( NULL, &TextBufferUnicode[0], ErrorText, MB_OK );
		ConvertFromUnicodeToANSI( &TextBufferUnicode[0], &TextBuffer[0] );
		PutStringInTextLog( &TextBuffer[0] );
		ExitProcess( Retcode );
	}

	//       UDP 
	Retcode = OpenSocketUDP( &Socket );
	if ( Retcode != 0 )
	{
		Retcode = 1002;
		wsprintf( &TextBufferUnicode[0], ErrorSocketOpenText, "UDP", EmergencyExitText, Retcode );
		MessageBox( NULL, &TextBufferUnicode[0], ErrorText, MB_OK );
		ConvertFromUnicodeToANSI( &TextBufferUnicode[0], &TextBuffer[0] );
		PutStringInTextLog( &TextBuffer[0] );
		ExitProcess( Retcode );
	}
	Addr.sin_family = AF_INET;
	Addr.sin_port = htons( 0 );
	Addr.sin_addr.S_un.S_addr = INADDR_ANY;
	memset( &Addr.sin_addr, 0, 4 );
	memset( &Addr.sin_zero, 0, 8 );
	//   "" .
	Retcode = BindSocket( Socket, ( struct sockaddr_in * ) &Addr );
	Retcode |= BoolSocketSetOpt( Socket, SOL_SOCKET, SO_RCVTIMEO, SOCKET_TIMEOUT );
	if ( Retcode != 0 )
	{
		Retcode = 1003;
		wsprintf( &TextBufferUnicode[0], ErrorSocketOpenText, "UDP", EmergencyExitText, Retcode );
		MessageBox( NULL, &TextBufferUnicode[0], ErrorText, MB_OK );
		ConvertFromUnicodeToANSI( &TextBufferUnicode[0], &TextBuffer[0] );
		PutStringInTextLog( &TextBuffer[0] );
		ExitProcess( Retcode );
	}	                                                         
	Addr.sin_port = htons( 69 );
                               
	strcpy( &TextBuffer[0], CRLF );
	PutStringInTextLog( &TextBuffer[0] );
	strcpy( &TextBuffer[0], "Start DViewer" );
	strcat( &TextBuffer[0], CRLF );
	strcat( &TextBuffer[0], CRLF );
	PutStringInTextLog( &TextBuffer[0] );
	StartFlag = TRUE;

	hAccelTable = LoadAccelerators( theApp.m_hInstance, MAKEINTRESOURCE( IDR_ACCELERATOR ) );

	wcscpy( &TextBufferUnicode[0], &FramePath[0] );
	wcscat( &TextBufferUnicode[0], _T( "*.png" ) );
	FramesFilesNames = GetFileList( &TextBufferUnicode[0], &FramesFilesNumber );
	FramesFilesCurrentNumber = 0;

	CDViewerDlg dlg;
	m_pMainWnd = &dlg;
	MainDlg = &dlg;
	
	SetDialogBkColor( BackColor, ForeColor );
	
	//     
	dlg.Create( IDD_DVIEWER_DIALOG, NULL );
//	dlg.DoModal();

	while ( GetMessage( &msg, NULL, 0, 0 ) )
	{
		if ( !TranslateAccelerator( msg.hwnd, hAccelTable, &msg ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
												   
	return FALSE;
}

int CDViewerApp::ExitInstance()
{
	DoCleanup();

	if ( SaveConfigurationFlag == TRUE )
	{
		SaveConfigurationFlag = FALSE;
		SaveConfiguration();
	}

	strcpy( &TextBuffer[0], CRLF );
	PutStringInTextLog( &TextBuffer[0] );
	strcpy( &TextBuffer[0], "Stop DViewer" );
	strcat( &TextBuffer[0], CRLF );
	strcat( &TextBuffer[0], CRLF );
	PutStringInTextLog( &TextBuffer[0] );
	
	GdiplusShutdown( gdiplusToken );

	return CWinApp::ExitInstance();
}

void CDViewerApp::OnExit() 
{
	MainDlg->Mode = IDLE;
	MainDlg->ChangeMode();
	MainDlg->DestroyWindow();
}

void CDViewerApp::OnFrameView() 
{
CFile File;
CString Filename;
CFileDialog FrameOpenDlg( TRUE, _T( "PNG" ), NULL, OFN_HIDEREADONLY, &szFrameFilter[0], MainDlg );
DWORD i;

	FrameOpenDlg.m_ofn.lpstrInitialDir = &FramePath[0];
	FrameOpenDlg.m_ofn.Flags |= OFN_NONETWORKBUTTON;
	FrameOpenDlg.m_ofn.Flags |= OFN_HIDEREADONLY;
	FrameOpenDlg.m_ofn.Flags |= OFN_NOCHANGEDIR;
	FrameOpenDlg.m_ofn.Flags |= OFN_SHAREAWARE;

	if ( FrameOpenDlg.DoModal() == IDOK )
	{
		wcscpy( &MainDlg->FrameFilename[0], &FramePath[0] );
		wcscat( &MainDlg->FrameFilename[0], FrameOpenDlg.GetFileName() );
		for ( i=0;i<FramesFilesNumber;i++ )
		{
			wcscpy( &TextBufferUnicode[0], &FramePath[0] );
			wcscat( &TextBufferUnicode[0], FramesFilesNames[i] );
			if ( wcscmp( &MainDlg->FrameFilename[0], &TextBufferUnicode[0] ) == 0 )
				break;
		}
		if ( i != FramesFilesNumber )
		{
			FramesFilesCurrentNumber = i;
		}
		else
		{
			FramesFilesCurrentNumber = 0;
		}

		if ( FramesFilesNumber != 0 )
		{
			SendMessage( MainDlg->m_hWnd, WM_USER+1, FRAME_VIEW_MODE, NULL );
		}
	}

	return;
}

void CDViewerApp::OnSettingsView() 
{
CFile File;
CString Filename;
CFileDialog SettingsOpenDlg( TRUE, _T( "DAT" ), NULL, OFN_HIDEREADONLY, &szSettingsFilter[0], m_pMainWnd );

	SettingsOpenDlg.m_ofn.lpstrInitialDir = &SettingsPath[0];
	SettingsOpenDlg.m_ofn.Flags |= OFN_NONETWORKBUTTON;
	SettingsOpenDlg.m_ofn.Flags |= OFN_HIDEREADONLY;
	SettingsOpenDlg.m_ofn.Flags |= OFN_NOCHANGEDIR;
	SettingsOpenDlg.m_ofn.Flags |= OFN_SHAREAWARE;

	if ( SettingsOpenDlg.DoModal() == IDOK )
	{
		Filename = SettingsOpenDlg.GetPathName();
		if ( File.Open( Filename, CFile::modeRead | CFile::shareDenyNone, NULL ) == 0 )
		{
			wsprintf( &OutputBuffer[0], FileNotOpenText, Filename );
			AfxMessageBox( &OutputBuffer[0], MB_OK, 0 );
			goto quit_proc;
		}
//		File.Read( &MainDlg->Settings, sizeof( struct SETTINGS ) );
		File.Close();

		wcscpy( &MainDlg->SettingsFilename[0], SettingsOpenDlg.GetFileName() );
		MainDlg->Mode = 1;
		MainDlg->ChangeMode();

		MainDlg->Invalidate( TRUE );
	}

quit_proc:
	return;
}

void CDViewerApp::OnFrameRead()
{
DWORD i;

	CReadFramesDlg ReadFramesDlg;
	ReadFramesDlg.DoModal();

	for ( i=0;i<FramesFilesNumber;i++ )
	{
		FreeMemory( FramesFilesNames[i] );
	}
	FreeMemory( FramesFilesNames );

	wcscpy( &TextBufferUnicode[0], &FramePath[0] );
	wcscat( &TextBufferUnicode[0], _T( "*.png" ) );
	FramesFilesNames = GetFileList( &TextBufferUnicode[0], &FramesFilesNumber );
}

void CDViewerApp::OnFrameEdit()
{
CFile File;
CString Filename;
DWORD i;

	if ( MainDlg->Mode != FRAME_VIEW_MODE )
	{
		CFileDialog FrameOpenDlg( TRUE, _T( "PNG" ), NULL, OFN_HIDEREADONLY, &szFrameFilter[0], MainDlg );

		FrameOpenDlg.m_ofn.lpstrInitialDir = &FramePath[0];
		FrameOpenDlg.m_ofn.Flags |= OFN_NONETWORKBUTTON;
		FrameOpenDlg.m_ofn.Flags |= OFN_HIDEREADONLY;
		FrameOpenDlg.m_ofn.Flags |= OFN_NOCHANGEDIR;
		FrameOpenDlg.m_ofn.Flags |= OFN_SHAREAWARE;

		if ( FrameOpenDlg.DoModal() == IDOK )
		{
/*			Filename = FrameOpenDlg.GetPathName();
			if ( File.Open( Filename, CFile::modeRead | CFile::shareDenyNone, NULL ) == 0 )
			{
				wsprintf( &OutputBuffer[0], FileNotOpenText, Filename );
				AfxMessageBox( &OutputBuffer[0], MB_OK, 0 );
				goto quit_proc;
			}
			File.Read( &MainDlg->Image, sizeof( struct IMAGE ) );
			File.Close();
*/
			wcscpy( &MainDlg->FrameFilename[0], FrameOpenDlg.GetPathName() );
			for ( i=0;i<FramesFilesNumber;i++ )
			{
				wcscpy( &TextBufferUnicode[0], &FramePath[0] );
				wcscat( &TextBufferUnicode[0], FramesFilesNames[i] );
				if ( wcsicmp( &MainDlg->FrameFilename[0], &TextBufferUnicode[0] ) == 0 )
					break;
			}
			if ( i != FramesFilesNumber )
			{
				FramesFilesCurrentNumber = i;
			}
			else
			{
				FramesFilesCurrentNumber = 0;
			}

			if ( FramesFilesNumber != 0 )
			{
				SendMessage( MainDlg->m_hWnd, WM_USER+1, FRAME_VIEW_MODE, NULL );
			}
		}
	}
	else
	{
		SendMessage( MainDlg->m_hWnd, WM_USER+1, FRAME_EDIT_MODE, NULL );
	}                                                                    	

	return;
}

void CDViewerApp::OnIpEdit()
{
	CIPEditDlg IPEditDlg;
	IPEditDlg.DoModal();
}

void CDViewerApp::OnSettingsRead()
{
	CReadSettingsDlg ReadSettingsDlg;
	ReadSettingsDlg.DoModal();
}

void CDViewerApp::OnDefaultSettingsWrite()
{
WORD i;
char Filename[50];
DWORD FileBufferLength;
BYTEPTR FileBuffer;
CFile File;
char TempBuffer[20];

	if ( AfxMessageBox( WarningWriteDefaultSettingsText, MB_YESNO, 0 ) == IDYES )
	{
		* ( DWORDPTR ) &Addr.sin_addr = RemoteIPAddress;
		for ( i=0;i<2;i++ )
		{
			Addr.sin_port = htons( 69 );
			wsprintf( &TextBufferUnicode[0], _T( "Default\\%s" ), SettingsFilenameTable[i] );
			if ( File.Open( &TextBufferUnicode[0], CFile::modeRead | CFile::shareDenyNone, NULL ) != 0 )
			{
				FileBufferLength = ( DWORD ) File.GetLength();
				FileBuffer = ( BYTEPTR ) AllocateMemory( FileBufferLength );
				if ( FileBuffer != NULL )
				{
					ConvertFromUnicodeToANSI( SettingsFilenameTable[i], &TempBuffer[0] );
//					wsprintf( &Filename[0], "D:\\TFTPBoot\\%s", SettingsFilenameTable[i] );
//					sprintf( &Filename[0], "/mnt/%s", &TempBuffer[0] );
					sprintf( &Filename[0], "/%s", &TempBuffer[0] );
					TRY { File.Read( FileBuffer, FileBufferLength ); } CATCH( CFileException, e ) { ; } END_CATCH
					PutTFTPFile( &Addr, &Filename[0], FileBuffer, FileBufferLength );
					FreeMemory( FileBuffer );
				}
				File.Close();
			}
		}
	}
}

void CDViewerApp::OnSelectLanguage()
{
DWORD id;
CSelectLanguage SelectLanguageDlg;
RECT Rect;
CMenu *pSubMenu;
INT Retcode;

	if ( SelectLanguageDlg.DoModal() == IDOK )
	{
		//  
		wsprintf( &TextBufferUnicode[0], WindowHeaderText, VersionText );	
		MainDlg->SetWindowText( &TextBufferUnicode[0] );

		MainDlg->cNextText.SetWindowText( NextText );
		MainDlg->cPrevText.SetWindowText( PrevText );

		//  
		MainDlg->SetMenu( NULL );
		CMenu *pMenu = MainDlg->GetMenu();

		if ( pMenu != NULL )
			pMenu->DestroyMenu();
		else
			pMenu = new CMenu;

		switch ( CurrentLanguage )
		{
			case 0:
			pMenu->LoadMenu( IDR_MENU_RUS );
			break;
			
			case 1:
			pMenu->LoadMenu( IDR_MENU_ENG );
			break;

			case 2:
			pMenu->LoadMenu( IDR_MENU_TUR );
/*			id = pMenu->GetMenuItemID( 0 );
			pMenu->ModifyMenu( id, MF_BYCOMMAND, id, _T( "Gorunum" ) );
			pSubMenu = pMenu->GetSubMenu( 0 );
			id = pSubMenu->GetMenuItemID( 1 );
			Retcode = pSubMenu->ModifyMenu( 1, MF_BYPOSITION | MF_STRING, 0, _T( "Ekran Goruntusu" ) );
			MainDlg->DrawMenuBar();
*/			
			break;

			default:
			pMenu->LoadMenu( IDR_MENU_RUS );
			break;
		}
		
		MainDlg->SetMenu( pMenu );

		MainDlg->GetClientRect( &Rect );
		Rect.top = Rect.bottom - 20;
		Rect.left = 5;
		Rect.right = Rect.left + 300;
		MainDlg->InvalidateRect( &Rect, TRUE );

		SendMessage( MainDlg->m_hWnd, WM_USER+1, MainDlg->Mode, NULL );

		SaveConfigurationFlag = TRUE;
	}
}

void CDViewerApp::OnAboutProgram()
{
CAboutDlg AboutDlg;

	AboutDlg.DoModal();
}

void CDViewerApp::OnPrint()
{
	//   "   Print Dialog
	CFramePrint FramePrintDlg( FALSE ); 

	//    ,  
	//  ,   
	PRINTDLG pd; 

	//        NULL 
	//  ,       
	pd.hDevMode = NULL; 

	//      
	GetPrinterDeviceDefaults( &pd ); 

	//   pd.hDevMode    
	//   ,      
	//   ,     
	DEVMODE *dm = ( DEVMODE * ) LocalLock( pd.hDevMode ); 
	if ( dm != NULL )
	{
		//      DEVMODE 
		// ,      
		dm->dmFields = DM_ORIENTATION | DM_PAPERSIZE; 
		dm->dmOrientation = DMORIENT_LANDSCAPE; 
		dm->dmPaperSize = DMPAPER_A4; 

		//      DEVMODE 
		//   CPrintDialog 
		FramePrintDlg.m_pd.hDevMode = pd.hDevMode; 

		//       
		LocalUnlock( pd.hDevMode ); 

		if ( MainDlg->Mode == FRAME_VIEW_MODE || MainDlg->Mode == FRAME_EDIT_MODE )
		{
			//      
			if ( FramePrintDlg.DoModal() == IDOK )
			{
				FramePrintDlg.OnIDOK();
			}
		}
	}
	else
	{
		MessageBox( MainDlg->m_hWnd, PrinterNotInstalledText, WarningText, MB_OK );
	}
}
