// DViewer.h : main header file for the DVIEWER application
//

#if !defined(AFX_DVIEWER_H__87A499F6_579C_4342_BACD_E2ACA374B77F__INCLUDED_)
#define AFX_DVIEWER_H__87A499F6_579C_4342_BACD_E2ACA374B77F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CDViewerApp:// See DViewer.cpp for the implementation of this class
//

class CDViewerApp : public CWinApp
{
public:
	CDViewerApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL( CDViewerApp )
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG( CDViewerApp )
	afx_msg void OnExit();
	afx_msg void OnFrameView();
	afx_msg void OnSettingsView();
	afx_msg void OnFrameRead();
	afx_msg void OnFrameEdit();
	afx_msg void OnIpEdit();
	afx_msg void OnSettingsRead();
	afx_msg void OnDefaultSettingsWrite();
	afx_msg void OnSelectLanguage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	virtual int ExitInstance();
	afx_msg void OnAboutProgram();
	afx_msg void OnPrint();
};


#define HANDLEPTR		HANDLE *
#define VOIDPTR			void *
#define BYTEPTR			unsigned char *
#define CONSTCHARPTR	const char *
#define CHARPTR			signed char *
#define INTPTR			signed short *
#define WORDPTR			unsigned short *
#define DWORDPTR		unsigned long *
#define LONGPTR			signed long *
#define FLOATPTR		float *
#define DOUBLEPTR		double *
#define DOUBLE			double 
#define BYTE			unsigned char
#define INTEGER			signed short
#define BOOLPTR			BOOL *

#define PEP_NAME_MAX_SYMBOL	       	11

#define HCOOR_SHIFT					139
#define VCOOR_SHIFT					69

#define YCOOR_BEGIN								480
#define XCOOR_BEGIN								600

#define IDLE						0
#define FRAME_VIEW_MODE				2
#define FRAME_EDIT_MODE				3

#define TFTP_READ_REQUEST						1		//     (RRQ)
#define TFTP_WRITE_REQUEST						2		//     (WRQ)
#define TFTP_DATA								3		// ,   TFTP (DATA)
#define TFTP_ACKNOWLEDGMENT						4		//   (ACK)
#define TFTP_ERROR								5		//  (ERR)
#define TFTP_OPTIONS_ACKNOWLEDGMENT				6		//   (OACK)


struct TFTP_REQUEST_STRUCT {
WORD Type;
BYTE Data[512];
};

struct TFTP_ANSWER_STRUCT {
WORD Type;
WORD ErrorCode;
BYTE Data[512];
};


#define FILE_BUFFER_LENGTH	0x400

#define BLUE_ON_MAGENTA         0x31
#define BLUE_ON_LIGHTGRAY       0x81
#define BLUE_ON_YELLOW          0xE1
#define BLUE_ON_WHITE           0xF1
#define RED_ON_YELLOW           0xE4
#define DARKGRAY_ON_BLACK       0x08
#define DARKGRAY_ON_BLUE        0x18
#define GREEN_ON_BLACK          0x02
#define LIGHTGRAY_ON_BLUE       0x17
#define WHITE_ON_BLACK          0x0F
#define WHITE_ON_BLUE           0x1F
#define WHITE_ON_GREEN          0x2F
#define WHITE_ON_RED            0x4F
#define WHITE_ON_YELLOW         0xEF
#define YELLOW_ON_BLUE          0x1E
#define YELLOW_ON_RED           0x4E
#define YELLOW_ON_DARKGRAY      0x8E

//    .
#define DELAY						0		// 
#define UNROLLING					1		// 
#define CUT_OFF						2		// 
#define AMPLIFICATION				3		// 
#define ACCUMULATION				4		// 
#define SAVE						5		//  .  
#define VRCH_INCLINATION_CORRECTION	8		//   
#define ASD_TRESHOLD_CORRECTION		9		//   
#define ASD_ENDING_CORRECTION		10		//   
#define ASD_BEGINING_CORRECTION		11      //   
#define MEMORY						12		//    
#define LOAD						13		//  .  
#define SETTINGS_SELECTION 			16		//   
#define ROUGHNESS					17		// 
#define ASD2_CORRECTION				18		//   2
#define ASD1_CORRECTION				19		//   1
#define MENU						20		// 
#define RESET						21		// 
#define COMMENT						28		//  
#define CORRECTION_ROUGH_PLUS		40		//    ()
#define CORRECTION_ROUGH_MINUS		41		//    ()
#define CORRECTION_EXACT_PLUS		42		//    ()
#define CORRECTION_EXACT_MINUS		43		//    ()


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

LPVOID					AllocateMemory( UINT Size );
LPVOID					ReAllocateMemory( LPVOID Pointer, UINT Size );
UINT					SizeOfMemory( LPVOID Pointer );
BOOL					FreeMemory( LPVOID BufferPointer );

BYTEPTR					GetSectionData( BYTEPTR, char *, WORDPTR, WORD );
BOOL					GetVarNameValue( BYTEPTR, BYTEPTR, WORD, char * );
BOOL					LoadConfiguration( VOID );
BOOL					SaveConfiguration( VOID );
WORD					CheckVersion( WORDPTR, WORDPTR );
WORD					ControlSum( BYTEPTR, WORD );
WORD					PutStringInTextLog( char * );
DWORD					GetColorFromRGBBuffer( char * );

BOOL					DoStartup( void );
void					DoCleanup( void );
int 					OpenSocketUDP( SOCKET *s );
int 					BindSocket( SOCKET s, sockaddr_in * psa );
int 					SendUDPDatagram( SOCKET s, BYTEPTR pBuffer, WORD Length, struct sockaddr_in * psa );
int 					ReceiveUDPDatagram( SOCKET s, struct sockaddr_in *AddrIn, BYTEPTR pBuffer, WORD * PacketLength );
int 					IntSocketSetOpt( SOCKET s, WORD Protocol, WORD Optname, int optval );
int 					BoolSocketSetOpt( SOCKET s, WORD Protocol, WORD Optname, BOOL optval );

WORD					GetTFTPFile( sockaddr_in *Addr, char * FileName, BYTEPTR FileBuffer, DWORDPTR FileBufferLength );
WORD					PutTFTPFile( sockaddr_in *AddrOut, char * FileName, BYTEPTR FileBuffer, DWORD FileLength );
BOOL					CheckTCPConnection( sockaddr * DestinationAddr );

LPTSTR *				GetFileList( LPTSTR Path, DWORD * FileNumberPtr );

VOID					ChangeLanguage( BYTE Language );
BOOL					ConvertFromANSIToUnicode( char * ANSIBuffer, LPWSTR UnicodeBuffer );
BOOL					ConvertFromUnicodeToANSI( LPWSTR UnicodeBuffer, char * ANSIBuffer );


#endif // !defined(AFX_DVIEWER_H__87A499F6_579C_4342_BACD_E2ACA374B77F__INCLUDED_)
