// DViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DViewer.h"
#include "FramesWnd.h"
#include "MessageWnd.h"
#include "DViewerDlg.h"
#include ".\dviewerdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CDViewerApp theApp;
extern DWORD RemoteIPAddress;
extern LPTSTR OutputWndClassName;
extern LPTSTR DialogWndClassName;
extern TCHAR FramePath[];
extern TCHAR SettingsPath[];
extern TCHAR PEPsPath[];
extern TCHAR BASED_CODE szFrameFilter[];
extern TCHAR BASED_CODE szSettingsFilter[];
extern WORD Version;
extern WORD Number;
extern HACCEL hAccelTable;
extern DWORD BackColor; 
extern CDViewerDlg *MainDlg;
extern char CRLF[];
extern char IPAddressSearchTable[][20];
extern DWORD FramesFilesNumber;
extern DWORD FramesFilesCurrentNumber;
extern LPTSTR *FramesFilesNames;
extern BOOL SaveConfigurationFlag;

extern LPTSTR VersionText;
extern LPTSTR PrevText;
extern LPTSTR NextText;
extern LPTSTR ProductionText;
extern LPTSTR DateText;
extern LPTSTR DefectorText;
extern LPTSTR DefectCoorText;
extern LPTSTR NoticeText;
extern LPTSTR MMText;
extern LPTSTR AddCommentText;
extern LPTSTR OperatorCodeText;
extern LPTSTR ObjectText;
extern LPTSTR TypeText;
extern LPTSTR NumberText;
extern LPTSTR MaterialText;
extern LPTSTR DepthText;
extern LPTSTR OperatorConfinementText;
extern LPTSTR DefectTypeText;
extern LPTSTR AddInformationText;
extern LPTSTR SignatureText;
extern LPTSTR WindowHeaderText;
extern LPTSTR IPAddressText;
extern LPTSTR MessageText;
extern LPTSTR ReadDiapazonText;
extern LPTSTR CurrentIPAddressText;
extern LPTSTR FoundText;
extern LPTSTR NotFoundText;

extern char TextBuffer[];
extern TCHAR TextBufferUnicode[];

extern SOCKET PingSocket;

extern DWORD BackColor; 
extern DWORD ForeColor;
extern DWORD GreenColor; 
extern DWORD RedColor;
extern DWORD BlackColor; 
extern DWORD WhiteColor;

extern BOOL StartupSearchFlag;
extern BYTE CurrentLanguage;
extern BOOL SaveConfigurationFlag;


CFramesWnd FrameWnd;
BOOL ControlPressFlag = FALSE;
BOOL ShiftPressFlag = FALSE;
CFont DialogFont;
CFont DialogBoldFont;

/////////////////////////////////////////////////////////////////////////////
// CDViewerDlg dialog

CDViewerDlg::CDViewerDlg( CWnd* pParent /*=NULL*/ )	: CDialog( CDViewerDlg::IDD, pParent )
{
	//{{AFX_DATA_INIT( CDViewerDlg )
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	Mode = 0;
	LastMode = 0;

	EditTextLimitsTable[0] = 50;
	EditTextLimitsTable[1] = 30;
	EditTextLimitsTable[2] = 50;
	EditTextLimitsTable[3] = 10;
	EditTextLimitsTable[4] = 150;
	EditTextLimitsTable[5] = 20;
	EditTextLimitsTable[6] = 25;
	EditTextLimitsTable[7] = 25;
	EditTextLimitsTable[8] = 25;
	EditTextLimitsTable[9] = 25;
	EditTextLimitsTable[10] = 105;
	EditTextLimitsTable[11] = 105;

	RemoteConnectFlag = FALSE;

	m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );

}

void CDViewerDlg::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CDViewerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP( CDViewerDlg, CDialog )
	//{{AFX_MSG_MAP(CDViewerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_WM_CTLCOLOR()
//	ON_EN_CHANGE(IDC_EDIT_IZDELIE, OnEnChangeEditIzdelie)
//ON_WM_GETDLGCODE()
ON_WM_HSCROLL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDViewerDlg message handlers

int CDViewerDlg::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( CDialog ::OnCreate( lpCreateStruct) == -1 )
		return -1;
	
	Depth = 760;	//GetSystemMetrics( SM_CYSCREEN );
	Width = 1024;	//GetSystemMetrics( SM_CXSCREEN );
	SetWindowPos( NULL, 0, 0, Width, Depth, SWP_SHOWWINDOW );
	
	return 0;
}

BOOL CDViewerDlg::OnInitDialog()
{
WORD i;
RECT Rect;
DWORD SeachIPAddress;
DWORD EndIPAddress;
TCHAR TempBuffer[20];

	CDialog::OnInitDialog();

	DialogFont.CreateFont( 16, 8, 0, 0, FW_NORMAL, FALSE, FALSE, 0, RUSSIAN_CHARSET, 
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				FF_ROMAN | DEFAULT_PITCH, _T( "Courier New" ) );

	DialogBoldFont.CreateFont( 18, 8, 0, 0, FW_HEAVY, FALSE, FALSE, 0, RUSSIAN_CHARSET, 
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				FF_ROMAN | DEFAULT_PITCH, _T( "Courier New" ) );

	// Remove and destroy the old menu
	SetMenu( NULL );
	CMenu *pMenu = GetMenu();

	if ( pMenu != NULL )
		pMenu->DestroyMenu();
	else
		pMenu = new CMenu;

	switch ( CurrentLanguage )
	{
		case 0:
		pMenu->LoadMenu( IDR_MENU_RUS );
		break;
		
		case 1:
		pMenu->LoadMenu( IDR_MENU_ENG );
		break;

		case 2:
		pMenu->LoadMenu( IDR_MENU_TUR );
		break;

		default:
		pMenu->LoadMenu( IDR_MENU_RUS );
		break;
	}
	
	SetMenu( pMenu );

	SetFont( &DialogFont, TRUE );

	pBrush.CreateSolidBrush( BackColor );

	Mode = IDLE;

	EditIndex = 0;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_IZDELIE );
	EditRect[EditIndex].left = 150; 
	EditRect[EditIndex].top = YCOOR_BEGIN; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_DATE );
	EditRect[EditIndex].left = 150; 
	EditRect[EditIndex].top = YCOOR_BEGIN + 30; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_DEFECTOR );
	EditRect[EditIndex].left = 150; 
	EditRect[EditIndex].top = YCOOR_BEGIN + 60; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	//   ()
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_DEPTH );
	EditRect[EditIndex].left = 5 + wcslen( DefectCoorText ) * 9; 
	EditRect[EditIndex].top = YCOOR_BEGIN + 90; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_REMARK );
	EditRect[EditIndex].left = 150; 
	EditRect[EditIndex].top = YCOOR_BEGIN + 120; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] / 3 + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 18 * 3; EditIndex += 1;
	//  
	//  
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_OPERATOR_CODE );
	EditRect[EditIndex].left = XCOOR_BEGIN + 8 + wcslen( OperatorCodeText ) * 8; 
	EditRect[EditIndex].top = 60; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	if ( EditRect[EditIndex].right > ( XCOOR_BEGIN + 36 * 8 ) )
		EditRect[EditIndex].right = XCOOR_BEGIN + 36 * 8;
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_OBJECT_TYPE );
	EditRect[EditIndex].left = XCOOR_BEGIN + 10 + wcslen( TypeText ) * 8; 
	EditRect[EditIndex].top = 120; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	if ( EditRect[EditIndex].right > ( XCOOR_BEGIN + 36 * 8 ) )
		EditRect[EditIndex].right = XCOOR_BEGIN + 36 * 8;
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 					
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_OBJECT_NUMBER );
	EditRect[EditIndex].left = XCOOR_BEGIN + 10 + wcslen( NumberText ) * 8; 
	EditRect[EditIndex].top = 150; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	if ( EditRect[EditIndex].right > ( XCOOR_BEGIN + 36 * 8 ) )
		EditRect[EditIndex].right = XCOOR_BEGIN + 36 * 8;
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_OBJECT_MATERIAL );
	EditRect[EditIndex].left = XCOOR_BEGIN + 10 + wcslen( MaterialText ) * 8; 
	EditRect[EditIndex].top = 180; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	if ( EditRect[EditIndex].right > ( XCOOR_BEGIN + 36 * 8 ) )
		EditRect[EditIndex].right = XCOOR_BEGIN + 36 * 8;
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	// 
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_OBJECT_DEPTH );
	EditRect[EditIndex].left = XCOOR_BEGIN + 10 + wcslen( DepthText ) * 8; 
	EditRect[EditIndex].top = 210; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] + 1 ) * 8; 
	if ( EditRect[EditIndex].right > ( XCOOR_BEGIN + 36 * 8 ) )
		EditRect[EditIndex].right = XCOOR_BEGIN + 36 * 8;
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 20; EditIndex += 1;
	//  
	//  
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_DEFECT_TYPE );
	EditRect[EditIndex].left = XCOOR_BEGIN; 
	EditRect[EditIndex].top = 350; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] / 3 + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 18 * 3; EditIndex += 1;
	//  
	EditText[EditIndex] = ( CEdit * ) GetDlgItem( IDC_EDIT_ADD_INFO );
	EditRect[EditIndex].left = XCOOR_BEGIN; 
	EditRect[EditIndex].top = 470; 
	EditRect[EditIndex].right = EditRect[EditIndex].left + ( EditTextLimitsTable[EditIndex] / 3 + 1 ) * 8; 
	EditRect[EditIndex].bottom = EditRect[EditIndex].top + 18 * 3; EditIndex += 1;

	for ( i=NUMBER_OF_EDIT_BOX-1;;i-- )
	{
		EditText[i]->SetFont( &DialogFont, TRUE );
		EditText[i]->SetReadOnly( TRUE );
		EditText[i]->SetLimitText( EditTextLimitsTable[i] );
		EditText[i]->SetWindowPos( &wndTop, EditRect[i].left, EditRect[i].top, EditRect[i].right-EditRect[i].left, EditRect[i].bottom-EditRect[i].top, SWP_HIDEWINDOW );
		if ( i == 0 )
			break;
	}

	GetClientRect( &Rect );
	ScrollBar = ( CScrollBar * ) GetDlgItem( IDC_SCROLLBAR_VIEW_FRAMES );
	ScrollBar->SetWindowPos( &wndTop, Rect.right-78, Rect.top+5, 0, 0, SWP_HIDEWINDOW | SWP_NOSIZE );
	ScrollBar->SetScrollRange( 0, FramesFilesNumber, 0 );
	ScrollBar->SetScrollPos( FramesFilesCurrentNumber, 0 );
	
	GetClientRect( &Rect );
	Rect.left = Rect.right - 120; Rect.top = 5; Rect.right = Rect.left + ( wcslen( PrevText ) ) * 8; Rect.bottom = Rect.top + 16;
	cPrevText.Create( PrevText, WS_CHILD | WS_VISIBLE | SS_LEFT, Rect, this, -1 );
	cPrevText.ShowWindow( SW_HIDE );

	GetClientRect( &Rect );
	Rect.left = Rect.right - 40; Rect.top = 5; Rect.right = Rect.left + ( wcslen( NextText ) ) * 8; Rect.bottom = Rect.top + 16;
	cNextText.Create( NextText, WS_CHILD | WS_VISIBLE | SS_LEFT, Rect, this, -1 );
	cNextText.ShowWindow( SW_HIDE );
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon( m_hIcon, TRUE );			// Set big icon
	SetIcon( m_hIcon, FALSE );			// Set small icon
	
	wsprintf( &TextBufferUnicode[0], WindowHeaderText, VersionText );	
	SetWindowText( &TextBufferUnicode[0] );

	AddrOut.sin_family = AF_INET;
	AddrOut.sin_addr.S_un.S_addr = RemoteIPAddress;
	memset( &AddrOut.sin_zero[0], 0, 8 );
	AddrOut.sin_port = htons( 1533 );

	if ( StartupSearchFlag == TRUE )
	{
		GetClientRect( &Rect );
		Rect.top = Rect.bottom / 2 - 80;
		Rect.bottom = Rect.top + 160;
		Rect.left = Rect.right / 2 - 220;
		Rect.right = Rect.left + 440;
		MessageWindow.Create( OutputWndClassName, MessageText, WS_CHILD | WS_VISIBLE | WS_BORDER | WS_CAPTION, Rect, this, IDC_MESSAGE_WINDOW, 0 );

		//    ,   IP 
		SeachIPAddress = ( RemoteIPAddress & 0x00ffffff ) | 0x64000000;
		EndIPAddress = ( RemoteIPAddress & 0x00ffffff ) | 0xc7000000;
		AddrOut.sin_addr.S_un.S_addr = SeachIPAddress;
		strcpy( &IPAddressSearchTable[0][0], inet_ntoa( AddrOut.sin_addr ) );
		AddrOut.sin_addr.S_un.S_addr = EndIPAddress;
		strcpy( &IPAddressSearchTable[1][0], inet_ntoa( AddrOut.sin_addr ) );

		wsprintf( &TextBufferUnicode[0], ReadDiapazonText, &IPAddressSearchTable[0][0], &IPAddressSearchTable[1][0] );
		MessageWindow.SendMessage( WM_USER+1, ( WPARAM ) &TextBufferUnicode[0], 0 );

		while ( 1 )
		{
			wsprintf( &TextBufferUnicode[0], CurrentIPAddressText, inet_ntoa( AddrOut.sin_addr ) );
			MessageWindow.SendMessage( WM_USER+2, ( WPARAM ) &TextBufferUnicode[0], 0 );
			MessageWindow.UpdateWindow();

			AddrOut.sin_addr.S_un.S_addr = SeachIPAddress;

			if ( CheckTCPConnection( ( sockaddr * ) &AddrOut ) == FALSE )
			{
				SaveConfigurationFlag = TRUE;
				RemoteIPAddress = SeachIPAddress;
				ConvertFromANSIToUnicode( inet_ntoa( AddrOut.sin_addr ), &TempBuffer[0] );
				wsprintf( &TextBufferUnicode[0], CurrentIPAddressText, &TempBuffer[0] );
				wcscat( &TextBufferUnicode[0], FoundText );
				MessageWindow.SendMessage( WM_USER+2, ( WPARAM ) &TextBufferUnicode[0], 0 );
				MessageWindow.UpdateWindow();
				Sleep( 1000 );
				break;
			}
			if ( SeachIPAddress == EndIPAddress )
			{
				ConvertFromANSIToUnicode( inet_ntoa( AddrOut.sin_addr ), &TempBuffer[0] );
				wsprintf( &TextBufferUnicode[0], CurrentIPAddressText, &TempBuffer[0] );
				wcscat( &TextBufferUnicode[0], NotFoundText );
				MessageWindow.SendMessage( WM_USER+2, ( WPARAM ) &TextBufferUnicode[0], 0 );
				MessageWindow.UpdateWindow();
				Sleep( 1000 );
				break;
			}

			SeachIPAddress += 0x01000000;
		}

		MessageWindow.DestroyWindow();
	}

	ErrorCode = 0;
	if ( CheckTCPConnection( ( sockaddr * ) &AddrOut ) == FALSE )
	{
		RemoteConnectFlag = TRUE;
	}
	else
	{
		RemoteConnectFlag = FALSE;
	}

	TimerId = SetTimer( TimerId, 10000, 0 );

	return FALSE;
}


void CDViewerDlg::OnPaint() 
{
CRect Rect;
TCHAR TempBuffer[20];
char *TempBufferA;

	GetClientRect( &Rect );
	CPaintDC dc( this ); // device context for painting

	if ( IsIconic() )
	{
		SendMessage( WM_ICONERASEBKGND, ( WPARAM ) dc.GetSafeHdc(), 0 );

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics( SM_CXICON );
		int cyIcon = GetSystemMetrics( SM_CYICON );
		int x = ( Rect.Width() - cxIcon + 1 ) / 2;
		int y = ( Rect.Height() - cyIcon + 1 ) / 2;

		// Draw the icon
		dc.DrawIcon( x, y, m_hIcon );
	}
	else
	{
		switch( Mode )
		{
			case 0:
			break;

			case 1:
			ShowSettings();
			break;

			case 2:
			ShowFrameComments( &dc );
			break;
		}

		GetClientRect( &Rect );

		if ( RemoteConnectFlag == TRUE )
		{
			dc.SetBkColor( GreenColor );
			dc.SetTextColor( BlackColor );
		}
		else
		{
			dc.SetBkColor( RedColor );
			dc.SetTextColor( WhiteColor );
		}

		TempBufferA = inet_ntoa( AddrOut.sin_addr );
		ConvertFromANSIToUnicode( TempBufferA, &TempBuffer[0] );
		wsprintf( &TextBufferUnicode[0], _T( "%s = %s" ), IPAddressText, &TempBuffer[0] );
		dc.TextOut( Rect.left+5, Rect.bottom-20, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDViewerDlg::OnQueryDragIcon()
{
	return ( HCURSOR ) m_hIcon;
}


BOOL CDViewerDlg::PreCreateWindow( CREATESTRUCT& cs ) 
{
//	cs.lpszClass = DialogWndClassName;
	cs.x = 0;
	cs.y = 0;
	cs.cx = 1024;
	cs.cy = 768;
	return CDialog::PreCreateWindow( cs );
}


LRESULT CDViewerDlg::WindowProc( UINT message, WPARAM wParam, LPARAM lParam ) 
{
LRESULT Retcode;
RECT Rect;

	Retcode = 0;

	switch ( message )
	{
		case WM_COMMAND: 		
		switch ( wParam )
		{
			case IDOK:					// ENTER
			break;

			case IDCANCEL:				// ALT+F4  ESC
			if ( lParam == 0x00000000 )
			{
				Mode = IDLE;
				ChangeMode();
				Retcode = CDialog::WindowProc( message, wParam, lParam );
			}
			DestroyWindow();
			break;
		
			default:
			Retcode = CDialog::WindowProc( message, wParam, lParam );
			break;
		}
		break;
	
		case WM_TIMER:
		AddrOut.sin_port = htons( 1533 );
		AddrOut.sin_addr.S_un.S_addr = RemoteIPAddress;
		if ( CheckTCPConnection( ( sockaddr * ) &AddrOut ) == FALSE )
		{
			RemoteConnectFlag = TRUE;
		}
		else
		{
			RemoteConnectFlag = FALSE;
		}
		GetClientRect( &Rect );
		Rect.top = Rect.bottom - 20;
		Rect.left = 5;
		Rect.right = Rect.left + 300;
		InvalidateRect( &Rect, TRUE );
		break;


		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
		switch ( wParam )
		{
			case VK_CONTROL:
			ControlPressFlag = TRUE;
			break;
			
			case VK_SHIFT:
			ShiftPressFlag = TRUE;
			break;
			
			case VK_ESCAPE:
			DestroyWindow();
			break;

			default:
			Retcode = CDialog::WindowProc( message, wParam, lParam );
			break;
		}
		break;
		
//		case WM_CTLCOLOREDIT:
//		Retcode = ( LRESULT ) 0;
//		break;																	   

		case WM_CTLCOLORBTN:
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORLISTBOX:
		case WM_CTLCOLORSCROLLBAR:
		case WM_CTLCOLORSTATIC:
		SetBkColor( ( HDC ) wParam, BackColor );								   
		SetTextColor( ( HDC ) wParam, ForeColor );								   
		Retcode = ( LRESULT ) pBrush.m_hObject;
		break;																	   
																				   
		case WM_KEYUP:
		case WM_SYSKEYUP:
		switch ( wParam )
		{
			case VK_CONTROL:
			ControlPressFlag = FALSE;
			break;
			
			case VK_SHIFT:
			ShiftPressFlag = FALSE;
			break;

			default:
			Retcode = CDialog::WindowProc( message, wParam, lParam );
			break;
		}
		break;

		
		case WM_USER+1:
		Mode = ( BYTE ) wParam;
		ChangeMode();
		break;


		default:
		Retcode = CDialog::WindowProc( message, wParam, lParam );
		break;
	}

	return( Retcode );
}


void CDViewerDlg::WinHelp( DWORD dwData, UINT nCmd ) 
{
	// ,    "windows help"
	return;	
}


void CDViewerDlg::ChangeMode( void )
{
RECT Rect;
WORD i;
DWORD Style;
CFile File;

	switch( LastMode )
	{
		case 0:
		break;

		case 1:
		break;

		case FRAME_VIEW_MODE:
		FrameWnd.DestroyWindow();
		cHeaderText.DestroyWindow();
		for ( i=0;i<21;i++ )
		{
			StaticText[i].DestroyWindow();
		}
		for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
		{
			EditText[i]->ShowWindow( SW_HIDE  );
		}
		ScrollBar->ShowWindow( SW_HIDE ); 
		cPrevText.ShowWindow( SW_HIDE );
		cNextText.ShowWindow( SW_HIDE );
		break;

		case FRAME_EDIT_MODE:
		ConvertFromUnicodeToANSI( &MainDlg->FrameFilename[0], &TextBuffer[0] );
		i = strlen( &TextBuffer[0] );
		TextBuffer[i-3] = 'd';
		TextBuffer[i-2] = 'a';
		TextBuffer[i-1] = 't';
		ConvertFromANSIToUnicode( &TextBuffer[0], &TextBufferUnicode[0] );
		if ( File.Open( &TextBufferUnicode[0], CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone, 0 ) != 0 )
		{
			File.SetLength( 0 );
			for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
			{
				memset( &TextBufferUnicode[0], 0, 500 * sizeof( TCHAR ) );
				EditText[i]->GetWindowText( &TextBufferUnicode[0], 500 * sizeof( TCHAR ) );
				wcscat( &TextBufferUnicode[0], _T( "\r\n" ) );
				File.Write( &TextBufferUnicode[0], ( EditTextLimitsTable[i] + 2 ) * sizeof( TCHAR ) );
			}
			File.Close();
		}
		FrameWnd.DestroyWindow();
		cHeaderText.DestroyWindow();
		for ( i=0;i<21;i++ )
		{
			StaticText[i].DestroyWindow();
		}
		for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
		{
			EditText[i]->ShowWindow( SW_HIDE );
		}
		ScrollBar->ShowWindow( SW_HIDE ); 
		cPrevText.ShowWindow( SW_HIDE );
		cNextText.ShowWindow( SW_HIDE );
		break;

		default:
		goto quit_proc;
	}

	switch( Mode )
	{
		case IDLE:
		break;

		case 1:
		break;

		case FRAME_VIEW_MODE:
		case FRAME_EDIT_MODE:
		wcscpy( &TextBufferUnicode[0], &FramePath[0] );
		wcscat( &TextBufferUnicode[0], FramesFilesNames[FramesFilesCurrentNumber] );
		wcscpy( &MainDlg->FrameFilename[0], &TextBufferUnicode[0] );

		Rect.top = 30;
		Rect.left = 5;
		Rect.bottom = Rect.top + 491 - VCOOR_SHIFT;
		Rect.right = Rect.left + 656 - HCOOR_SHIFT;
		wcscpy( FrameWnd.Filename, &MainDlg->FrameFilename[0] );
		FrameWnd.Create( OutputWndClassName, NULL, WS_CHILD | WS_VISIBLE, Rect, this, 0, NULL );
		FrameWnd.ShowWindow( SW_SHOWNORMAL );
		FrameWnd.UpdateWindow();
  
		// static controls
		Style = WS_CHILD | WS_VISIBLE | SS_LEFT;
		Rect.left = 5; Rect.top = 5; Rect.right = Rect.left + wcslen( FrameWnd.Filename ) * 8; Rect.bottom = Rect.top + 16;
		cHeaderText.Create( FrameWnd.Filename, Style, Rect, this, -1 );
		Rect.left = 5; Rect.top = YCOOR_BEGIN; Rect.right = Rect.left + wcslen( ProductionText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[0].Create( ProductionText, Style, Rect, this, -1 );
		Rect.left = 5; Rect.top = YCOOR_BEGIN + 30; Rect.right = Rect.left + wcslen( DateText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[1].Create( DateText, Style, Rect, this, -1 );
		Rect.left = 5; Rect.top = YCOOR_BEGIN + 60; Rect.right = Rect.left + wcslen( DefectorText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[2].Create( DefectorText, Style, Rect, this, -1 );
		Rect.left = 5; Rect.top = YCOOR_BEGIN + 90; Rect.right = Rect.left + wcslen( DefectCoorText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[3].Create( DefectCoorText, Style, Rect, this, -1 );
		Rect.left = 5 + 110 + wcslen( DefectCoorText ) * 9; Rect.top = YCOOR_BEGIN + 90; Rect.right = Rect.left + wcslen( MMText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[4].Create( MMText, Style, Rect, this, -1 );
		Rect.left = 5; Rect.top = YCOOR_BEGIN + 120; Rect.right = Rect.left + wcslen( NoticeText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[5].Create( NoticeText, Style, Rect, this, -1 );
		//  
		Rect.left = XCOOR_BEGIN + 40; Rect.top = 30; Rect.right = Rect.left + wcslen( AddCommentText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[6].Create( AddCommentText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 60; Rect.right = Rect.left + wcslen( OperatorCodeText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[7].Create( OperatorCodeText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 90; Rect.right = Rect.left + wcslen( ObjectText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[8].Create( ObjectText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 120; Rect.right = Rect.left + wcslen( TypeText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[9].Create( TypeText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 150; Rect.right = Rect.left + wcslen( NumberText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[10].Create( NumberText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 180; Rect.right = Rect.left + wcslen( MaterialText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[11].Create( MaterialText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 210; Rect.right = Rect.left + wcslen( DepthText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[12].Create( DepthText, Style, Rect, this, -1 );
		//  
		Rect.left = XCOOR_BEGIN + 40; Rect.top = 290; Rect.right = Rect.left + wcslen( OperatorConfinementText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[13].Create( OperatorConfinementText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 320; Rect.right = Rect.left + wcslen( DefectTypeText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[14].Create( DefectTypeText, Style, Rect, this, -1 );
		Rect.left = XCOOR_BEGIN; Rect.top = 440; Rect.right = Rect.left + wcslen( AddInformationText ) * 8; Rect.bottom = Rect.top + 16;
		StaticText[15].Create( AddInformationText, Style, Rect, this, -1 );
		// 
		Rect.left = XCOOR_BEGIN + 40; Rect.top = 630; Rect.right = Rect.left + wcslen( SignatureText ) * 9; Rect.bottom = Rect.top + 16;
		StaticText[16].Create( SignatureText, Style, Rect, this, -1 );

		for ( i=0;i<NUMBER_OF_STATIC_TEXT;i++ )
		{
			if ( StaticText[i].m_hWnd != NULL )
				StaticText[i].SetFont( &DialogFont, TRUE );
		}

		StaticText[6].SetFont( &DialogBoldFont, TRUE );
		StaticText[13].SetFont( &DialogBoldFont, TRUE );
		StaticText[16].SetFont( &DialogBoldFont, TRUE );

		for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
		{
			EditText[i]->SetWindowText( NULL );
			EditText[i]->ShowWindow( SW_SHOWNORMAL ); 
			EditText[i]->ShowCaret();
			EditText[i]->SetReadOnly( TRUE );
		}

		cHeaderText.SetFont( &DialogFont, TRUE );
		cNextText.SetFont( &DialogFont, TRUE );
		cPrevText.SetFont( &DialogFont, TRUE );

		ScrollBar->ShowWindow( SW_SHOWNORMAL ); 
		ScrollBar->SetScrollPos( FramesFilesCurrentNumber );
		cPrevText.ShowWindow( SW_SHOWNORMAL );
		cNextText.ShowWindow( SW_SHOWNORMAL );
		
		//    		
		wcscpy( &TextBufferUnicode[0], &MainDlg->FrameFilename[0] );
		i = wcslen( &TextBufferUnicode[0] );
		TextBufferUnicode[i-3] = 'd';
		TextBufferUnicode[i-2] = 'a';
		TextBufferUnicode[i-1] = 't';
		if ( File.Open( &TextBufferUnicode[0], CFile::modeRead | CFile::shareDenyNone, 0 ) != 0 )
		{
			for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
			{
				File.Read( &TextBufferUnicode[0], ( EditTextLimitsTable[i] + 2 ) * sizeof( TCHAR ) );
				TextBufferUnicode[wcslen(&TextBufferUnicode[0])-2] = 0;
				EditText[i]->SetWindowText( &TextBufferUnicode[0] );
				EditText[i]->UpdateWindow();
			}
			File.Close();
		}
  
		if ( Mode == FRAME_EDIT_MODE )
		{
			for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
			{
				EditText[i]->SetReadOnly( FALSE );
				EditText[i]->UpdateWindow();
			}
			EditText[0]->SetFocus();
		}
		break;

		default:
		goto quit_proc;
	}
	
	LastMode = Mode;

quit_proc:
	return;
}


VOID CDViewerDlg::ShowSettings( VOID )
{
	;
}

VOID CDViewerDlg::ShowFrameComments( CPaintDC * pdc )
{
RECT Rect;

	GetClientRect( &Rect );
	pdc->SetBkColor( BackColor );
}


void CDViewerDlg::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
	if ( FramesFilesNumber != 0 )
	{
		if ( nSBCode == SB_LINELEFT )
		{
			if ( FramesFilesCurrentNumber > 0 )
			{
				FramesFilesCurrentNumber -= 1;
				pScrollBar->SetScrollPos( FramesFilesCurrentNumber );
				ChangeMode();
			}
		}
		else if ( nSBCode == SB_LINERIGHT )
		{
			if ( FramesFilesCurrentNumber < ( FramesFilesNumber - 1 ) )
			{
				FramesFilesCurrentNumber += 1;
				pScrollBar->SetScrollPos( FramesFilesCurrentNumber );
				ChangeMode();
			}
		}
	}
	CDialog::OnHScroll( nSBCode, nPos, pScrollBar );
}
