// FramePrint.cpp : implementation file
//

#include "stdafx.h"
#include "DViewer.h"
#include "DViewerDlg.h"
#include "defines.h"
#include "FramePrint.h"
#include ".\frameprint.h"


#define MULTYLPLIER				6


extern CDViewerApp theApp;
extern CDViewerDlg *MainDlg;
extern DWORD BlackColor;
extern TCHAR TextBufferUnicode[];


// CFramePrint

IMPLEMENT_DYNAMIC( CFramePrint, CPrintDialog )
CFramePrint::CFramePrint( BOOL bPrintSetupOnly, DWORD dwFlags, CWnd* pParentWnd ) : 
             CPrintDialog( bPrintSetupOnly, dwFlags, pParentWnd )
{
}

CFramePrint::~CFramePrint()
{
}


BEGIN_MESSAGE_MAP( CFramePrint, CPrintDialog )
END_MESSAGE_MAP()



// CFramePrint message handlers


int CFramePrint::OnIDOK()
{
int Retcode;
DWORD i;
CDC hDC;
DOCINFO DocInfo;
CPen MyPen;
DEVMODE *lpDevMode;
WORD NumberOfCopies;
WORD Orientation;
CFile File;
SIZE Size;
RECT Rect;

	//      .
	lpDevMode = GetDevMode();

	// :    ,     .
	if ( ( ( lpDevMode->dmFields & DM_COLOR ) == DM_COLOR && lpDevMode->dmColor != DMCOLOR_COLOR ) || ( lpDevMode->dmFields & DM_COLOR ) != DM_COLOR )
	{
		i = AfxMessageBox( PrintColorWarningText, MB_YESNO, 0 );
		if ( i == IDNO )
		{
			//   
			GlobalUnlock( lpDevMode );
			Retcode = 1;
			goto quit_proc;
		}
	}

	NumberOfCopies = lpDevMode->dmCopies;
	Orientation = lpDevMode->dmOrientation;
	//   
	GlobalUnlock( lpDevMode );

	hDC.m_hDC = GetPrinterDC();
	if ( hDC.m_hDC == NULL )
	{
		Retcode = 2;
		goto quit_proc;
	}

	//    (   ).
	hDC.SetMapMode( MM_TEXT );

	hDC.m_hAttribDC = hDC.m_hDC;
	
	//       .
	hDC.SetViewportExt( 0, 0 );
	Size.cx = 1024;
	Size.cy = 768;
	Size = hDC.ScaleViewportExt( 1, 7, 1, 7 );

	//      .
	DocInfo.cbSize = sizeof( DOCINFO );
	DocInfo.fwType = DI_APPBANDING;
	DocInfo.lpszDatatype = NULL;
	DocInfo.lpszDocName = &MainDlg->FrameFilename[0];
	DocInfo.lpszOutput = NULL;
	
	if ( hDC.StartDoc( &DocInfo ) == -1 )
	{
		Retcode = 3;
		hDC.DeleteDC();
		goto quit_proc;
	}  

cycle_print:
	if ( hDC.StartPage() < 0 )
	{
		Retcode = 4;
		hDC.AbortDoc();
		hDC.DeleteDC();
		goto quit_proc;
	}

	//   
	// 
	Rect.left = 5 * MULTYLPLIER; Rect.top = 5 * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], MainDlg->FrameFilename );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );

	// 
	{
	RectF SourceRect;
	RectF DestinationRect;
	Graphics g( hDC.m_hDC );
	USES_CONVERSION;
	Image bg( T2CW( &MainDlg->FrameFilename[0] ) );
	Unit unit;
	bg.GetBounds( &SourceRect, &unit );
	DestinationRect.X = 5;
	DestinationRect.Y = 20;
	DestinationRect.Width = SourceRect.Width + 5 - HCOOR_SHIFT;
	DestinationRect.Height = SourceRect.Height - VCOOR_SHIFT;
	g.DrawImage( &bg, DestinationRect, HCOOR_SHIFT, 0, SourceRect.Width-HCOOR_SHIFT, SourceRect.Height-VCOOR_SHIFT, UnitPixel );
	}

	// 
	Rect.left = 5 * MULTYLPLIER; Rect.top = YCOOR_BEGIN * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], ProductionText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = 5 * MULTYLPLIER; Rect.top = ( YCOOR_BEGIN + 30 ) * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], DateText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = 5 * MULTYLPLIER; Rect.top = ( YCOOR_BEGIN + 60 ) * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], DefectorText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = 5 * MULTYLPLIER; Rect.top = ( YCOOR_BEGIN + 90 )  * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], DefectCoorText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = ( 5 + 110 + wcslen( DefectCoorText ) * 9 ) * MULTYLPLIER; Rect.top = ( YCOOR_BEGIN + 90 ) * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], MMText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = 5 * MULTYLPLIER; Rect.top = ( YCOOR_BEGIN + 120 ) * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], NoticeText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	//  
	Rect.left = ( XCOOR_BEGIN + 40 ) * MULTYLPLIER; Rect.top = 30 * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], AddCommentText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 60 * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], OperatorCodeText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
    Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 90 * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], ObjectText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 120 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], TypeText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 150 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], NumberText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 180 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], MaterialText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 210 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], DepthText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	//  
	Rect.left = ( XCOOR_BEGIN + 40 ) * MULTYLPLIER; Rect.top = 290 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], OperatorConfinementText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 320 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], DefectTypeText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	Rect.left = XCOOR_BEGIN * MULTYLPLIER; Rect.top = 440 * MULTYLPLIER;
    wcscpy( &TextBufferUnicode[0], AddInformationText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
	// 
	Rect.left = ( XCOOR_BEGIN + 40 ) * MULTYLPLIER; Rect.top = 630 * MULTYLPLIER;
	wcscpy( &TextBufferUnicode[0], SignatureText );
	hDC.TextOut( Rect.left, Rect.top, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );

	//  edit box'
	for ( i=0;i<NUMBER_OF_EDIT_BOX;i++ )
	{
		Rect = MainDlg->EditRect[i];
		Rect.left *= MULTYLPLIER;
		Rect.right *= MULTYLPLIER;
		Rect.top *= MULTYLPLIER;
		Rect.bottom *= MULTYLPLIER;
		hDC.MoveTo( Rect.left, Rect.top );
		hDC.LineTo( Rect.right, Rect.top );
		hDC.LineTo( Rect.right, Rect.bottom );
		hDC.LineTo( Rect.left, Rect.bottom );
		hDC.LineTo( Rect.left, Rect.top );
		MainDlg->EditText[i]->GetWindowText( &TextBufferUnicode[0], 500 );
		if ( i == 3 )
		{
			hDC.TextOut( Rect.right-wcslen( &TextBufferUnicode[0] )*54+6, Rect.top+6, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
		}
		else
		{
			hDC.TextOut( Rect.left+6, Rect.top+6, &TextBufferUnicode[0], wcslen( &TextBufferUnicode[0] ) );
		}
	}

	if ( hDC.EndPage() < 0 )
	{
		Retcode = 5;
		hDC.AbortDoc();
		hDC.DeleteDC();
		goto quit_proc;
	}

	//     .
	NumberOfCopies--;
	if ( NumberOfCopies != 0 ) 
		goto cycle_print;
	
	if ( hDC.EndDoc() < 0 )
	{
		Retcode = 6;
		hDC.AbortDoc();
		hDC.DeleteDC();
		goto quit_proc;
	}

	hDC.DeleteDC();

	Retcode = 0;

quit_proc:
	return Retcode;
}
