// FramesWnd.cpp : implementation file
//

#include "stdafx.h"
#include "DViewer.h"
#include "FramesWnd.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CDViewerApp theApp;


COLORREF VRCHCurveColor;
COLORREF YellowColor;
COLORREF StrobColor;
CFont MyFont;

CPen StrobPen;
CPen GreenPen;
CPen YellowPen;
CBrush YellowBrush;
BOOLEAN OutputLockFlag;

/////////////////////////////////////////////////////////////////////////////
// CFramesWnd

CFramesWnd::CFramesWnd()
{
	MyFont.CreateFont( 14, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0, RUSSIAN_CHARSET, 
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				FF_ROMAN | DEFAULT_PITCH, _T( "Tahoma" ) );

	GreenPen.CreatePen( PS_SOLID, 0, VRCHCurveColor );
	YellowPen.CreatePen( PS_SOLID, 0, YellowColor );
	YellowBrush.CreateSolidBrush( YellowColor );

	OutputTimerID = 1;
}

CFramesWnd::~CFramesWnd()
{
}


BEGIN_MESSAGE_MAP( CFramesWnd, CWnd )
	//{{AFX_MSG_MAP(CFramesWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFramesWnd message handlers

int CFramesWnd::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( CWnd ::OnCreate( lpCreateStruct ) == -1 )
		return -1;

	FPSCounter = 0;
	FPSCounterFixed = FPSCounter;
	SetTimer( OutputTimerID, 1000, NULL );

	SetFont( &MyFont );

	return 0;
}




void CFramesWnd::OnPaint() 
{
RectF SourceRect;
RectF DestinationRect;

	CPaintDC dc( this );
	
	Graphics g( dc.m_hDC );

	USES_CONVERSION;
	
	Image bg( T2CW( Filename ) );
	Unit unit;
	bg.GetBounds( &SourceRect, &unit );
	DestinationRect.X = 5;
	DestinationRect.Y = 5;
	DestinationRect.Width = SourceRect.Width + 5 - HCOOR_SHIFT;
	DestinationRect.Height = SourceRect.Height - VCOOR_SHIFT;
	g.DrawImage( &bg, DestinationRect, HCOOR_SHIFT, 0, SourceRect.Width-HCOOR_SHIFT, SourceRect.Height-VCOOR_SHIFT, UnitPixel );
}


