// ReadFramesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DViewer.h"
#include "ReadFramesDlg.h"
#include ".\readframesdlg.h"


#define TFTP_FILE_BUFFER_LENGTH			50000L


extern sockaddr_in Addr;
extern DWORD RemoteIPAddress;
extern TCHAR FramePath[];
extern TCHAR TextBufferUnicode[];
extern LPTSTR ReadFramesHeaderText;
extern LPTSTR FrameText;
extern LPTSTR SelectAllFramesText;
extern LPTSTR CancelButtonText;
extern LPTSTR FrameNotFoundText;
extern LPTSTR LinkNotEstablishedText;
extern BOOL SaveConfigurationFlag;

// CReadFramesDlg dialog

IMPLEMENT_DYNAMIC( CReadFramesDlg, CDialog )
CReadFramesDlg::CReadFramesDlg( CWnd* pParent /*=NULL*/ ) : CDialog( CReadFramesDlg::IDD, pParent )
{
	MyFont.CreateFont( 16, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0, RUSSIAN_CHARSET, 
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				FF_ROMAN | DEFAULT_PITCH, _T( "DialogFont New" ) );
}

CReadFramesDlg::~CReadFramesDlg()
{
}

void CReadFramesDlg::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
}


BEGIN_MESSAGE_MAP( CReadFramesDlg, CDialog )
	ON_LBN_DBLCLK(IDC_LIST_FRAMES, OnLbnDblclkListFrames)
	ON_BN_CLICKED(IDC_CHECK_SELECT_ALL, OnBnClickedCheckSelectAll)
END_MESSAGE_MAP()


// CReadFramesDlg message handlers

BOOL CReadFramesDlg::OnInitDialog()
{
WORD i;
RECT Rect;

	CDialog::OnInitDialog();

	GetClientRect( &Rect );
	Rect.top += 5;
	Rect.left += 5;
	Rect.right -= 5;
	Rect.bottom -= 30;
//	Style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_HSCROLL | WS_BORDER | LBS_MULTICOLUMN | LBS_EXTENDEDSEL;
	FramesListBox = ( CListBox * ) GetDlgItem( IDC_LIST_FRAMES );
	for ( i=1;i<=100;i++ )
	{
		wsprintf( &TextBufferUnicode[0], _T( "%s %3.3d" ), FrameText, i );
		FramesListBox->AddString( &TextBufferUnicode[0] );
	}
	FramesListBox->SetColumnWidth( ( wcslen( &TextBufferUnicode[0] ) + 2 ) * 8 );
	FramesListBox->SetFont( &MyFont, 1 );

	SetWindowText( ReadFramesHeaderText );
	GetDlgItem( IDC_CHECK_SELECT_ALL )->SetWindowText( SelectAllFramesText );
	GetDlgItem( IDCANCEL )->SetWindowText( CancelButtonText );

	return TRUE;
}

void CReadFramesDlg::OnOK()
{
WORD Retcode;
WORD i;
WORD j;
WORD k;
RECT Rect;
DWORD Style;
BYTE SelectArray[100];
char Filename[100];
BYTEPTR FileBuffer;
DWORD FileBufferLength;
CFile File;
SYSTEMTIME Time;

	* ( DWORDPTR ) &Addr.sin_addr = RemoteIPAddress;

	k = 0;
	for ( i=1;i<=100;i++ )
	{
		if ( FramesListBox->GetSel( i - 1 ) != 0 )
		{
			SelectArray[k] = ( BYTE ) i;
			k += 1;
		}
	}

	FramesListBox->DestroyWindow();
	GetDlgItem( IDOK )->DestroyWindow();
	GetDlgItem( IDCANCEL )->DestroyWindow();
	GetDlgItem( IDC_CHECK_SELECT_ALL )->DestroyWindow();

	GetClientRect( &Rect );
	Rect.top += ( Rect.bottom - Rect.top ) / 2 - 70;
	Rect.left += ( Rect.right - Rect.left ) / 2 - 32;
	Rect.right = Rect.left + 8 * 20;
	Rect.bottom = Rect.top + 16;
	Style = WS_CHILD | WS_VISIBLE | SS_LEFT;
	Header.Create( NULL, Style, Rect, this, -1 );

	GetClientRect( &Rect );
	Rect.top += ( Rect.bottom - Rect.top ) / 2 - 40;
	Rect.left += 15;
	Rect.right -= 15;
	Rect.bottom = Rect.top + 40;
	Style = WS_CHILD | WS_VISIBLE | PBS_SMOOTH;
	OverallProgressBar.Create( Style, Rect, this, IDC_READ_FRAMES_OVERALL_PROGRESS_BAR );
	OverallProgressBar.SetRange( 0, 100 );
	OverallProgressBar.SetStep( 100 / k );
	OverallProgressBar.StepIt();
	OverallProgressBar.SetPos( 0 );

	Rect.top = Rect.bottom + 20;
	Rect.bottom = Rect.top + 40;
	Style = WS_CHILD | WS_VISIBLE | PBS_SMOOTH;
	CurrentProgressBar.Create( Style, Rect, this, IDC_READ_FRAMES_CURRENT_PROGRESS_BAR );
	CurrentProgressBar.SetRange( 0, 100 );
	CurrentProgressBar.SetStep( 10 );
	CurrentProgressBar.StepIt();
	CurrentProgressBar.SetPos( 0 );

	FileBuffer = ( BYTEPTR ) AllocateMemory( TFTP_FILE_BUFFER_LENGTH );
	FileBufferLength = TFTP_FILE_BUFFER_LENGTH;

	for ( i=0;i<k;i++ )
	{
		wsprintf( &TextBufferUnicode[0], _T( "%s %d" ), FrameText, SelectArray[i] );
		Header.SetWindowText( &TextBufferUnicode[0] );

		CurrentProgressBar.SetPos( 0 );
//		sprintf( &Filename[0], "/mnt/screenshots/%d.png", SelectArray[i] );
		sprintf( &Filename[0], "/screenshots/%d.png", SelectArray[i] );
		Addr.sin_port = htons( 69 );
		FileBufferLength = TFTP_FILE_BUFFER_LENGTH;
		Retcode = GetTFTPFile( &Addr, &Filename[0], FileBuffer, &FileBufferLength );
		if ( Retcode == 0 )
		{
			GetLocalTime( &Time );
			wsprintf( &TextBufferUnicode[0], _T( "%s%4.4d_%2.2d_%2.2d-%2.2d-%2.2d~%3.3d.png" ), &FramePath[0], Time.wYear, Time.wMonth, Time.wDay, Time.wHour, Time.wMinute, SelectArray[i] );
			File.Open( &TextBufferUnicode[0], CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone, NULL );
			TRY { File.Write( FileBuffer, FileBufferLength ); } CATCH( CFileException, e ) { ; } END_CATCH
			File.Close();

			for ( j=0;j<10;j++ )
			{
				CurrentProgressBar.StepIt();
				Sleep( 10 );
			}
			CurrentProgressBar.SetPos( 100 );
		}
		else if ( Retcode == 2 )
		{
			wsprintf( &TextBufferUnicode[0], _T( "%s %d - %s" ), FrameText, SelectArray[i], FrameNotFoundText );
			Header.SetWindowText( &TextBufferUnicode[0] );
			Sleep( 300 );
		}
		else if ( Retcode == 5 )
		{
			wsprintf( &TextBufferUnicode[0], _T( "%s %d - %s" ), FrameText, SelectArray[i], LinkNotEstablishedText );
			Header.SetWindowText( &TextBufferUnicode[0] );
			Sleep( 300 );
		}
		OverallProgressBar.StepIt();
	}

	FreeMemory( FileBuffer );

	Header.DestroyWindow();
	OverallProgressBar.SetPos( 100 );
	Sleep( 10 );

	CurrentProgressBar.DestroyWindow();
	OverallProgressBar.DestroyWindow();

	CDialog::OnOK();
}


BOOL CReadFramesDlg::OnChildNotify( UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult )
{
	// TODO: Add your specialized code here and/or call the base class

	return CDialog::OnChildNotify( message, wParam, lParam, pLResult );
}

void CReadFramesDlg::OnLbnDblclkListFrames()
{
	OnOK();	
}

void CReadFramesDlg::OnBnClickedCheckSelectAll()
{
	pButton = ( CButton * ) GetDlgItem( IDC_CHECK_SELECT_ALL );
	if ( pButton->GetCheck() == BST_CHECKED )
	{
		FramesListBox->SelItemRange( TRUE, 0, 99 );
	}
	else
	{
		FramesListBox->SelItemRange( FALSE, 0, 99 );
	}
}
