// ReadSettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DViewer.h"
#include "ReadSettingsDlg.h"
#include "defines.h"
#include ".\readsettingsdlg.h"


#define TFTP_FILE_SDB_BUFFER_LENGTH			5000000L


extern sockaddr_in Addr;
extern DWORD RemoteIPAddress;
extern TCHAR FramePath[];
extern TCHAR TextBufferUnicode[];
extern LPTSTR FileNotFoundText;
extern LPTSTR LinkErrorText;
extern BOOL SaveConfigurationFlag;
extern LPTSTR SettingsFilenameTable[];


// CReadSettingsDlg dialog

IMPLEMENT_DYNAMIC( CReadSettingsDlg, CDialog )
CReadSettingsDlg::CReadSettingsDlg( CWnd* pParent /*=NULL*/ ) : CDialog( CReadSettingsDlg::IDD, pParent )
{
	TimerId = 109;
}

CReadSettingsDlg::~CReadSettingsDlg()
{
}

void CReadSettingsDlg::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
}


BEGIN_MESSAGE_MAP( CReadSettingsDlg, CDialog )
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CReadSettingsDlg message handlers

BOOL CReadSettingsDlg::OnInitDialog()
{
RECT Rect;
DWORD Style;

	CDialog::OnInitDialog();

	* ( DWORDPTR ) &Addr.sin_addr = RemoteIPAddress;

	GetClientRect( &Rect );
	Rect.top += ( Rect.bottom - Rect.top ) / 2 - 70;
	Rect.left += ( Rect.right - Rect.left ) / 2 - 32;
	Rect.right = Rect.left + 8 * 20;
	Rect.bottom = Rect.top + 16;
	Style = WS_CHILD | WS_VISIBLE | SS_LEFT;
	Header.Create( NULL, Style, Rect, this, -1 );

	GetClientRect( &Rect );
	Rect.top += ( Rect.bottom - Rect.top ) / 2 - 40;
	Rect.left += 15;
	Rect.right -= 15;
	Rect.bottom = Rect.top + 40;
	Style = WS_CHILD | WS_VISIBLE | PBS_SMOOTH;
	OverallProgressBar.Create( Style, Rect, this, IDC_READ_SETTINGS_OVERALL_PROGRESS_BAR );
	OverallProgressBar.SetRange( 0, 100 );
	OverallProgressBar.SetStep( 100 / 2 );
	OverallProgressBar.StepIt();
	OverallProgressBar.SetPos( 0 );

	Rect.top = Rect.bottom + 20;
	Rect.bottom = Rect.top + 40;
	Style = WS_CHILD | WS_VISIBLE | PBS_SMOOTH;
	CurrentProgressBar.Create( Style, Rect, this, IDC_READ_SETTINGS_CURRENT_PROGRESS_BAR );
	CurrentProgressBar.SetRange( 0, 100 );
	CurrentProgressBar.SetStep( 10 );
	CurrentProgressBar.StepIt();
	CurrentProgressBar.SetPos( 0 );

	TimerId = SetTimer( TimerId, 500, NULL );

	SetWindowText( ReadSettingsHeaderText );

	return TRUE;
}

void CReadSettingsDlg::OnTimer( UINT nIDEvent )
{
WORD Retcode;
WORD i;
WORD j;
char Filename[MAX_PATH];
BYTEPTR FileBuffer;
DWORD FileBufferLength;
CFile File;
char TempBuffer[20];

	KillTimer( TimerId );

	FileBuffer = ( BYTEPTR ) AllocateMemory( 5000000L );
	if ( FileBuffer == NULL )
	{
		Retcode = 1;
		goto quit_proc;
	}

	for ( i=0;i<2;i++ )
	{
		wsprintf( &TextBufferUnicode[0], _T( "%s" ), SettingsFilenameTable[i] );
		Header.SetWindowText( &TextBufferUnicode[0] );

		CurrentProgressBar.SetPos( 0 );
		ConvertFromUnicodeToANSI( SettingsFilenameTable[i], &TempBuffer[0] );
//		sprintf( &Filename[0], "/mnt/%s", &TempBuffer[0] );
		sprintf( &Filename[0], "%s", &TempBuffer[0] );
		Addr.sin_port = htons( 69 );
		FileBufferLength = TFTP_FILE_SDB_BUFFER_LENGTH;
		Retcode = GetTFTPFile( &Addr, &Filename[0], FileBuffer, &FileBufferLength );
		if ( Retcode == 0 )
		{
			wsprintf( &TextBufferUnicode[0], _T( "%s%s" ), FramePath, SettingsFilenameTable[i] );
			File.Open( &TextBufferUnicode[0], CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone, NULL );
			TRY { File.Write( FileBuffer, FileBufferLength ); } CATCH( CFileException, e ) { ; } END_CATCH
			File.Close();

			for ( j=0;j<10;j++ )
			{
				CurrentProgressBar.StepIt();
				Sleep( 10 );
			}
			CurrentProgressBar.SetPos( 100 );
		}
		else if ( Retcode == 2 )
		{
			wsprintf( &TextBufferUnicode[0], FileNotFoundText, SettingsFilenameTable[i] );
			Header.SetWindowText( &TextBufferUnicode[0] );
			Sleep( 300 );
		}
		else if ( Retcode == 5 )
		{
			wsprintf( &TextBufferUnicode[0], LinkErrorText, SettingsFilenameTable[i] );
			Header.SetWindowText( &TextBufferUnicode[0] );
			Sleep( 300 );
		}
		OverallProgressBar.StepIt();
		if ( Retcode != 0 )
		{
			AfxMessageBox( &TextBufferUnicode[0], MB_OK, 0 );
		}
	}

	FreeMemory( FileBuffer );

	Header.DestroyWindow();
	OverallProgressBar.SetPos( 100 );
	Sleep( 10 );

	CurrentProgressBar.DestroyWindow();
	OverallProgressBar.DestroyWindow();

	FreeMemory( FileBuffer );
	Retcode = 0;

quit_proc:
	EndDialog( Retcode );
	
	CDialog::OnTimer( nIDEvent );
}
