#include "stdafx.h"
#include "DViewer.h"
#include "detector502.h"
#include "output502.h"

TCHAR OutputBuffer[256];

BOOL UpdateSettingsInDSPFlag;
BOOL StartFlag;
BYTE TimeBuffer[10];
BYTE TimeMig;
BYTE Version[10];
BYTE MinUnrolling;
BYTE MaxUnrolling;
BYTE PObrLevel;
BYTE R12[250];
BYTE R32[250];
BYTE ARD[250];
BYTE DAC[250];

BYTE BlackColor;
BYTE BlueColor;
BYTE GreenColor;
BYTE MagentaColor;
BYTE RedColor;
BYTE VioletColor;
BYTE BrownColor;
BYTE LightGrayColor;
BYTE DarkGrayColor;
BYTE LightBlueColor;
BYTE LightGreenColor;
BYTE LightMagentaColor;
BYTE LightRedColor;
BYTE PurpleColor;
BYTE YellowColor;
BYTE WhiteColor;
BYTE DisplayBrightnessCodes[];

BOOL FirstStartFlag = TRUE;
BOOL SoundFlag = FALSE;
BOOL SoundType = 0;
BOOL RedrawFlag = FALSE;
BOOL LockOnFlag = FALSE;
BOOL LockMigFlag = FALSE;
BOOL LockMigFlagOld = FALSE;
BOOL RzMigFlag = FALSE;
BOOL SquareMigFlag = FALSE;
BOOL KNMigFlag = FALSE;
BOOL MemoryMigFlag = FALSE;
BOOL ChannelNumberMigFlag = FALSE;
BOOL SolidityMigFlag = FALSE;
BOOL SettingsMigFlag = FALSE;
BOOL ChangedSettingsFlag = FALSE;
BOOL Mig = FALSE;
BOOL MigOld = FALSE;

BYTE SolidityAmplifierKoeff[MAX_SOLIDITY_TYPES] = { 0, 24, 16, 8 };
BYTE Pallete[17] = { 0, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0 };
BYTE LeftArrowString[2] = { 0x1b, 0x00 };
BYTE RightArrowString[2] = { 0x1a, 0x00 };

LPTSTR FPSModeStrings[3] = { "", "" };
LPTSTR DisplayBrightnessStrings[4] = { "30%", "50%", "75%", "100%" };
LPTSTR ARDAmplifierString = "A=";
LPTSTR ARDString = "";
LPTSTR AmplificationLevelString = ".p.";
LPTSTR AmplifierString = "..";
LPTSTR ArticleString = ":";
LPTSTR ChannelString = "";
LPTSTR CommaString = ",";
LPTSTR CommentString = ".:";
LPTSTR ConfirmLoadSet1String = "\"+\"  \"-\" -    ";
LPTSTR ConfirmLoadSet2String = "\"\" - , \"\" - ";
LPTSTR CutString = "";
LPTSTR CutModeString = "";
LPTSTR KNString = "KN";
LPTSTR MarkerString = "";
LPTSTR SetString = ".";
LPTSTR DACString = "DAC";
LPTSTR DBString = "";
LPTSTR ShotNumberString = "N=";
LPTSTR DefectTypeString = "";
LPTSTR DegreeLetterString =  "";
LPTSTR DegreeString = "";
LPTSTR DelayString = "";
LPTSTR Digit0String = "0";
LPTSTR Digit1String = "1";
LPTSTR Digit2String = "2";
LPTSTR Digit3String = "3";
LPTSTR Digit4String = "4";
LPTSTR Digit5String = "5";
LPTSTR Digit6String = "6";
LPTSTR Digit7String = "7";
LPTSTR Digit8String = "8";
LPTSTR Digit9String = "9";
LPTSTR NoString = "";
LPTSTR EmissionPowerString = "";
LPTSTR SensorString = "";
LPTSTR EqualityString = "=";
LPTSTR ErrorCheckSumString = "  .";
LPTSTR ErrorLoadFrameString = "  ";
LPTSTR ErrorLoadSettingsString = "   ";
LPTSTR FPSString = "fps";
LPTSTR FrameNotFoundString = " ";
LPTSTR InnerResString = "R";
LPTSTR InnerResistorStrings[] = { "500", "50" };
LPTSTR InputAngleString = "";
LPTSTR KeybString = "-";
LPTSTR DiapazonWarningString1 = "   ";
LPTSTR ValueSEString = " SE";
LPTSTR Valueh1String = " h1";
LPTSTR ValueddCOString = " ddCO";
LPTSTR LockOnWarningString1 = "    - \"\"";
LPTSTR LockOnWarningString2 = "    -";
LPTSTR LockOnWarningString3 = "  ";
LPTSTR ManyModeWarningString1 = "  p p -";
LPTSTR ManyModeWarningString2 = " p.  \"\"";
LPTSTR ManyModeWarningString3 = " p  \"\"  ";
LPTSTR OneModeWarningString1 = "  p p -";
LPTSTR OneModeWarningString2 = " p.  \"\"";
LPTSTR OneModeWarningString3 = " p  \"\"  ";
LPTSTR LockString = "";
LPTSTR MCSString = "";
LPTSTR MCSUpperString = "";
LPTSTR MMString = "";
LPTSTR MMUpperString = "";
LPTSTR MPerSecondString = "/";
LPTSTR MeasuringUnitsString =  "..";
LPTSTR MeterInSecondString = "/c";
LPTSTR MigString = "";
LPTSTR Minus2String = "-2";
LPTSTR Minus32String = "-3/2";
LPTSTR MoreThen4HString = ">4H ";
LPTSTR NoFifoString = " fifo";
LPTSTR NullValueString = "0";
LPTSTR OmString = "";
LPTSTR OwewriteFrameString1 = "     ";
LPTSTR OwewriteFrameString2 = " ?";
LPTSTR OwewriteSettingsString1 = "    ";
LPTSTR OwewriteSettingsString2 = " ?";
LPTSTR UnrollingDisableString1 = "   ";
LPTSTR UnrollingDisableString2 = "   200 .";
LPTSTR UnrollingDisableString3 = "   .";
LPTSTR ErrorARDFileReadingString = "   ";
LPTSTR ErrorARDFileWritingString = "   ";
LPTSTR PixelString = "";
LPTSTR PowerMaxString = "Pmax";
LPTSTR PowerMinString = "Pmin";
LPTSTR PowerString = "P";
LPTSTR PObrsString = "-";
LPTSTR PowerStrings[] = { "MAX", "MIN" };
LPTSTR PressAnyKeyToContinueString = "    ";
LPTSTR RString = "R";
LPTSTR RXString = "RX";
LPTSTR RYString = "RY";
LPTSTR X_CString = "X-C";
LPTSTR XcString = "Xc";
LPTSTR RzString = "Rz";
LPTSTR RXcString = "RXc";
LPTSTR SaveFrameString = " ";
LPTSTR SaveSettingsString = "  ";
LPTSTR SensorNumberString = "N=";
LPTSTR SettingsNotFoundString = "     .";
LPTSTR SettingsNotFoundString1 = "  .";
LPTSTR SettingsNotFoundString2 = "   .";
LPTSTR SettingsNumberString = "N=";
LPTSTR SettingsOld;
LPTSTR SimilarString = "";
LPTSTR SoundString = "";
LPTSTR SpaceString = " ";
LPTSTR SpeedString = "V";
LPTSTR SquareString = "S=";
LPTSTR Strob1String = " 1";
LPTSTR Strob2String = " 2";
LPTSTR StrobBaseString =   "";
LPTSTR StrobLengthString = "";
LPTSTR StrobLevelString =  "";
LPTSTR StrobsString = "";
LPTSTR SuccessLoadFrameString = " ";
LPTSTR SuccessLoadSettingsString = "  ";
LPTSTR TestSettingsString = ".   ";
LPTSTR TimeString = "";
LPTSTR TurnOffString = "";
LPTSTR TurnOnString = "";
LPTSTR UnrollingStirngs[] = { "6,25", "12,5", "25", "50", "100", "200", "400", "800" };
LPTSTR UnrollingString = "";
LPTSTR UrollingCodeErrorString = "  ";
LPTSTR VRCHString = "";
LPTSTR VRCHStrings[] = { "R", "R", "", "DAC", "" };
LPTSTR WidthValueString = "H";
LPTSTR XString = "X";
LPTSTR YString = "Y";
LPTSTR YXString = "YX";
LPTSTR YesOrNoString = " - \"\",  - \"\"";
LPTSTR nString = "n";
LPTSTR DBNonDefinedString = " ?";
LPTSTR WrongChannelNumberString = "";
LPTSTR CalibrationString = "";
LPTSTR HandString = "";
LPTSTR DepthTypeString = "-";
LPTSTR DepthKoeffString = "-";
LPTSTR StrobTypeString = " ";
LPTSTR StrobTypeStrings[] = { "", "" };
LPTSTR ParamChangingString = "";
LPTSTR BottomString = "";
LPTSTR SelectionString = "";
LPTSTR ChooseString = "";
LPTSTR CancelString = "";
LPTSTR MeasureString = "";
LPTSTR EqualsProcherkString = "=---";
LPTSTR ProcherkString = "---";

WORD ConvertAToDBArray[201] = {
  0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  4,  5,  5,  6,  6,  7,
  7,  8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15,
 15, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 22, 22, 23, 23,
 24, 24, 25, 26, 26, 27, 27, 28, 29, 29, 30, 30, 31, 32, 32, 33,
 33, 34, 35, 35, 36, 37, 37, 38, 39, 39, 40, 41, 42, 42, 43, 44,
 44, 45, 46, 47, 47, 48, 49, 50, 50, 51, 52, 53, 54, 54, 55, 56,
 57, 58, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 67, 68, 69, 70,
 71, 72, 73, 74, 75, 76, 77, 79, 80, 81, 82, 83, 84, 85, 86, 88,
 89, 90, 91, 92, 94, 95, 96, 98, 99,100,102,103,105,106,108,109,
111,112,114,115,117,119,120,122,124,126,128,130,132,134,136,138,
140,142,144,146,149,151,154,157,159,162,165,168,171,174,177,181,
184,188,192,196,200,204,209,214,219,225,231,237,244,252,260,269,
280,291,305,320,340,365,400,460,460
};

WORD MaxDBValue1Old;
BYTE MaxDBRValue1Old;
WORD MaxDBValue2Old;
BYTE MaxDBRValue2Old;

WORD DBValue1Count;
WORD DBValue2Count;
WORD AngleXBegin;
WORD AngleYBegin;
WORD BeginXCoor;
WORD BeginYCoor;
WORD CosArray[91];
WORD DBValue1Middle;
WORD DBValue2Middle;
WORD DelayOld;
WORD Depth0Old;
WORD FifoIntNumber;
WORD FifoIrqNumber;
WORD FifoRefreshRateInTicks;
WORD FPSXCoor;
WORD FPSYCoor;
WORD GraphBeginXCoor;
WORD GraphBeginYCoor;
WORD LockXCoor;
WORD LockYCoor;
WORD MaxXRes;
WORD MaxYRes;
WORD Mmax;
WORD NumberOfModes;
WORD NumberOfSettings;
WORD OldOutputMode;
WORD OutputMode;             	//  .
WORD output_id;
WORD ROMPEPNumber;
WORD RzXCoor;
WORD RzYCoor;
WORD ChannelNumberYCoor;
WORD ChannelNumberXCoor;
WORD SolidityYCoor;
WORD SolidityXCoor;
WORD SensorXBegin;
WORD SensorYBegin;
WORD SettingsXCoor;
WORD SettingsYCoor;
WORD SinArray[91];
WORD SpeedXBegin;
WORD SpeedYBegin;
WORD SqXCoor;
WORD SqYCoor;
WORD Strob1XCoor;
WORD Strob1YCoor;
WORD Strob2XCoor;
WORD Strob2YCoor;
WORD TimerMigId;
WORD FPSTimerId;
WORD BottomSignalTimerId;
WORD WaitTaskOutputTimerId;
WORD TimerMigPeriod;
WORD TimeXCoor;
WORD TimeYCoor;
WORD AverageDepth;

struct DSP_DATA_STRUCT DSPDataStruct;


VOID SetPixel12( WORD, WORD, BYTE );
VOID OutChar( WORD, WORD, TCHAR, BYTE );
VOID FillChar( WORD, WORD, TCHAR, BYTE, BYTE );
VOID OutString( WORD, WORD, LPTSTR, BYTE );
VOID FillString( WORD, WORD, LPTSTR, BYTE, BYTE );
VOID OutChar7x9( WORD, WORD, TCHAR, BYTE );
VOID FillChar7x9( WORD, WORD, TCHAR, BYTE, BYTE );
VOID OutString7x9( WORD, WORD, LPTSTR, BYTE );
VOID FillString7x9( WORD, WORD, LPTSTR, BYTE, BYTE );
VOID OutChar12x21( WORD, WORD, TCHAR, BYTE );
VOID FillChar12x21( WORD, WORD, TCHAR, BYTE, BYTE );
VOID OutString12x21( WORD, WORD, LPTSTR, BYTE );
VOID FillString12x21( WORD, WORD, LPTSTR, BYTE, BYTE );
VOID ClearScreen( VOID );
VOID DrawVerticalLine12( WORD, WORD, WORD, BYTE );
VOID DrawHorizontalLine12( WORD, WORD, WORD, BYTE );
VOID ClearRectangle12( WORD, WORD, WORD, WORD );


VOID					CalcR12Curve( struct SETTINGS502 * );
VOID					CalcR32Curve( struct SETTINGS502 * );
VOID					CalcDACCurve( struct SETTINGS502 * );
VOID					CalcR12Koeff( struct SETTINGS502 * );
VOID					CalcR32Koeff( struct SETTINGS502 * );
VOID					CalcARDKoeff( struct SETTINGS502 * );
VOID					CalcDACKoeff( struct SETTINGS502 * );
VOID 					CalcR12Law( struct SETTINGS502 * );
VOID 					CalcR32Law( struct SETTINGS502 * );
VOID 					CalcDACLaw( struct SETTINGS502 * );
WORD 					GetMmaxAmplificationCode( struct SETTINGS502 * );
DWORD 					PixelsToDBMulty10( DWORD, WORD );
DWORD 					DBMulty10ToPixels( DWORD, WORD );
WORD 					PixelsToFifoBytes( WORD, struct SETTINGS502 * );
WORD 					FifoBytesToPixels( WORD, struct SETTINGS502 * );
VOID 					ConvertLawToVisualPoints( struct SETTINGS502 *, DWORDPTR, BYTEPTR );
WORD					ReadARDCurve( struct SETTINGS502 * );
VOID 					DrawVRCHCurves( struct SETTINGS502 * );
VOID 					ClearVRCHCurves( struct SETTINGS502 * );
VOID 					SelectVRCHCurves( struct SETTINGS502 * );
VOID					DrawEffectiveSquare( WORD );
VOID 					SetVRCHCurves( struct SETTINGS502 * );
VOID					SendVRCHLawToDSP( BYTE );
VOID 					UpdateSettingsOnDSP( struct SETTINGS502 * );
VOID 					UpdateMCSettingsOnDSP( BYTE );
VOID 					UpdateRzArrayOnDSP( BYTEPTR, BYTE );
VOID 					DrawZoomDevice( BYTE );
VOID 					ClearEffectiveSquare( VOID );

VOID 					CalcLineToPoints( struct POINTS_DATA *, BYTEPTR );
VOID 					CalcOctant0( WORD, WORD, WORD, WORD, INT, BYTEPTR );
VOID 					CalcOctant1( WORD, WORD, WORD, WORD, INT, BYTEPTR );
WORD 					CalcRzArray( BYTEPTR, struct SETTINGS502 * );
WORD 					CalcYCoorForDAC( WORD, WORD, WORD );
INT 					CheckBuffer( BYTEPTR, WORD );
INT             		CheckFileError( struct FILES * );
INT 					CheckFramePlace( BYTE );
WORD					CheckKey( VOID );
INT 					CheckSettingsPlace( BYTE );
VOID 					CheckSubSubModes( VOID );
WORD					ClearARDCurve( struct SETTINGS502 * );
VOID					ClearCut( struct SETTINGS502 * );
VOID 					ClearDACCurve( struct ARD_DATA * );
VOID 					ClearRectangle12( INT, INT, INT, INT );
VOID 					ClearStrobs( struct SETTINGS502 * );
VOID					ClearSubModes( VOID );
VOID					ClearSubSubModes( VOID );
VOID 					ClearSymbolMessage( VOID );
VOID 					DrawALMarker( struct SETTINGS502 *, BYTE );
VOID					DrawAmplifierKoeff( WORD );
VOID					DrawARDCurve( struct SETTINGS502 *, BYTE );
VOID 					DrawCrossHair( WORD, WORD, BYTE );
VOID 					DrawCrossHairWOLine( WORD, WORD, BYTE );
VOID 					DrawCurve( BYTEPTR , BYTE );
VOID					DrawCut( struct SETTINGS502 * );
VOID					DrawDACCurve( struct SETTINGS502 *, BYTE );
VOID 					DrawDefectHill( WORD, WORD, BYTE );
VOID 					DrawDepth0Level( struct SETTINGS502 * );
VOID 					DrawDepth1Level( struct SETTINGS502 * );
VOID 					DrawDepth2Level( struct SETTINGS502 * );
VOID 					DrawDepth3Level( struct SETTINGS502 * );
VOID 					DrawDynamicInfo( struct SETTINGS502 * );
VOID 					DrawE( BYTE );
VOID					DrawFrameNumber( WORD );
VOID					DrawGraphInBuffer( VOID );
VOID					DrawHorizontalCoor( struct SETTINGS502 * );
VOID					DrawInputAngle( struct SETTINGS502 * );
VOID					DrawLittleStrob( WORD, WORD, WORD );
VOID 					DrawMarkerLevel( WORD, struct SETTINGS502 *, BYTE );
VOID					DrawOnlyARDCurve( struct SETTINGS502 *, BYTE );
VOID					DrawOnlyDACCurve( struct SETTINGS502 *, BYTE );
VOID 					DrawOnlyDACCurve( struct SETTINGS502 *, BYTE );
VOID 					DrawPointToPointLine( INT, INT, INT, INT, BYTE );
VOID					DrawRz( struct SETTINGS502 * );
VOID					DrawSensor( struct SETTINGS502 * );
VOID 					DrawSpecialLetter( INT, INT, BYTEPTR, BYTE );
VOID 					DrawStaticInfo( struct SETTINGS502 * );
VOID 					DrawStrob( struct SETTINGS502 *, WORD, BYTE );
VOID 					DrawStrobs( struct SETTINGS502 * );
VOID					DrawUltrasonicSpeed( struct SETTINGS502 * );
VOID					ErrorSound( VOID );
VOID					ExchangeVariables( VOIDPTR, VOIDPTR );
WORD 					FifoBytesToRelativePixels( WORD, struct SETTINGS502 * );
WORD					FifoBytesToMCSMulty10( WORD );
LONG 					FifoBytesToMM( WORD, struct SETTINGS502 * );
LONG 					FifoBytesToMMMulty10( WORD, struct SETTINGS502 * );
WORD					FifoRead( struct SETTINGS502 * );
VOID					Format( BYTEPTR, BYTEPTR, WORD );
VOID 					FormatDivideBy10( BYTEPTR );
VOID 					FormatMCSMulty10ToMcs( BYTEPTR );
VOID 					FormatNullValue( BYTEPTR, WORD );
VOID 					FormatRValue( BYTEPTR, LONG );
VOID 					FormatXCValue( BYTEPTR, LONG );
VOID 					FormatWordDiv10( BYTEPTR, WORD );
VOID 					FormControlPort1( BOOL, struct SETTINGS502 * );
INT             		FreeAmxBuffer( BYTEPTR );
INT 					FreeMemory( VOIDPTR );
VOID            		FreeResource( WORD );
BYTEPTR         	 	GetAmxBuffer( INT );
WORD 					GetDACAmplificationCodes( struct SETTINGS502 *, BYTEPTR );
INT	    				GetPriorityMsg( WORD, struct AMXMSG * );
INT						GetResource( WORD );
BYTE 					GetUnrollingCode( BYTE );
BYTE 					GetUnrollingOrder( BYTE );
WORD					GetVarNameValue( BYTEPTR, BYTEPTR, WORD, BYTEPTR );
WORD 					GetWordDigit( BYTEPTR );
DWORD 					GetWorkTime( VOID );
LONG 					GetYCoor( struct SETTINGS502 *, LONG );
BYTE            		HIGHBYTE( WORD );
WORD					HighWord( DWORD );
VOID					InitDigitalOuputCounters( VOID );
VOID 					InitPallete( VOID );
VOID					InsByte( WORD, WORD, BYTEPTR );
VOID					InterruptInit( VOID );
VOID					InterruptRestore( VOID );
VOID					LittlePause( VOID );
INT						Load( VOID );
INT 					LoadFrameData( BYTE );
WORD 					LoadFromEPROM( DWORD, WORD, BYTEPTR );
VOID 					LoadSensor( struct SETTINGS502 *, BYTE );
VOID 					LoadSensorAngle( struct SETTINGS502 * );
VOID 					LoadSensorName( struct SETTINGS502 * );
VOID 					LoadVRCHArray( BYTEPTR Array );
BYTE            		LOWBYTE( WORD );
WORD					LowWord( DWORD );
LONG 					MCS10ToMM10( DWORD, struct SETTINGS502 * );
DWORD					MCSMulty10ToFifoBytes( WORD );
LONG 					MCSMulty10ToMM( WORD, struct SETTINGS502 * );
BYTEPTR					MK_FP( WORD , WORD );
DWORD 					MM10ToMCS10( LONG, struct SETTINGS502 * );
DWORD 					MMMulty10ToFifoBytes( LONG, struct SETTINGS502 * );
DWORD 					MMToFifoBytes( INT, struct SETTINGS502 * );
DWORD 					MMToMCSMulty10( INT, struct SETTINGS502 * );
DWORD 					MMToPixels( INT, struct SETTINGS502 * );
DWORD 					MMMulty10ToPixels( INT, struct SETTINGS502 * );
LONG 					MultyDivide( LONG, WORD, WORD );
WORD					Not( WORD );
WORD 					OppositeCalcYCoorForDAC( WORD, WORD, WORD );
VOID 					OutputStrobDBValue( struct SETTINGS502 *, WORD, WORD, WORD, WORD );
VOID					OutsByte( WORD, WORD, BYTEPTR );
DWORD					PixelsToMCSMulty10( WORD, struct SETTINGS502 * );
LONG 					PixelsToMM( WORD, struct SETTINGS502 * );
LONG 					PixelsToMMMulty10( WORD, struct SETTINGS502 * );
WORD 					RelativePixelToFifoBytes( WORD, struct SETTINGS502 * );
VOID					PrintExitMessage( WORD );
VOID					ProcessFifoBuffer( struct SETTINGS502 * );
VOID 					ProgramInit( WORD );
INT            			RemoveFile( BYTEPTR );
INT            			RenFile( BYTEPTR, BYTEPTR );
INT						Reset( VOID );
VOID 					ResetRadiusValue( WORD );
VOID 					RestorePallete( VOID );
VOID           			Ring( VOID );
INT						Save( VOID );
WORD 					SaveFrameData( WORD );
VOID 					SavePallete( VOID );
WORD 					SaveToEPROM( DWORD, WORD, BYTEPTR );
BYTEPTR         		Search( BYTEPTR, BYTEPTR, WORD, WORD );
INT             		SeekFile( struct FILES *, DWORD );
VOID 					SelectVideoModeOutput( VOID );
INT             		SendMsg( WORD, struct AMXMSG * );
INT             		SendPriorityMsg( WORD, WORD, struct AMXMSG * );
INT             		SendMsgAndWait( WORD , struct AMXMSG * );
WORD					SetR12Mode( VOID );
WORD					SetR32Mode( VOID );
WORD					SetARDMode( VOID );
WORD					SetDACMode( VOID );
VOID 					SetDataSmooth( BYTEPTR, BYTEPTR );
VOID 					SetTestSettings( WORD, struct SETTINGS502 * );
VOID 					SettingsInit( WORD );
INT						SettingTimeDate( void );
VOID 					SetWorkTime( DWORD );
VOID 					ShowDiagMessage( BYTEPTR, WORD );
VOID 					ShowPointer( INT, INT, BYTEPTR );
VOID 					ShowDword( INT, INT, DWORD );
VOID 					ShowFloat( INT, INT, FLOAT );
VOID 					ShowDouble( INT, INT, double );
VOID 					ShowDecimalWord( INT, INT, WORD );
VOID 					ShowDecimalByte( INT, INT, BYTE );
VOID 					ShowByte( INT, INT, BYTE );
VOID 					ShowDecimalDword( INT, INT, DWORD );
VOID 					ShowWord( INT, INT, WORD );
VOID 					ShowBuffer( BYTEPTR, WORD );
VOID 					Sound( VOID );
VOID 					SoundBeep( WORD, WORD );
VOID 					StrobDataInit( struct SETTINGS502 *, WORD );
VOID 					StrobsInit( struct SETTINGS502 * );
WORD            		swap( WORD );
VOID					ttproc( VOID );
VOID 					TurnOffAllIndication( VOID );
VOID					TurnOffOneLamp( WORD );
VOID					TurnOnOneLamp( WORD );
VOID 					UnrollingFormat( BYTE, BYTEPTR );
VOID					UpdateDynamicScreen( VOID );
VOID 					UpdateRadiusValue( WORD );
BYTE 					ZeroLevelCalc( struct SETTINGS502 * );
VOID 					ZeroSettingsInit( VOID );
VOID					SendCommandToDSP( BYTE, WORD, BYTEPTR );
WORD 					Sleep( VOID );
WORD 					Wait( WORD );
BOOL 					ReadPEP( BYTEPTR, WORD );
BOOL 					WritePEP( BYTEPTR, WORD );
VOID 					CheckChannelEnableFlag( struct SETTINGS502 * );
INT             		ReadFileAmx( struct FILES *, BYTEPTR, WORD );
INT             		WriteFileAmx( struct FILES *, BYTEPTR, WORD );
struct FILES *  		CreateFileAmx( BYTEPTR, WORD );
int             		CloseFileAmx( struct FILES * );
struct FILES *  		OpenFileAmx( BYTEPTR, WORD );
int             		ReadFileAmx( struct FILES *,char *, WORD );
WORD 					MakeDirAmx( BYTEPTR );
int             		RemoveFileAmx( BYTEPTR );
int             		RenFileAmx( BYTEPTR, BYTEPTR );
int             		SeekFileAmx( struct FILES *, DWORD );
VOID 					ConvertSettingsFromIndToGroup( struct SETTINGS502 * );
VOID 					CalcVRCHCurves( struct SETTINGS502 * );
WORD 					CalcARDCurve( struct SETTINGS502 *, WORD, WORD );
WORD 					CalcAndSetARDCurve( VOID );
BOOL 					DrawDigitalValuesEmul( struct DSP_DATA_STRUCT *, struct SETTINGS502 * );
VOID 					EnableDSPInterrupt( VOID );
VOID 					DisableDSPInterrupt( VOID );

BYTE GetLayer( VOID );
VOID SelectLayer( BYTE );


VOID OutputTaskInit( VOID )
{
	UpdateSettingsInDSPFlag = FALSE;

	DSPDataStruct.Length = sizeof( struct DSP_DATA_STRUCT );

	StartFlag = TRUE;


	WhiteColor = 1;

	BeginYCoor = 0;
	BeginXCoor = 0;
	MaxYRes = BeginYCoor + 239;
	MaxXRes = BeginXCoor + 319;
	GraphBeginXCoor = BeginXCoor + 15;
	GraphBeginYCoor = BeginYCoor + 25;
	SettingsYCoor = GraphBeginYCoor + 25;
	SettingsXCoor = MaxXRes - 48 + BeginXCoor;
	LockYCoor = SettingsYCoor + 14;
	LockXCoor = MaxXRes - 48 + BeginXCoor;
	AngleYBegin = LockYCoor + 14;
	AngleXBegin = MaxXRes - 48 + BeginXCoor;
	SpeedYBegin = AngleYBegin + 14;
	SpeedXBegin = MaxXRes - 48 + BeginXCoor;
	//      .
	RzYCoor = SpeedYBegin + 14;
	RzXCoor = MaxXRes - 48 + BeginXCoor;
	//      .  .
	SqYCoor = RzYCoor + 14;
	SqXCoor = MaxXRes - 48 + BeginXCoor;
	//      .
	ChannelNumberYCoor = SqYCoor + 30;
	ChannelNumberXCoor = MaxXRes - 48 + BeginXCoor;
	//      .
	SolidityYCoor = ChannelNumberYCoor + 12;
	SolidityXCoor = MaxXRes - 48 + BeginXCoor;
	//    FPS .
	FPSYCoor = 231;
	FPSXCoor = 205 + BeginXCoor;
	//   
	TimeYCoor = MaxYRes - 34 + BeginYCoor;
	TimeXCoor = MaxXRes - 48 + BeginXCoor;
	//  
	SensorYBegin = MaxYRes - 44 + BeginYCoor;
	SensorXBegin = MaxXRes - 48 + BeginXCoor;
	//     .
	Strob1YCoor = 0 + BeginYCoor;
	Strob1XCoor = 0 + BeginXCoor;
	Strob2YCoor = 0 + BeginYCoor;
	Strob2XCoor = 135 + BeginXCoor;
}


VOID DrawStaticInfo502( struct SETTINGS502 *Settings502 )
{
	ClearScreen();
	//    .
	DrawVerticalLine12( GraphBeginXCoor+1, GraphBeginYCoor, GraphBeginYCoor+200, WhiteColor );
	OutString7x9( 14+BeginYCoor, 0+BeginXCoor, DBString, WhiteColor );
	//    .
	DrawHorizontalLine12( GraphBeginYCoor+200, GraphBeginXCoor+1, GraphBeginXCoor+251, WhiteColor );
	if ( Settings502->DepthOutputType == 0 )
		OutString7x9( GraphBeginYCoor+200-4, GraphBeginXCoor+251+9, MMString, WhiteColor );
	else
		OutString7x9( GraphBeginYCoor+200-4, GraphBeginXCoor+251+9, MCSString, WhiteColor );
	//   
	OutChar( SettingsYCoor-2, SettingsXCoor+1, 'N', WhiteColor );
	OutChar7x9( SettingsYCoor+1, SettingsXCoor+19, '=', WhiteColor );
	OutString7x9( SettingsYCoor+1, SettingsXCoor+8, "", WhiteColor );
	OutString7x9( SettingsYCoor+1, SettingsXCoor+13, "", WhiteColor );
	//   .
	StrobsInit502( Settings502 );
	//     ,    .
	DrawLock( LockOnFlag );
	//      - "".
	OutString7x9( AngleYBegin+1, AngleXBegin+2, "=", WhiteColor );
	//     .
	OutString7x9( SpeedYBegin+1, SpeedXBegin+1, "V=", WhiteColor );

	DrawCoordinateGrid();
}


VOID DrawCoordinateGrid502( VOID )
{
WORD i,j;

	for ( i=0;i<4;i++ )
	{
		for ( j=0;j<26;j++ )
		{
			SetPixel12( GraphBeginYCoor+i*50, GraphBeginXCoor+1+j*10, WhiteColor );
		}
	}
	for ( i=0;i<21;i++ )
	{
		for ( j=0;j<6;j++ )
		{
			SetPixel12( GraphBeginYCoor+i*10, GraphBeginXCoor+1+j*50, WhiteColor );
		}
	}
}


VOID DrawStrob502( WORD ASDLevel, WORD ASDBase, WORD ASDLength, WORD Type, BYTE Color )
{
WORD i,j,k;

//	if ( CurrentSettings.OneStrobSubModeFlag == 1 && Type == 2 && Color == WhiteColor )
//		return;

	i = GraphBeginYCoor + 200 - ASDLevel;
	j = GraphBeginXCoor + 1 + ASDBase;
	k = j + ASDLength - 1;
	DrawHorizontalLine12( i, j, k, Color );

	switch ( Type )
	{
		case 1:
		DrawVerticalLine12( j, i, i+3, Color );
		DrawVerticalLine12( k, i, i+3, Color );
		break;

		case 2:
       		DrawVerticalLine12( j, i, i-3, Color );
       		DrawVerticalLine12( k, i, i-3, Color );
		break;

		default:
		break;
	}
}


VOID DrawStrobs502( struct SETTINGS502 *Settings502 )
{
BYTE LayerNumber;
WORD MarkerDepth;
WORD i;

	LayerNumber = ( BYTE ) GetLayer();
	SelectLayer( 1 );

	DrawStrob( ASD1LevelOld, ASD1BaseOld, ASD1LengthOld, 1, BlackColor );
	DrawStrob( ASD2LevelOld, ASD2BaseOld, ASD2LengthOld, 2, BlackColor );
	DrawStrob( PObrLevel, ASD2BaseOld, ASD2LengthOld, 2, BlackColor );
	DrawVerticalLine12( GraphBeginXCoor + 1 + ASD2BaseOld, GraphBeginYCoor + 200 - PObrLevel, GraphBeginYCoor + 200, BlackColor );
	DrawVerticalLine12( GraphBeginXCoor + ASD2BaseOld + ASD2LengthOld, GraphBeginYCoor + 200 - PObrLevel, GraphBeginYCoor + 200, BlackColor );

	if ( MarkerModeEnableFlag == TRUE && Settings502->MarkerModeFlag == TRUE )
	{
		DrawMarkerLevel( MarkerDepthOld, Settings502, BlackColor );
	}

	if ( Settings502->OneStrobSubModeFlag == 0 )
	{
		DrawStrob( Settings502->ASD1Level[Settings502->ChannelNumber], Settings502->ASD1Base[Settings502->ChannelNumber], Settings502->ASD1Length[Settings502->ChannelNumber], 1, WhiteColor );
		Settings502->ASD2Level[Settings502->ChannelNumber] = PObrLevel;
		DrawStrob( Settings502->ASD2Level[Settings502->ChannelNumber], Settings502->ASD2Base[Settings502->ChannelNumber], Settings502->ASD2Length[Settings502->ChannelNumber], 2, WhiteColor );
		DrawVerticalLine12( GraphBeginXCoor + 1 + Settings502->ASD2Base[Settings502->ChannelNumber], GraphBeginYCoor + 200 - Settings502->ASD2Level[Settings502->ChannelNumber], GraphBeginYCoor + 200, WhiteColor );
		DrawVerticalLine12( GraphBeginXCoor + Settings502->ASD2Base[Settings502->ChannelNumber] + Settings502->ASD2Length[Settings502->ChannelNumber], GraphBeginYCoor + 200 - Settings502->ASD2Level[Settings502->ChannelNumber], GraphBeginYCoor + 200, WhiteColor );
	}
	else if ( Settings502->OneStrobSubModeFlag == 1 )
	{
		DrawStrob( Settings502->ASD1Level[Settings502->ChannelNumber], Settings502->ASD1Base[Settings502->ChannelNumber], Settings502->ASD1Length[Settings502->ChannelNumber], 1, WhiteColor );
		if ( ManyChannelModeFlag == TRUE && ProgramModeFlag == AUTO_MODE )
		{
	      		DrawStrob( Settings502->ASD2Level[Settings502->ChannelNumber], Settings502->ASD2Base[Settings502->ChannelNumber], Settings502->ASD2Length[Settings502->ChannelNumber], 2, WhiteColor );
		}
	}
	else if ( Settings502->OneStrobSubModeFlag == 2 )
	{
      		DrawStrob( Settings502->ASD1Level[Settings502->ChannelNumber], Settings502->ASD1Base[Settings502->ChannelNumber], Settings502->ASD1Length[Settings502->ChannelNumber], 1, WhiteColor );
      		DrawStrob( Settings502->ASD2Level[Settings502->ChannelNumber], Settings502->ASD2Base[Settings502->ChannelNumber], Settings502->ASD2Length[Settings502->ChannelNumber], 2, WhiteColor );
	}

	if ( MarkerModeEnableFlag == TRUE && Settings502->MarkerModeFlag == TRUE )
	{
		DrawMarkerLevel( Settings502->MarkerDepth, Settings502, WhiteColor );
	}

	ASD1LevelOld = Settings502->ASD1Level[Settings502->ChannelNumber];
	ASD1BaseOld = Settings502->ASD1Base[Settings502->ChannelNumber];
	ASD1LengthOld = Settings502->ASD1Length[Settings502->ChannelNumber];
	ASD2LevelOld = Settings502->ASD2Level[Settings502->ChannelNumber];
	ASD2BaseOld = Settings502->ASD2Base[Settings502->ChannelNumber];
	ASD2LengthOld = Settings502->ASD2Length[Settings502->ChannelNumber];
	MarkerDepthOld = Settings502->MarkerDepth;

	SelectLayer( LayerNumber );
}

#define	FUNC_SUFFIX	502
#define	FUNC( NAME ) NAME##FUNC_SUFFIX

VOID FUNC( ClearStrobs )( struct SETTINGS502 *Settings502 )
{
BYTE LayerNumber;
WORD MarkerDepth;

	LayerNumber = ( BYTE ) GetLayer();
	SelectLayer( 1 );

	DrawStrob( ASD1LevelOld, ASD1BaseOld, ASD1LengthOld, 1, BlackColor );
	DrawStrob( ASD2LevelOld, ASD2BaseOld, ASD2LengthOld, 2, BlackColor );
	DrawStrob( PObrLevel, ASD2BaseOld, ASD2LengthOld, 2, BlackColor );
	DrawVerticalLine12( GraphBeginXCoor + 1 + ASD2BaseOld, GraphBeginYCoor + 200 - PObrLevel, GraphBeginYCoor + 200, BlackColor );
	DrawVerticalLine12( GraphBeginXCoor + ASD2BaseOld + ASD2LengthOld, GraphBeginYCoor + 200 - PObrLevel, GraphBeginYCoor + 200, BlackColor );

	if ( MarkerModeEnableFlag == TRUE && Settings502->MarkerModeFlag == TRUE )
	{
		DrawMarkerLevel( MarkerDepthOld, Settings502, BlackColor );
	}

	SelectLayer( LayerNumber );
}


VOID StrobsInit( struct SETTINGS502 *Settings502 )
{
BYTE StrobTypeOutput;
INT YCoor;
INT XCoor;
INT Offset;
WORD LayerNumber;

	LayerNumber = GetLayer();

	if ( Settings502->OneStrobSubModeFlag == 1 )
	{
		YCoor = Strob1YCoor;
		XCoor = Strob1XCoor;
		ClearRectangle12( Strob1YCoor, Strob1XCoor, Strob1YCoor+24, Strob1XCoor+263 );

		SelectLayer( 3 );

		if ( Settings502->MeasureModeFlag == 1 && ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE || Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE ) )
		{
			OutString12x21( YCoor, XCoor, "S", WhiteColor );
		}
		else
		{
			OutString12x21( YCoor, XCoor, "A", WhiteColor );
		}
		StrobTypeOutput = Settings502->Strob1TypeOutput[Settings502->ChannelNumber];
		RadiusValue1Old = 0xff;
		RadiusValue1Clear = 0xff;

		// .
		switch ( StrobTypeOutput )
		{
			case 0:
			OutString12x21( YCoor, XCoor+12*7+6, RString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			OutString12x21( YCoor, XCoor+12*14, YString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*15, '=', WhiteColor );
			Offset = 12 * 14;
			break;
			case 1:
			OutString12x21( YCoor, XCoor+12*7+6, RString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			OutString12x21( YCoor, XCoor+12*14, XString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*15, '=', WhiteColor );
			Offset = 12 * 14;
			break;
			case 2:
			OutString12x21( YCoor, XCoor+12*7+6, YString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			OutString12x21( YCoor, XCoor+12*14, XString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*15, '=', WhiteColor );
			Offset = 12 * 14;
			break;
			case 3:
			OutString12x21( YCoor, XCoor+12*7+6, RString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			Offset = 12 * 8;
			break;
			case 4:
			OutString12x21( YCoor, XCoor+12*7+6, YString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			Offset = 12 * 8;
			break;
			case 5:
			OutString12x21( YCoor, XCoor+12*7+6, XString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*8+6, '=', WhiteColor );
			Offset = 12 * 8;
			break;
			case 6:
			OutString12x21( YCoor, XCoor+12*8+6, XcString, WhiteColor );
			OutChar12x21( YCoor, XCoor+12*10+6, '=', WhiteColor );
			Offset = 13 * 10;
			break;
		}

		if ( Settings502->DepthOutputType == 0 )
		{
			OutString( YCoor+5, XCoor+Offset+12*6+1, MMString, WhiteColor );
		}
		else
		{
			OutString( YCoor+5, XCoor+Offset+12*6+1, MCSString, WhiteColor );
		}
	}
	else
	{
		ClearRectangle12( Strob1YCoor, Strob1XCoor, Strob1YCoor+24, Strob1XCoor+263 );
		StrobDataInit( Settings502, 1 );
		StrobDataInit( Settings502, 2 );
	}

	SelectLayer( LayerNumber );
}


VOID StrobDataInit( struct SETTINGS502 *Settings502, WORD StrobNumber )
{
BYTE StrobTypeOutput;
INT YCoor;
INT XCoor;
WORD LayerNumber;

	LayerNumber = GetLayer();

	if ( StrobNumber == 1 )
	{
		YCoor = Strob1YCoor;
		XCoor = Strob1XCoor;
	}
	else if ( StrobNumber == 2 )
	{
		YCoor = Strob2YCoor;
		XCoor = Strob2XCoor;
	}

	SelectLayer( 3 );
	//  :
	// .
	if ( StrobNumber == 1 )
	{
		if ( Settings502->MeasureModeFlag == 1 && ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE || Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE ) )
		{
			OutString( YCoor, XCoor, "S", WhiteColor );
		}
		else
		{
			OutString( YCoor, XCoor, "A", WhiteColor );
		}
		StrobTypeOutput = Settings502->Strob1TypeOutput[Settings502->ChannelNumber];
		RadiusValue1Old = 0xff;
		RadiusValue1Clear = 0xff;
	}
	else
	{
		if ( Settings502->MeasureModeFlag == 1 && ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE || Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE ) )
		{
			OutString( YCoor, XCoor, "S", WhiteColor );
		}
		else
		{
			OutString( YCoor, XCoor, "A", WhiteColor );
		}
		StrobTypeOutput = Settings502->Strob2TypeOutput[Settings502->ChannelNumber];
		RadiusValue2Old = 0xff;
		RadiusValue2Clear = 0xff;
	}

	DrawLittleStrob( YCoor+13, XCoor+24, StrobNumber );

	// .
	switch ( StrobTypeOutput )
	{
		case 0:
		FillString( YCoor, XCoor+58, RString, WhiteColor, BlackColor );
		FillString( YCoor+12, XCoor+58, YString, WhiteColor, BlackColor );
		break;
		case 1:
		FillString( YCoor, XCoor+58, RString, WhiteColor, BlackColor );
		FillString( YCoor+12, XCoor+58, XString, WhiteColor, BlackColor );
		break;
		case 2:
		FillString( YCoor, XCoor+58, YString, WhiteColor, BlackColor );
		FillString( YCoor+12, XCoor+58, XString, WhiteColor, BlackColor );
		break;
		case 3:
		FillString( YCoor, XCoor+58, RString, WhiteColor, BlackColor );
		FillString( YCoor+12, XCoor+50, XcString, WhiteColor, BlackColor );
		break;
	}

	OutChar( YCoor, XCoor+66, '=', WhiteColor );
	OutChar( YCoor+12, XCoor+66, '=', WhiteColor );

	if ( Settings502->DepthOutputType == 0 )
	{
		OutString7x9( YCoor+2, XCoor+108, MMString, WhiteColor );
		OutString7x9( YCoor+14, XCoor+108, MMString, WhiteColor );
	}
	else
	{
		OutString7x9( YCoor+2, XCoor+108, MCSString, WhiteColor );
		OutString7x9( YCoor+14, XCoor+108, MCSString, WhiteColor );
	}

	SelectLayer( LayerNumber );
}


VOID DrawLittleStrob( WORD YCoor, WORD XCoor, WORD StrobNumber )
{
	if ( StrobNumber == 1 )
	{
		DrawVerticalLine12( XCoor+0, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+1, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+15, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+16, YCoor+0, YCoor+6, WhiteColor );
		DrawHorizontalLine12( YCoor+0, XCoor+2, XCoor+14, WhiteColor );
		DrawHorizontalLine12( YCoor+1, XCoor+2, XCoor+14, WhiteColor );
	}
	else
	{
		DrawVerticalLine12( XCoor+0, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+1, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+15, YCoor+0, YCoor+6, WhiteColor );
		DrawVerticalLine12( XCoor+16, YCoor+0, YCoor+6, WhiteColor );
		DrawHorizontalLine12( YCoor+5, XCoor+2, XCoor+14, WhiteColor );
		DrawHorizontalLine12( YCoor+6, XCoor+2, XCoor+14, WhiteColor );
	}
}


VOID OutputStrobDBValue( struct SETTINGS502 *Settings502, WORD BaseDBValue0, WORD DBValue, WORD RValue, WORD StrobNumber )
{
INT i,j;
LONG Value;
LONG Value1;
LONG Value2;
WORD YBegin;
WORD XBegin;
WORD YEnd;
WORD XEnd;
WORD BaseDBValue;
WORD k;
BYTE ZeroChar;

	if ( StrobNumber == 2 && Settings502->OneStrobSubModeFlag == 1 )
		goto quit_proc;

	if ( ManyChannelModeFlag == TRUE && ProgramModeFlag == AUTO_MODE )
		BaseDBValue = BaseDBValue0 + ( WORD ) SolidityAmplifierKoeff[Settings502->Solidity];
	else
		BaseDBValue = BaseDBValue0;

	if ( DBValue == 0 )
	{
		ZeroChar = '>';
	}
	else if ( DBValue == 0xff )
	{
		ZeroChar = '<';
	}
	else
	{
		ZeroChar = '=';
	}

	if ( StrobNumber == 1 )
	{
     		if ( Settings502->OneStrobSubModeFlag == 1 )
		{
			YBegin = Strob1YCoor;
			XBegin = Strob1XCoor + 12 * 1;
		}
		else
		{
			YBegin = Strob1YCoor;
			XBegin = Strob1XCoor + 8;
		}
	}
	else if ( StrobNumber == 2 )
	{
		YBegin = Strob2YCoor;
		XBegin = Strob2XCoor + 8;
	}

	//     .
	if ( ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE || Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE ) &&
	     Settings502->MeasureModeFlag == 1 )
	{
		Value1 = BaseDBValue * 10;
		Value1 += ConvertAToDBArray[200-DBValue];
		if ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE || Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE )
		{
			if ( Settings502->VRCHSubMode == FALSE )
			{
				if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
				{
					Value2 = 1260 - CurveData[Settings502->Delay[Settings502->ChannelNumber] + RValue / 2];
				}
				else
				{
					Value2 = 1260 - CurveData[Settings502->Delay[Settings502->ChannelNumber] + RValue * Settings502->Unrolling[Settings502->ChannelNumber]];
				}
			}
			else
			{
				Value2 = 1260 - MaxDBCode;
			}
		}

		if ( Value1 > ( Value2 + 60 ) )
		{
			if ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE )
				Value2 = Settings502->ARDEffectiveSquare[Settings502->ChannelNumber] / 2;
			if ( Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE )
				Value2 = Settings502->DACEffectiveSquare[Settings502->ChannelNumber] / 2;
			OutputBuffer[0] = '<';
			FormatWordDiv10( &OutputBuffer[1], ( WORD ) Value2 );
		}
		else
		{
			if ( Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE )
				Value = Settings502->ARDEffectiveSquare[Settings502->ChannelNumber];
			if ( Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE )
				Value = Settings502->DACEffectiveSquare[Settings502->ChannelNumber];
			GetResource( X87 );
			Value1 = ( LONG ) ( pow( 10.0, ( ( ( DOUBLE ) ( Value2 - Value1 ) ) / 200.0 ) ) * ( DOUBLE ) Value );
			FreeResource( X87 );
			//   - 
			if ( Value1 > 9999 )
				Value1 = 9999;
			if ( Value1 >= 2000 )
			{
				OutputBuffer[0] = '>';
				FormatWordDiv10( &OutputBuffer[1], ( WORD ) Value1 );
			}
			else
			{
				OutputBuffer[0] = '=';
				FormatWordDiv10( &OutputBuffer[1], ( WORD ) Value1 );
			}
		}
	}
	else
	{
		OutputBuffer[0] = ZeroChar;
		Value = BaseDBValue * 10;
		Value += ConvertAToDBArray[200-DBValue];
		if ( Settings502->AmplificationLevelValue != 0 )
		{
			Value2 = ( LONG ) Value - ( LONG ) 10 * Settings502->AmplificationLevelValue;
			GetResource( X87 );
			sprintf( &OutputBuffer[1], "%3.1f", ( FLOAT ) ( -Value2 ) / 10 );
			FreeResource( X87 );
       	       	}
		else
		{
		 	FormatWordDiv10( &OutputBuffer[1], ( WORD ) Value );
		}
	}

	i = strlen( OutputBuffer );
	if ( i > 6 )
		i = 6;
	for ( j=0;j<(6-i);j++ )
		OutputBuffer[i+j] = 0x20;
	OutputBuffer[6] = 0x00;

	if ( Settings502->OneStrobSubModeFlag == 1 )
	{
		OutString12x21( YBegin, XBegin, OutputBuffer, WhiteColor );
	}
	else
	{
		OutString( YBegin, XBegin, OutputBuffer, WhiteColor );
	}

quit_proc:
	return;
}


VOID ClearCut( struct SETTINGS502 *Settings502 )
{
WORD YCoor;
WORD XCoor;

	if ( Settings502->Cut[Settings502->ChannelNumber] <= 200 )
	{
		YCoor = GraphBeginYCoor + 200 - Settings502->Cut[Settings502->ChannelNumber];
		XCoor = GraphBeginXCoor + 252;
		if ( Settings502->Cut[Settings502->ChannelNumber] == 0 )
		{
			SetPixel12( YCoor, XCoor, BlackColor );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, BlackColor );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, BlackColor );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+3, BlackColor );
		}
		else
		{
			SetPixel12( YCoor, XCoor, BlackColor );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, BlackColor );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, BlackColor );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+3, BlackColor );
		}
	}
}


VOID DrawCut( struct SETTINGS502 *Settings502 )
{
WORD YCoor;
WORD XCoor;

	if ( Settings502->Cut[Settings502->ChannelNumber] <= 200 )
	{
		YCoor = GraphBeginYCoor + 200 - Settings502->Cut[Settings502->ChannelNumber];
		XCoor = GraphBeginXCoor + 252;
		if ( Settings502->Cut[Settings502->ChannelNumber] == 0 )
		{
			SetPixel12( YCoor, XCoor, WhiteColor );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, WhiteColor );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, WhiteColor );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+3, WhiteColor );
		}
		else
		{
			SetPixel12( YCoor, XCoor, WhiteColor );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, WhiteColor );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, WhiteColor );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+3, WhiteColor );
		}
	}
}


VOID DrawLock( BOOL LockOnFlag )
{
	if ( LockOnFlag == FALSE )
		FillChar7x9( LockYCoor, LockXCoor, 0xf7, WhiteColor, BlackColor );
	else
		FillChar7x9( LockYCoor, LockXCoor, 0xf6, WhiteColor, BlackColor );
	FillRectangle12( LockYCoor, LockXCoor+10, LockYCoor+12, LockXCoor+17, BlackColor );
}


VOID DrawSensor( struct SETTINGS502 *Settings502 )
{
	ClearRectangle12( SensorYBegin, SensorXBegin, SensorYBegin+24, MaxXRes );
	strncpy( &OutputBuffer[0], &Settings502->PEPName[Settings502->ChannelNumber][0], 5 );
	OutputBuffer[5] = 0;
	OutString( SensorYBegin+1, SensorXBegin+1, &OutputBuffer[0], WhiteColor );
	strncpy( &OutputBuffer[0], &Settings502->PEPName[Settings502->ChannelNumber][5], 6 );
	OutputBuffer[6] = 0;
	OutString7x9( SensorYBegin+15, SensorXBegin+1, &OutputBuffer[0], WhiteColor );
}


VOID DrawALMarker( struct SETTINGS502 *Settings502, BYTE Color )
{
WORD i,j;
WORD YCoor;
WORD XCoor;

	if ( Settings502->AmplifierKoeff[Settings502->ChannelNumber] <= Settings502->AmplificationLevelValue &&
	     ( Settings502->AmplifierKoeff[Settings502->ChannelNumber] + 46 ) > Settings502->AmplificationLevelValue )
	{
		j = Settings502->AmplificationLevelValue - Settings502->AmplifierKoeff[Settings502->ChannelNumber];
		for ( i=0;i<200;i++ )
		{
			if ( ConvertAToDBArray[i] >= ( j * 10 ) && ( j * 10 ) < ConvertAToDBArray[i+1] )
			{
				i++;
				break;
			}
		}

		YCoor = GraphBeginYCoor + i;
		XCoor = GraphBeginXCoor + 2;
		switch ( i )
		{
			case 200:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor, Color );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor, Color );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor, Color );
			break;

			case 199:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+1, Color );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+1, Color );
			break;

			case 198:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, Color );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+2, Color );
			break;

			case 2:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, Color );
			DrawVerticalLine12( XCoor+3, YCoor-2, YCoor+3, Color );
			break;

			case 1:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor-1, YCoor+2, Color );
			DrawVerticalLine12( XCoor+3, YCoor-1, YCoor+3, Color );
			break;

			case 0:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor, YCoor+2, Color );
			DrawVerticalLine12( XCoor+3, YCoor, YCoor+3, Color );
			break;

			default:
			SetPixel12( YCoor, XCoor, Color );
			DrawVerticalLine12( XCoor+1, YCoor-1, YCoor+1, Color );
			DrawVerticalLine12( XCoor+2, YCoor-2, YCoor+2, Color );
			DrawVerticalLine12( XCoor+3, YCoor-3, YCoor+3, Color );
			break;
		}
	}
}


VOID DrawAmplifierKoeff( struct SETTINGS502 *Settings502, WORD Koeff )
{
WORD Koeff1;

	ClearRectangle12( GraphBeginYCoor+1, BeginXCoor, GraphBeginYCoor+200, BeginXCoor+15 );

	//     -  .
	if ( Settings502->AmplificationLevelValue != 0 )
	{
		OutString7x9( GraphBeginYCoor+16, BeginXCoor+1, "", WhiteColor );
		sprintf( OutputBuffer, "%2.2d", Settings502->AmplificationLevelValue );
		OutString7x9( GraphBeginYCoor+26, BeginXCoor+1, OutputBuffer, WhiteColor );
		OutString7x9( GraphBeginYCoor+36, BeginXCoor+1, DBString, WhiteColor );
		DrawRectangle( GraphBeginYCoor+15, BeginXCoor, GraphBeginYCoor+45, BeginXCoor+15, WhiteColor );
		DrawALMarker( &CurrentSettings, WhiteColor );
	}

	//  
	Koeff1 = Koeff + 0;
	if ( Settings502->AmplificationLevelValue != 0 )
	{
		if ( Koeff1 <= Settings502->AmplificationLevelValue )
		{
			Koeff1 = Settings502->AmplificationLevelValue - Koeff1;
		}
		else
		{
			Koeff1 = Koeff1 - Settings502->AmplificationLevelValue;
			DrawHorizontalLine12( GraphBeginYCoor+5, BeginXCoor, BeginXCoor+1, WhiteColor );
		}
	}
	sprintf( OutputBuffer, "%2.2d", Koeff1 );
	OutString7x9( GraphBeginYCoor+1, BeginXCoor+2, OutputBuffer, WhiteColor );

	//   + 3
	Koeff1 = Koeff + 3;
	if ( Settings502->AmplificationLevelValue != 0 )
	{
		if ( Koeff1 <= Settings502->AmplificationLevelValue )
		{
			Koeff1 = Settings502->AmplificationLevelValue - Koeff1;
		}
		else
		{
			Koeff1 = Koeff1 - Settings502->AmplificationLevelValue;
			DrawHorizontalLine12( GraphBeginYCoor+55, BeginXCoor, BeginXCoor+1, WhiteColor );
       	       	}
	}
	sprintf( OutputBuffer, "%2.2d", Koeff1 );
	OutString7x9( GraphBeginYCoor+51, BeginXCoor+2, OutputBuffer, WhiteColor );

	//   + 6
	Koeff1 = Koeff + 6;
	if ( Settings502->AmplificationLevelValue != 0 )
	{
		if ( Koeff1 <= Settings502->AmplificationLevelValue )
		{
			Koeff1 = Settings502->AmplificationLevelValue - Koeff1;
		}
		else
		{
			Koeff1 = Koeff1 - Settings502->AmplificationLevelValue;
			DrawHorizontalLine12( GraphBeginYCoor+105, BeginXCoor, BeginXCoor+1, WhiteColor );
	       	}
	}
	sprintf( OutputBuffer, "%2.2d", Koeff1 );
	OutString7x9( GraphBeginYCoor+101, BeginXCoor+2, OutputBuffer, WhiteColor );

	//   + 12
	Koeff1 = Koeff + 12;
	if ( Settings502->AmplificationLevelValue != 0 )
	{
		if ( Koeff1 <= Settings502->AmplificationLevelValue )
		{
			Koeff1 = Settings502->AmplificationLevelValue - Koeff1;
		}
		else
		{
			Koeff1 = Koeff1 - Settings502->AmplificationLevelValue;
	       		DrawHorizontalLine12( GraphBeginYCoor+155, BeginXCoor, BeginXCoor+1, WhiteColor );
		}
	}
	sprintf( OutputBuffer, "%2.2d", Koeff1 );
	OutString7x9( GraphBeginYCoor+151, BeginXCoor+2, OutputBuffer, WhiteColor );
}


//   .
VOID DrawMarkerLevel( WORD MarkerDepth, struct SETTINGS502 *Settings502, BYTE Color )
{
WORD i;
WORD XCoor;
DWORD Depth;
DOUBLE Depth0;

	Depth = MarkerDepth;
	Depth = MultyDivide( Depth, 10000, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]] );
	Depth = MMMulty10ToFifoBytes( Depth, Settings502 );

	GetResource( X87 );
	Depth0 = ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];
	if ( Settings502->DepthType == 1 )
	{
		Depth0 *= ( 250.0 + Settings502->DepthKoeff );
		Depth0 /= 500.0;
	}
	Depth += ( DWORD ) Depth0;
	FreeResource( X87 );

	if ( Depth < Settings502->Delay[Settings502->ChannelNumber] )
		goto quit_proc;

	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 125 ) )
			goto quit_proc;
	}
	else
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 250 * Settings502->Unrolling[Settings502->ChannelNumber] ) )
			goto quit_proc;
	}

	XCoor = ( WORD ) Depth - Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		XCoor *= 2;
	}
	else
	{
		XCoor /= Settings502->Unrolling[Settings502->ChannelNumber];
	}
	XCoor += ( GraphBeginXCoor + 1 );

	for ( i=0;i<20;i++ )
	{
		DrawVerticalLine12( XCoor, GraphBeginYCoor+i*10, GraphBeginYCoor+i*10+7, Color );
	}

quit_proc:
	return;
}


//     .
VOID DrawDepth0Level( struct SETTINGS502 *Settings502 )
{
WORD i;
WORD YCoor;
WORD XCoor;

	if ( Settings502->Depth0[Settings502->ChannelNumber] < Settings502->Delay[Settings502->ChannelNumber] )
		goto quit_proc;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		if ( Settings502->Depth0[Settings502->ChannelNumber] > ( Settings502->Delay[Settings502->ChannelNumber] + 125 ) )
			goto quit_proc;
	}
	else
	{
		if ( Settings502->Depth0[Settings502->ChannelNumber] > ( Settings502->Delay[Settings502->ChannelNumber] + 250 * Settings502->Unrolling[Settings502->ChannelNumber] ) )
			goto quit_proc;
	}

	XCoor = Settings502->Depth0[Settings502->ChannelNumber] - Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
		XCoor *= 2;
	else
		XCoor /= Settings502->Unrolling[Settings502->ChannelNumber];

	if ( Settings502->DepthType == 1 )
	{
		XCoor *= ( 250 + Settings502->DepthKoeff );
		XCoor /= 500;
	}

	XCoor += ( GraphBeginXCoor + 1 );
	YCoor = GraphBeginYCoor + 201;

	SetPixel12( YCoor, XCoor, WhiteColor );
	for ( i=0;i<3;i++ ) SetPixel12( YCoor+1, XCoor-1+i, WhiteColor );
	for ( i=0;i<5;i++ ) SetPixel12( YCoor+2, XCoor-2+i, WhiteColor );
	for ( i=0;i<7;i++ ) SetPixel12( YCoor+3, XCoor-3+i, WhiteColor );

quit_proc:
	return;
}


//     .
VOID DrawDepth1Level( struct SETTINGS502 *Settings502 )
{
WORD YCoor;
WORD XCoor;
DWORD Depth;
DOUBLE Depth0;

	Depth = Settings502->Depth1[Settings502->ChannelNumber];
	Depth = MultyDivide( Depth, 10000, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]] );
	Depth = MMMulty10ToFifoBytes( Depth, Settings502 );

	GetResource( X87 );
	Depth0 = ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];
	if ( Settings502->DepthType == 1 )
	{
		Depth0 *= ( 250.0 + Settings502->DepthKoeff );
		Depth0 /= 500.0;
	}
	Depth += ( DWORD ) Depth0;
	FreeResource( X87 );

	if ( Depth < Settings502->Delay[Settings502->ChannelNumber] )
		goto quit_proc;

	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 125 ) )
			goto quit_proc;
	}
	else
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 250 * Settings502->Unrolling[Settings502->ChannelNumber] ) )
			goto quit_proc;
	}

	XCoor = ( WORD ) Depth - Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		XCoor *= 2;
	}
	else
	{
		XCoor /= Settings502->Unrolling[Settings502->ChannelNumber];
	}
	XCoor += ( GraphBeginXCoor + 1 );
	YCoor = GraphBeginYCoor + 201;

	DrawVerticalLine12( XCoor, YCoor, YCoor+3, WhiteColor );

quit_proc:
	return;
}


//      .
VOID DrawDepth2Level( struct SETTINGS502 *Settings502 )
{
WORD YCoor;
WORD XCoor;
DWORD Depth;
DOUBLE Depth0;

	Depth = Settings502->Depth1[Settings502->ChannelNumber];
	Depth = MultyDivide( Depth, 20000, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]] );
	Depth = MMMulty10ToFifoBytes( Depth, Settings502 );

	GetResource( X87 );
	Depth0 = ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];
	if ( Settings502->DepthType == 1 )
	{
		Depth0 *= ( 250.0 + Settings502->DepthKoeff );
		Depth0 /= 500.0;
	}
	Depth += ( DWORD ) Depth0;
	FreeResource( X87 );

	if ( Depth < Settings502->Delay[Settings502->ChannelNumber] ) goto quit_proc;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 125 ) )
			goto quit_proc;
	}
	else
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 250 * Settings502->Unrolling[Settings502->ChannelNumber] ) )
			goto quit_proc;
	}

	XCoor = ( WORD ) Depth - Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		XCoor *= 2;
	}
	else
	{
		XCoor /= Settings502->Unrolling[Settings502->ChannelNumber];
	}
	XCoor += ( GraphBeginXCoor + 1 );
	YCoor = GraphBeginYCoor + 201;

	SetPixel12( YCoor, XCoor, WhiteColor );
	DrawVerticalLine12( XCoor-1, YCoor, YCoor+3, WhiteColor );
	DrawVerticalLine12( XCoor+1, YCoor, YCoor+3, WhiteColor );

quit_proc:
	return;
}


//      .
VOID DrawDepth3Level( struct SETTINGS502 *Settings502 )
{
WORD YCoor;
WORD XCoor;
DWORD Depth;
DOUBLE Depth0;

	Depth = Settings502->Depth1[Settings502->ChannelNumber];
	Depth = MultyDivide( Depth, 30000, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]] );
	Depth = MMMulty10ToFifoBytes( Depth, Settings502 );

	GetResource( X87 );
	Depth0 = ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];
	if ( Settings502->DepthType == 1 )
	{
		Depth0 *= ( 250.0 + Settings502->DepthKoeff );
		Depth0 /= 500.0;
	}
	Depth += ( DWORD ) Depth0;
	FreeResource( X87 );

	if ( Depth < Settings502->Delay[Settings502->ChannelNumber] ) goto quit_proc;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 125 ) )
			goto quit_proc;
	}
	else
	{
		if ( Depth > ( Settings502->Delay[Settings502->ChannelNumber] + 250 * Settings502->Unrolling[Settings502->ChannelNumber] ) )
			goto quit_proc;
	}

	XCoor = ( WORD ) Depth - Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		XCoor *= 2;
	}
	else
	{
		XCoor /= Settings502->Unrolling[Settings502->ChannelNumber];
	}
	XCoor += ( GraphBeginXCoor + 1 );
	YCoor = GraphBeginYCoor + 201;

	DrawVerticalLine12( XCoor, YCoor, YCoor+3, WhiteColor );
	SetPixel12( YCoor+3, XCoor-2, WhiteColor );
	SetPixel12( YCoor+3, XCoor+2, WhiteColor );

quit_proc:
	return;
}


VOID DrawHorizontalCoor( struct SETTINGS502 *Settings502 )
{
LONG Koeff;

	//        .
	ClearRectangle12( MaxYRes-9+BeginYCoor, GraphBeginXCoor, MaxYRes+BeginYCoor, GraphBeginXCoor+42 );
	if ( Settings502->DepthOutputType == 0 )
	{
		Koeff = PixelsToMMMulty10( 0, Settings502 );
		GetResource( X87 );
 		sprintf( &OutputBuffer[0], "%ld", Koeff );
		FreeResource( X87 );
		FormatDivideBy10( &OutputBuffer[0] );
	}
	else
	{
		Koeff = PixelsToMCSMulty10( 0, Settings502 );
		GetResource( X87 );
 		sprintf( &OutputBuffer[0], "%ld", Koeff );
		FreeResource( X87 );
		FormatDivideBy10( &OutputBuffer[0] );
	}
	OutString7x9( MaxYRes-9+BeginYCoor, GraphBeginXCoor, OutputBuffer, WhiteColor );
	//        .
	ClearRectangle12( MaxYRes-9+BeginYCoor, GraphBeginXCoor+251, MaxYRes, MaxXRes );
	if ( Settings502->DepthOutputType == 0 )
	{
		Koeff = PixelsToMMMulty10( 250, Settings502 );
		GetResource( X87 );
 		sprintf( &OutputBuffer[0], "%ld", Koeff );
		FreeResource( X87 );
		FormatDivideBy10( &OutputBuffer[0] );
	}
	else
	{
		Koeff = PixelsToMCSMulty10( 250, Settings502 );
		GetResource( X87 );
 		sprintf( &OutputBuffer[0], "%ld", Koeff );
		FreeResource( X87 );
		FormatDivideBy10( &OutputBuffer[0] );
	}
	OutString7x9( MaxYRes-9+BeginYCoor, GraphBeginXCoor+251, OutputBuffer, WhiteColor );
	if ( Settings502->DepthType == 1 && Settings502->DepthKoeff != 250 )
	{
		OutChar( MaxYRes-10+BeginYCoor, GraphBeginXCoor+294, '*', WhiteColor );
	}
	//      .
	ClearRectangle12( GraphBeginYCoor+201, GraphBeginXCoor-2, GraphBeginYCoor+204, GraphBeginXCoor+252 );
	DrawDepth0Level( Settings502 );
	DrawDepth1Level( Settings502 );
	DrawDepth2Level( Settings502 );
	DrawDepth3Level( Settings502 );
	//       .
	ClearRectangle12( MaxYRes-9+BeginYCoor, GraphBeginXCoor+93, MaxYRes, GraphBeginXCoor+177 );
	UnrollingFormat( ( BYTE ) Settings502->Unrolling[Settings502->ChannelNumber], &OutputBuffer[0] );
	OutString7x9( MaxYRes-9+BeginYCoor, GraphBeginXCoor+93, OutputBuffer, WhiteColor );
}


VOID DrawRz( struct SETTINGS502 *Settings502 )
{
	if ( PEPExistFlag == TRUE )
		sprintf( OutputBuffer, "%3.3d", Settings502->Rz );
 	else
		strcpy( OutputBuffer, "---" );
 	FillString7x9( RzYCoor+2, RzXCoor+23, OutputBuffer, WhiteColor, BlackColor );
}


VOID DrawSettingsNumber( WORD Number )
{
	//  .
	sprintf( OutputBuffer, "%d", Number );
	ClearRectangle12( SettingsYCoor+1, SettingsXCoor+27, SettingsYCoor+9, SettingsXCoor+46 );
	OutString7x9( SettingsYCoor+1, SettingsXCoor+27, OutputBuffer, WhiteColor );
}


VOID DrawFrameNumber( WORD Number )
{
 	sprintf( OutputBuffer, "%2.2d", Number );
 	ClearRectangle12( 1, MaxXRes-15, 9, MaxXRes-1 );
 	OutString7x9( 1, MaxXRes-15, OutputBuffer, WhiteColor );
}


VOID DrawUltrasonicSpeed( struct SETTINGS502 *Settings502 )
{
	//   .
	sprintf( OutputBuffer, "%d", Settings502->UltrasonicSpeed );
	ClearRectangle12( SpeedYBegin+1, SpeedXBegin+15, SpeedYBegin+13, MaxXRes );
	OutString7x9( SpeedYBegin+1, SpeedXBegin+15, OutputBuffer, WhiteColor );
}


VOID DrawInputAngle( struct SETTINGS502 *Settings502 )
{
	//   .
	sprintf( OutputBuffer, "%d", Settings502->InputAngle[Settings502->ChannelNumber] );
	ClearRectangle12( AngleYBegin+1, AngleXBegin+16, AngleYBegin+13, MaxXRes );
	OutString7x9( AngleYBegin+1, AngleXBegin+16, OutputBuffer, WhiteColor );
}


VOID CheckBottomSignal( BYTE LostBottomFlag, struct SETTINGS502 *Settings502 )
{
WORD i;
BYTE Mask;

	//      .
	Mask = 1;
	for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
	{
 		if ( ( LostBottomFlag & Mask) != 0 )
			AbsentBottomSignalChannel[i] = NO_BOTTOM_SIGNAL;
		else
			AbsentBottomSignalChannel[i] = BOTTOM_SIGNAL_EXIST;
		Mask <<= 1;
	}

	if ( memchr( &AbsentBottomSignalChannel[0], NO_BOTTOM_SIGNAL, MAX_NUMBER_OF_CHANNELS ) != NULL )
	{
		if ( AbsentBottomSignalFlag == FALSE )
		{
			ajtmwr( BottomSignalTimerId, BottomSignalPause/SystemClockDivider );
			AbsentBottomSignalIntervalFlag = FALSE;
			AbsentBottomSignalFlag = TRUE;
		}
		if ( AbsentBottomSignalIntervalFlag == TRUE )
		{
			if ( AbsentBottomSignalMode == FALSE )
			{
				ajtmwr( BottomSignalTimerId, 0 );
				ClearRectangle12( GraphBeginYCoor, GraphBeginXCoor+2, GraphBeginYCoor+199, GraphBeginXCoor+251 );
				for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
				{
					FillRectangle12( GraphBeginYCoor+1, GraphBeginXCoor+1+(i+1)*26-5, GraphBeginYCoor+200, GraphBeginXCoor+1+(i+1)*26+5, WhiteColor );
				}
				AbsentBottomSignalMode = TRUE;
			}
		}
	}
	else
	{
		if ( AbsentBottomSignalMode == TRUE )
		{
			ClearRectangle12( GraphBeginYCoor, GraphBeginXCoor+2, GraphBeginYCoor+199, GraphBeginXCoor+251 );
			DrawCoordinateGrid();
			DrawStrobs( Settings502 );

			AbsentBottomSignalMode = FALSE;
		}
		if ( AbsentBottomSignalFlag == TRUE )
		{
			AbsentBottomSignalFlag = FALSE;
			AbsentBottomSignalIntervalFlag = FALSE;
			ajtmwr( BottomSignalTimerId, 0 );
		}
	}
}


BOOL DrawDigitalValues( struct DSP_DATA_STRUCT *DSPDataPtr, struct SETTINGS502 *Settings502 )
{
BOOL DefectFlagProm;
WORD MaxDBValue1;
WORD MaxDBValue2;
BYTE RadiusValue;
BYTE MaxDBRValue1;
BYTE MaxDBRValue2;
LONG LValue;
LONG LValueTemp;
WORD i,j,k;
WORD YBegin;
WORD XBegin;
WORD YEnd;
WORD XEnd;

	DSPDataStruct.AmplifierKoeffEcho = Settings502->AmplifierKoeff[Settings502->ChannelNumber];

	SetDataSmooth( &DataNew[0], &DataSmooth[0] );

	DefectFlagProm = FALSE;
	for ( i=Settings502->ASD1Base[Settings502->ChannelNumber];i<(Settings502->ASD1Base[Settings502->ChannelNumber]+Settings502->ASD1Length[Settings502->ChannelNumber]);i++ )
	{
 		if ( DataSmooth[i] >= Settings502->ASD1Level[Settings502->ChannelNumber] )
		{
			DefectFlagProm = TRUE;
			break;
		}
	}

	MaxDBValue1 = 0;
	for ( i=Settings502->ASD1Base[Settings502->ChannelNumber];i<(Settings502->ASD1Base[Settings502->ChannelNumber]+Settings502->ASD1Length[Settings502->ChannelNumber]);i++ )
	{
		if ( MaxDBValue1 < DataSmooth[i] )
		{
			MaxDBValue1 = DataSmooth[i];
			MaxDBRValue1 = ( BYTE ) i;
		}
	}
	MaxDBValue2 = 0;
	for ( i=Settings502->ASD2Base[Settings502->ChannelNumber];i<(Settings502->ASD2Base[Settings502->ChannelNumber]+Settings502->ASD2Length[Settings502->ChannelNumber]);i++ )
	{
		if ( MaxDBValue2 <= DataSmooth[i] )
		{
			MaxDBValue2 = DataSmooth[i];
			MaxDBRValue2 = ( BYTE ) i;
		}
	}

	//      1.
	DBValueCount++;
	DBValue1Middle += MaxDBValue1;
	DBValue2Middle += MaxDBValue2;
	if ( DBValueCount >= AverageDepth )
	{
		MaxDBValue1 = ( BYTE ) ( DBValue1Middle / AverageDepth );
		DBValue1Middle = 0;
  		OutputStrobDBValue( Settings502, DSPDataStruct.AmplifierKoeffEcho, MaxDBValue1, MaxDBRValue1, 1 );

		if ( Settings502->OneStrobSubModeFlag != 1 )
		{
			MaxDBValue2 = ( BYTE ) ( DBValue2Middle / AverageDepth );
			DBValue2Middle = 0;
	  		OutputStrobDBValue( Settings502, DSPDataStruct.AmplifierKoeffEcho, MaxDBValue2, MaxDBRValue2, 2 );
		}
		DBValueCount = 0;
    	}

	//     
	if ( DBValueCount != 0 )
	{
		goto quit_proc;
	}

	RadiusValue = 0xff;
	for ( i=Settings502->ASD1Base[Settings502->ChannelNumber];i<(Settings502->ASD1Base[Settings502->ChannelNumber]+Settings502->ASD1Length[Settings502->ChannelNumber]);i++ )
	{
 		if ( DataSmooth[i] >= Settings502->ASD1Level[Settings502->ChannelNumber] )
		{
			if ( Settings502->DepthOutputType == 0 )
			{
				LValue = PixelsToMMMulty10( i, Settings502 );
			}
			else
			{
				LValue = PixelsToMCSMulty10( i, Settings502 );
			}
			if ( LValue >= 0 )
			{
				RadiusValue = ( BYTE ) i;
				break;
			}
		}
	}

	//      1.
	if ( RadiusValue < 0xfe )
	{
		RadiusValue1Clear = RadiusValue;

		if ( RadiusValue1Old == RadiusValue )
			goto second_radius;

		RadiusValue1Old = RadiusValue;

		if ( Settings502->DepthOutputType == 0 )
		{
			LValue = PixelsToMMMulty10( RadiusValue, Settings502 );
		}
		else
		{
			LValue = PixelsToMCSMulty10( RadiusValue, Settings502 );
		}
		//       
		if ( LValue < 0 )
		{
			RadiusValue1Old = 0xff;
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
     				FillRectangle12( Strob1YCoor, Strob1YCoor+12*9+6, Strob1YCoor+24, Strob1XCoor+12*13+6, BlackColor );
     				FillRectangle12( Strob1YCoor, Strob1YCoor+12*16, Strob1YCoor+24, Strob1XCoor+12*20, BlackColor );
			}
			else
			{
     				FillRectangle12( Strob1YCoor, Strob1XCoor+74, Strob1YCoor+24, Strob1XCoor+106, BlackColor );
			}
			DefectFlagProm = FALSE;
			goto second_radius;
		}
		switch ( Settings502->Strob1TypeOutput[Settings502->ChannelNumber] )
		{
			// R,Y 
			case 0:
			memset( &VirtualBuffer[0], 0, 2240 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
 				UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
				memset( &VirtualBuffer[0], 0, 2240 );
			}
			else
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 74;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 8;
				YEnd = YBegin + 24;
				OutVString( 0, k, OutputBuffer, WhiteColor );
			}
			LValue = GetYCoor( Settings502, LValue );
			if ( LValue == -1L )
			{
				strcpy( &OutputBuffer[0], MoreThen4HString );
			}
			else
			{
				FormatRValue( &OutputBuffer[0], LValue );
			}
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				XBegin = Strob1XCoor + 12 * 16;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
			else
			{
				OutVString( 12, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// R,X 
			case 1:
			memset( &VirtualBuffer[0], 0, 2240 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
 				UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
				memset( &VirtualBuffer[0], 0, 2240 );
			}
			else
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 74;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 8;
				YEnd = YBegin + 24;
				OutVString( 0, k, OutputBuffer, WhiteColor );
			}
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				XBegin = Strob1XCoor + 12 * 16;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
			else
			{
				OutVString( 12, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// Y,X 
			case 2:
			memset( &VirtualBuffer[0], 0, 2240 );
			LValueTemp = LValue;
			LValueTemp = GetYCoor( Settings502, LValueTemp );
			if ( LValueTemp == -1L )
			{
				strcpy( &OutputBuffer[0], MoreThen4HString );
			}
			else
			{
				FormatRValue( &OutputBuffer[0], LValueTemp );
			}
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
 				UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
				memset( &VirtualBuffer[0], 0, 2240 );
			}
			else
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 74;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 8;
				YEnd = YBegin + 24;
				OutVString( 0, k, OutputBuffer, WhiteColor );
			}
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				memset( &VirtualBuffer[0], 0, 2240 );
				XBegin = Strob1XCoor + 12 * 16;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
			else
			{
				OutVString( 12, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// R 
			case 3:
			memset( &VirtualBuffer[0], 0, 2240 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// Y 
			case 4:
			memset( &VirtualBuffer[0], 0, 2240 );
			LValue = GetYCoor( Settings502, LValue );
			if ( LValue == -1L )
			{
				strcpy( &OutputBuffer[0], MoreThen4HString );
			}
			else
			{
				FormatRValue( &OutputBuffer[0], LValue );
			}
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// X 
			case 5:
			memset( &VirtualBuffer[0], 0, 2240 );
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			FormatRValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 9 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			// X-C 
			case 6:
			memset( &VirtualBuffer[0], 0, 2240 );
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			if ( Settings502->DepthOutputType == 0 )
			{
				LValue -= Pep.PEPArrow;
			}
			else
			{
				LValue -= MM10ToMCS10( ( LONG ) Pep.PEPArrow, Settings502 );
			}
			FormatXCValue( &OutputBuffer[0], LValue );
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
				YBegin = Strob1YCoor;
				XBegin = Strob1XCoor + 12 * 11 + 6;
				k = XBegin % 8;
				XBegin = ( XBegin >> 3 ) << 3;
				XEnd = XBegin + strlen( OutputBuffer ) * 12;
				YEnd = YBegin + 24;
				OutVString12x21( 0, k, OutputBuffer, WhiteColor );
			}
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;
		}
		for ( j=0;j<26;j++ )
		{
			SetPixel12( GraphBeginYCoor, GraphBeginXCoor+1+j*10, WhiteColor );
		}
	}
	else if ( RadiusValue == 0xfe )
	{
		strcpy( &OutputBuffer[0], MoreThen4HString );
	}
	else
	{
		if ( RadiusValue1Clear != 0xff )
		{
			RadiusValue1Old = 0xff;
			RadiusValue1Clear = 0xff;
			if ( Settings502->OneStrobSubModeFlag == 1 )
			{
     				FillRectangle12( Strob1YCoor, Strob1YCoor+12*9+6, Strob1YCoor+24, Strob1XCoor+12*13+6, BlackColor );
     				FillRectangle12( Strob1YCoor, Strob1YCoor+12*16, Strob1YCoor+24, Strob1XCoor+12*20, BlackColor );
			}
			else
			{
     				FillRectangle12( Strob1YCoor, Strob1XCoor+74, Strob1YCoor+24, Strob1XCoor+106, BlackColor );
			}
		}
	}

second_radius:
	if ( Settings502->OneStrobSubModeFlag == 1 )
		goto quit_proc;

	RadiusValue = 0xff;
	for ( i=Settings502->ASD2Base[Settings502->ChannelNumber];i<(Settings502->ASD2Base[Settings502->ChannelNumber]+Settings502->ASD2Length[Settings502->ChannelNumber]);i++ )
	{
 		if ( DataSmooth[i] >= Settings502->ASD2Level[Settings502->ChannelNumber] )
		{
			if ( Settings502->DepthOutputType == 0 )
				LValue = PixelsToMMMulty10( i, Settings502 );
			else
				LValue = PixelsToMCSMulty10( i, Settings502 );
			if ( LValue >= 0 )
			{
				RadiusValue = ( BYTE ) i;
				break;
			}
		}
	}

	//      2.
	if ( RadiusValue < 0xfe )
	{
		RadiusValue2Clear = RadiusValue;

		if ( RadiusValue2Old == RadiusValue )
			goto quit_proc;

		RadiusValue2Old = RadiusValue;

		if ( Settings502->DepthOutputType == 0 )
		{
			LValue = PixelsToMMMulty10( RadiusValue, Settings502 );
		}
		else
		{
			LValue = PixelsToMCSMulty10( RadiusValue, Settings502 );
		}
		if ( LValue < 0 )
		{
			RadiusValue2Old = 0xff;
			ClearRectangle12( Strob2YCoor, Strob2XCoor+74, Strob2YCoor+24, Strob2XCoor+106 );
			goto quit_proc;
		}
		memset( &VirtualBuffer[0], 0, 2240 );
		switch ( Settings502->Strob2TypeOutput[Settings502->ChannelNumber] )
		{
			case 0:
			FormatRValue( &OutputBuffer[0], LValue );
			YBegin = Strob2YCoor;
			XBegin = Strob2XCoor + 74;
			k = XBegin % 8;
			XBegin = ( XBegin >> 3 ) << 3;
			XEnd = XBegin + strlen( OutputBuffer ) * 8;
			YEnd = YBegin + 24;
			OutVString( 0, k, OutputBuffer, WhiteColor );
			LValue = GetYCoor( Settings502, LValue );
			if ( LValue == -1L )
			{
				strcpy( &OutputBuffer[0], MoreThen4HString );
			}
			else
			{
				FormatRValue( &OutputBuffer[0], LValue );
			}
			OutVString( 12, k, OutputBuffer, WhiteColor );
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			case 1:
			FormatRValue( &OutputBuffer[0], LValue );
			YBegin = Strob2YCoor;
			XBegin = Strob2XCoor + 74;
			k = XBegin % 8;
			XBegin = ( XBegin >> 3 ) << 3;
			XEnd = XBegin + strlen( OutputBuffer ) * 8;
			YEnd = YBegin + 24;
			OutVString( 0, k, OutputBuffer, WhiteColor );
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			FormatRValue( &OutputBuffer[0], LValue );
			OutVString( 12, k, OutputBuffer, WhiteColor );
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;

			case 2:
			LValueTemp = LValue;
			LValueTemp = GetYCoor( Settings502, LValueTemp );
			if ( LValueTemp == -1L )
			{
				strcpy( &OutputBuffer[0], MoreThen4HString );
			}
			else
			{
				FormatRValue( &OutputBuffer[0], LValueTemp );
			}
			YBegin = Strob2YCoor;
			XBegin = Strob2XCoor + 74;
			k = XBegin % 8;
			XBegin = ( XBegin >> 3 ) << 3;
			XEnd = XBegin + strlen( OutputBuffer ) * 8;
			YEnd = YBegin + 24;
			OutVString( 0, k, OutputBuffer, WhiteColor );
			LValue = MultyDivide( LValue, SinArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
			FormatRValue( &OutputBuffer[0], LValue );
			OutVString( 12, k, OutputBuffer, WhiteColor );
 			UpdateScreenInYXCoor( YBegin, XBegin, YEnd, XEnd );
			break;
		}
		for ( j=0;j<26;j++ )
		{
			SetPixel12( GraphBeginYCoor, GraphBeginXCoor+1+j*10, WhiteColor );
		}
	}
	else if ( RadiusValue == 0xfe )
	{
		strcpy( &OutputBuffer[0], MoreThen4HString );
	}
	else
	{
		if ( RadiusValue2Clear != 0xff )
		{
			RadiusValue2Old = 0xff;
			RadiusValue2Clear = 0xff;
		 	FillRectangle12( Strob2YCoor, Strob2XCoor+74, Strob2YCoor+24, Strob2XCoor+106, BlackColor );
		}
	}

quit_proc:
	return( DefectFlagProm );
}


LONG GetYCoor( struct SETTINGS502 *Settings502, LONG ValueMulty10 )
{
LONG LValue;
LONG Depth;

	Depth = Settings502->Depth1[Settings502->ChannelNumber];
	LValue = ValueMulty10;
	Depth = MultyDivide( Depth, 10000, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]] );

	if ( Settings502->DepthOutputType == 1 )
	{
		Depth = MM10ToMCS10( Depth, Settings502 );
	}
	if ( LValue <= ( Depth * 1 ) )
	{
		LValue -= ( Depth * 0 );
		goto quit_proc;
	}
	else if ( LValue <= ( Depth * 2 ) )
	{
		LValue = Depth - ( LValue - Depth * 1 );
		goto quit_proc;
	}
	else if ( LValue <= ( Depth * 3 ) )
	{
		LValue -= ( Depth * 2 );
		goto quit_proc;
	}
	else if ( LValue <= ( Depth * 4 ) )
	{
		LValue = Depth - ( LValue - Depth * 3 );
		goto quit_proc;
	}
	else
	{
		LValue = -1L;
	}

quit_proc:
	if ( LValue != -1L )
	{
		LValue = MultyDivide( LValue, CosArray[Settings502->InputAngle[Settings502->ChannelNumber]], 10000 );
	}
	return( LValue );
}


LONG MultyDivide( LONG Value, WORD Multyplier, WORD Divider )
{
LONG i;
DWORD j;

	GetResource( X87 );
	j = ( DWORD ) Value;
	j *= Multyplier;
	j /= Divider;
	i = ( DWORD ) j;
	FreeResource( X87 );
	return i;
}


VOID SetDataSmooth( BYTEPTR Data, BYTEPTR DataSmooth )
{
register unsigned char i;
register unsigned int j;
register unsigned int k;

	MemSet( &DataSmooth[0], 0, 250 );
	j=0; k=0;
	Data[250] = 0;
	for ( i=0;i<250;i++ )
	{
		if ( Data[i+1] >= Data[i] )
		{
			if ( Data[i] < Data[i-1] )
			{
				j = ( Data[i-1] - Data[i] ) / 2;
				DataSmooth[i] = Data[i] + j;
			}

			j = ( Data[i+1] - Data[i] ) / 2;
			k = Data[i] + j;

			if ( k > DataSmooth[i] )
				DataSmooth[i] = ( BYTE ) k;
		}
		else
		{
			if ( Data[i] < Data[i-1] )
			{
				j = ( Data[i-1] - Data[i] ) / 2;
				DataSmooth[i] = Data[i] + j;
			}
			else
			{
				DataSmooth[i] = Data[i];
			}
		}
	}
}


VOID InitDigitalOuputCounters( VOID )
{
	RadiusValue1Old = 0xfe;
	RadiusValue2Old = 0xfe;
	DBValue1Old = 0xfe;
	DBValue2Old = 0xfe;
	DBValue1Middle = 0;
	DBValue2Middle = 0;
	DBValueCount = 0;
	AbsentBottomSignalCount = 0;
}


VOID RedrawPicture( struct SETTINGS502 *Settings502 )
{
WORD i,j,k;
struct AMXMSG msg;
WORD LayerNumber;
WORD Strob1BaseData;
WORD Strob1LengthData;
WORD Strob1LevelData;
WORD Strob2BaseData;
WORD Strob2LengthData;
WORD Strob2LevelData;

	LayerNumber = GetLayer();
	SelectLayer( 2 );

	//  .
	DrawStaticInfo( Settings502 );
	//    .
	DrawSettingsNumber( Settings502->SettingsNumber );
	//   
	LoadSensorName( Settings502 );
	//   .
	DrawSensor( Settings502 );
	//    .
	DrawInputAngle( Settings502 );
	//    .
	DrawUltrasonicSpeed( Settings502 );
	//  .
	if ( !( ManyChannelModeFlag == TRUE && ProgramModeFlag == AUTO_MODE ) )
	{
		DrawStrobs( Settings502 );
	}
	else
	{
		memcpy( &TempCurrentSettings, Settings502, sizeof( struct SETTINGS502 ) );
		TempCurrentSettings.ChannelNumber = 0;
		Strob1BaseData = 0;
		Strob1LengthData = 0;
		Strob1LevelData = 0;
		Strob2BaseData = 0;
		Strob2LengthData = 0;
		Strob2LevelData = 0;
		if ( StrobAutoModeFlag == 0 )
		{
			for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
			{
				Strob1BaseData += TempCurrentSettings.ASD1Base[i+1];
				Strob1LengthData += TempCurrentSettings.ASD1Length[i+1];
				Strob1LevelData += TempCurrentSettings.ASD1Level[i+1];
				Strob2BaseData += TempCurrentSettings.ASD2Base[i+1];
				Strob2LengthData += TempCurrentSettings.ASD2Length[i+1];
				Strob2LevelData += TempCurrentSettings.ASD2Level[i+1];
			}
			Strob1BaseData /= MAX_NUMBER_OF_CHANNELS;
			Strob1LengthData /= MAX_NUMBER_OF_CHANNELS;
			Strob1LevelData /= MAX_NUMBER_OF_CHANNELS;
			Strob2BaseData /= MAX_NUMBER_OF_CHANNELS;
			Strob2LengthData /= MAX_NUMBER_OF_CHANNELS;
			Strob2LevelData /= MAX_NUMBER_OF_CHANNELS;
		}
		else if ( StrobAutoModeFlag == 1 )
		{
			j = 0;
			for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
			{
				if ( j < TempCurrentSettings.Unrolling[i+1] )
					j = TempCurrentSettings.Unrolling[i+1];
			}
			for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
			{
				k = GetUnrollingOrder( ( BYTE ) j ) - GetUnrollingOrder( ( BYTE ) TempCurrentSettings.Unrolling[i+1] );
				TempCurrentSettings.ASD1Base[i+1] >>= k;
				TempCurrentSettings.ASD1Length[i+1] >>= k;
				TempCurrentSettings.ASD2Base[i+1] >>= k;
				TempCurrentSettings.ASD2Length[i+1] >>= k;

				ShowWord( i*20, 350, TempCurrentSettings.ASD1Base[i+1] );
				ShowWord( i*20, 400, TempCurrentSettings.ASD1Length[i+1] );
				ShowWord( i*20, 450, TempCurrentSettings.ASD2Base[i+1] );
				ShowWord( i*20, 500, TempCurrentSettings.ASD2Length[i+1] );
			}

			Strob1BaseData = 250;
			Strob1LengthData = 0;
			Strob1LevelData = 200;
			Strob2BaseData = 150;
			Strob2LengthData = 0;
			Strob2LevelData = 200;
			for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
			{
				if ( Strob1BaseData > TempCurrentSettings.ASD1Base[i+1] )
					Strob1BaseData = TempCurrentSettings.ASD1Base[i+1];
				if ( Strob1LengthData < ( TempCurrentSettings.ASD1Base[i+1] + TempCurrentSettings.ASD1Length[i+1] ) )
					Strob1LengthData = TempCurrentSettings.ASD1Base[i+1] + TempCurrentSettings.ASD1Length[i+1];
				if ( Strob1LevelData > TempCurrentSettings.ASD1Level[i+1] )
					Strob1LevelData = TempCurrentSettings.ASD1Level[i+1];
				if ( Strob2BaseData > TempCurrentSettings.ASD2Base[i+1] )
					Strob2BaseData = TempCurrentSettings.ASD2Base[i+1];
				if ( Strob2LengthData < ( TempCurrentSettings.ASD2Base[i+1] + TempCurrentSettings.ASD2Length[i+1] ) )
					Strob2LengthData = TempCurrentSettings.ASD2Base[i+1] + TempCurrentSettings.ASD2Length[i+1];
				if ( Strob2LevelData > TempCurrentSettings.ASD2Level[i+1] )
					Strob2LevelData = TempCurrentSettings.ASD2Level[i+1];
			}
		}
		Strob1LengthData -= Strob1BaseData;
		Strob2LengthData -= Strob2BaseData;
		TempCurrentSettings.ASD1Base[0] = ( BYTE ) Strob1BaseData;
		TempCurrentSettings.ASD1Length[0] = ( BYTE ) Strob1LengthData;
		TempCurrentSettings.ASD1Level[0] = ( BYTE ) Strob1LevelData;
		TempCurrentSettings.ASD2Base[0] = ( BYTE ) Strob2BaseData;
		TempCurrentSettings.ASD2Length[0] = ( BYTE ) Strob2LengthData;
		TempCurrentSettings.ASD2Level[0] = ( BYTE ) Strob2LevelData;
		DrawStrobs( &TempCurrentSettings );
	}

	//   
	StrobsInit( Settings502 );

	TurnOffAllIndication();

	if ( CurrentSubMode != 0xff )
		TurnOnOneLamp( CurrentSubMode );

	if ( CurrentSubMode == ASD_TRESHOLD_CORRECT_KEY_CODE ||
	     CurrentSubMode == ASD_ENDING_CORRECT_KEY_CODE ||
	     CurrentSubMode == ASD_BEGINING_CORRECT_KEY_CODE )
	{
		if ( ASD1CorrectionSubMode == TRUE )
		{
			TurnOnOneLamp( ASD1_CORRECTION_KEY_CODE );
		}
		else if ( ASD2CorrectionSubMode == TRUE )
		{
			TurnOnOneLamp( ASD2_CORRECTION_KEY_CODE );
		}
	}

	if ( CurrentSubMode == MENU_KEY_CODE )
	{
		MenuMode = 0;
		DrawMenuPicture( MenuMode );
		MenuTable[MenuMode].OutputFlag = FALSE;
	}

	DrawVRCHCurves( Settings502 );

	if ( Settings502->VRCHLaw[Settings502->ChannelNumber] != ARD_MODE &&
	     Settings502->VRCHLaw[Settings502->ChannelNumber] != DAC_MODE )
	{
		MenuTable[MEASURE_MODE].HiddenFlag = TRUE;
		CurrentSettings.MeasureModeFlag = 0;
	}
	else
	{
		MenuTable[MEASURE_MODE].HiddenFlag = FALSE;
	}

	if ( ManyChannelModeFlag == TRUE )
	{
		//   
		//   
		if ( ProgramModeFlag == MANUAL_MODE )
		{
			//   .
  			strcpy( OutputBuffer, ChannelString );
			i = strlen( OutputBuffer );
			if ( ChannelEnable == FALSE )
				OutputBuffer[i] = '?';
			else
				OutputBuffer[i] = Settings502->ChannelNumber + 0x30;
			OutputBuffer[i+1] = 0;
			k = ChannelNumberYCoor;
			j = ChannelNumberXCoor+2;
			ClearRectangle12( k, j, k+8, j+6 );
			OutString7x9( k, j, OutputBuffer, WhiteColor );
		}
		else if ( ProgramModeFlag == AUTO_MODE )
		{
			i = strlen( ChannelString );
			k = ChannelNumberYCoor;
			j = ChannelNumberXCoor+2+i*7;
			OutString7x9( k, ChannelNumberXCoor+2, ChannelString, WhiteColor );
			ClearRectangle12( k, j, k+8, j+6 );
			DrawVerticalLine12( j+6, k, k+6, WhiteColor );
			DrawHorizontalLine12( k+6, j, j+6, WhiteColor );
			SetPixel12( k+5, j+1, WhiteColor );
			SetPixel12( k+7, j+1, WhiteColor );
			SetPixel12( k+4, j+2, WhiteColor );
			SetPixel12( k+8, j+2, WhiteColor );
		}

		DrawSolidity( Settings502 );
	}
	//    .
	if ( ManyChannelModeFlag == TRUE && ProgramModeFlag == AUTO_MODE )
	{
		j = MAX_AMPLIFICATION;
		for ( i=0;i<MAX_NUMBER_OF_CHANNELS;i++ )
		{
			if ( j > Settings502->AmplifierKoeff[i+1]  )
			{
				j = Settings502->AmplifierKoeff[i+1];
			}
		}
		k = SolidityAmplifierKoeff[Settings502->Solidity];
		if ( ( j + k ) > MAX_AMPLIFICATION )
			j = MAX_AMPLIFICATION - k;
		DrawAmplifierKoeff( Settings502, j + k );
	}
	else
	{
     		DrawAmplifierKoeff( Settings502, Settings502->AmplifierKoeff[Settings502->ChannelNumber] );
	}
	//    .
	DrawHorizontalCoor( Settings502 );
	//    "" -   "".
	if ( CurrentSubMode == MEMORY_KEY_CODE )
	{
		DrawRectangle( 0, MaxXRes-44, 11, MaxXRes, WhiteColor );
		OutString7x9( 1, MaxXRes-43, "N=", WhiteColor );

	 	msg.type = ONE_TURN_ON;
	 	msg.length = MEMORY_KEY_CODE;
	 	SendMsg( function_keyboard_id, &msg );
	 	ajwake( function_keyboard_id );
		DrawFrameNumber( FrameNumber );
	}
	//    "" -   "".
	if ( Settings502->CutSubMode == TRUE )
	{
	 	msg.type = ONE_TURN_ON;
	 	msg.length = CUT_OFF_KEY_CODE;
	 	SendMsg( function_keyboard_id, &msg );
	 	ajwake( function_keyboard_id );
		DrawCut( Settings502 );
	}
	//    "" -   "".
	if ( Settings502->VRCHSubMode == TRUE )
	{
	      	msg.type = ONE_TURN_ON;
	     	msg.length = VRCH_CORRECTION_KEY_CODE;
	      	SendMsg( function_keyboard_id, &msg );
	      	ajwake( function_keyboard_id );
	}

	if ( ReadPEP( ( BYTEPTR ) &Pep, Settings502->SensorNumber[Settings502->ChannelNumber] ) == TRUE )
	{
		PEPExistFlag = FALSE;
		memset( &RzKoeffTable[0], 0, 128 );
	}
	else
	{
		PEPExistFlag = TRUE;

    		memcpy( &RzKoeffTable[0], &Pep.PEPRzKoeff[0], 128 );
//		GetResource( X87 );
//		CalcRzArray( &RzKoeffTable[0], Settings502 );
//		FreeResource( X87 );
	}

	//    "." -   ".".
	if ( Settings502->RzSubMode == TRUE )
	{
	 	msg.type = ONE_TURN_ON;
	 	msg.length = ROUGHNESS_KEY_CODE;
	 	SendMsg( function_keyboard_id, &msg );
	 	ajwake( function_keyboard_id );
		//  .
		OutString7x9( RzYCoor+2, RzXCoor+2, "Rz=", WhiteColor );
		DrawRz( Settings502 );
	}
	//    "" -    "".
	if ( Settings502->AccSubMode == TRUE )
	{
	 	msg.type = ONE_TURN_ON;
	 	msg.length = ACCUMULATION_KEY_CODE;
	 	SendMsg( function_keyboard_id, &msg );
	 	ajwake( function_keyboard_id );
	}
	//       -  
	//   .
	if ( CurrentSubMode == SETTINGS_SELECTION_KEY_CODE )
	{
		DrawRectangle( 0, 0, 11, 50, WhiteColor );
	}

      	StatusPort &= 0x13;
	StatusPort |= DisplayBrightnessCodes[Settings502->DisplayBrightnessMode];
	StatusPort |= 0x80;
	ajdi();
	outp( STATUS_PORT, StatusPort );
	ajei();

	GetResource( X87 );
	outp( GZI_CONTROL_PORT, ( WORD ) ( ( double ) CurrentSettings.RadiatePower * GZICoeff ) );
	FreeResource( X87 );

  	SelectLayer( LayerNumber );
}


VOID DrawSolidity( struct SETTINGS502 *Settings502 )
{
	ClearRectangle12( SolidityYCoor, SolidityXCoor, SolidityYCoor+14, MaxXRes );
	DrawHorizontalLine12( SolidityYCoor+1, SolidityXCoor+4, SolidityXCoor+14, WhiteColor );
	DrawLine( SolidityYCoor+1, SolidityXCoor+4, SolidityYCoor+12, SolidityXCoor+9, WhiteColor );
	DrawLine( SolidityYCoor+12, SolidityXCoor+9, SolidityYCoor+1, SolidityXCoor+14, WhiteColor );
	OutString( SolidityYCoor+1, SolidityXCoor+17, EqualityString, WhiteColor );

	switch ( Settings502->Solidity )
	{
		case 0:
		DrawCycle( SolidityYCoor+6, SolidityXCoor+32, 5, WhiteColor );
		DrawLine( SolidityYCoor+1, SolidityXCoor+37, SolidityYCoor+11, SolidityXCoor+27, WhiteColor );
		break;

		case 1:
		OutString7x9( SolidityYCoor+3, SolidityXCoor+28, Digit0String, WhiteColor );
		break;

		case 2:
		OutString7x9( SolidityYCoor+3, SolidityXCoor+28, Digit1String, WhiteColor );
		break;

		case 3:
		OutString7x9( SolidityYCoor+3, SolidityXCoor+28, Digit2String, WhiteColor );
		break;
	}
}


VOID TurnOffAllIndication( VOID )
{
	retrun;
}


VOID TurnOffOneLamp( WORD LampCode )
{
	retrun;
}


VOID TurnOnOneLamp( WORD LampCode )
{
	retrun;
}


VOID FormatMCSMulty10ToMcs( BYTEPTR Buffer )
{
WORD i;

	i = strlen( Buffer );
	if ( i == 1 )
	{
		Buffer[2] = Buffer[0];
		Buffer[0] = '0';
		Buffer[1] = '.';
		Buffer[3] = 0;
	}
	else
	{
		Buffer[i] = Buffer[i-1];
		Buffer[i-1] = '.';
		Buffer[i+1] = 0;
	}
}


VOID FormatDivideBy10( BYTEPTR Buffer )
{
WORD i;
WORD j;

	i = strlen( Buffer );
	if ( i == 1 )
	{
		Buffer[2] = Buffer[0];
		Buffer[0] = '0';
		Buffer[1] = '.';
		Buffer[3] = 0;
	}
	else if ( i == 2 && Buffer[0] == '-' )
	{
		Buffer[3] = Buffer[1];
		Buffer[1] = '0';
		Buffer[2] = '.';
		Buffer[4] = 0;
	}
	else if ( i > 4 )
	{
		for ( j=0;j<i;j++ )
		{
			if ( Buffer[j] == '.' )
				break;
		}
		if ( j == i )
			j = 4;
		Buffer[j] = 0;
	}
	else
	{
		Buffer[i] = Buffer[i-1];
		Buffer[i-1] = '.';
		Buffer[i+1] = 0;
	}
}


//         .
LONG PixelsToMMMulty10( WORD Pixels, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	GetResource( X87 );

	RDouble = ( DOUBLE ) Settings502->Delay[Settings502->ChannelNumber];
	RDouble -= ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		RDouble += ( DOUBLE ) ( Pixels / 2 );
	}
	else
	{
		RDouble += ( DOUBLE ) ( Pixels * Settings502->Unrolling[Settings502->ChannelNumber] );
	}
	RDouble *= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble /= ( DOUBLE ) 4000;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= 500;
		RDouble /= ( 250 + Settings502->DepthKoeff );
	}
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	return R;
}


LONG PixelsToMM( WORD Pixels, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	GetResource( X87 );

	RDouble = ( DOUBLE ) Settings502->Delay[Settings502->ChannelNumber];
	RDouble -= ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		RDouble += ( DOUBLE ) ( Pixels / 2 );
	}
	else
	{
		RDouble += ( DOUBLE ) ( Pixels * Settings502->Unrolling[Settings502->ChannelNumber] );
	}
	RDouble *= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble /= ( DOUBLE ) 40000;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= 500.0;
		RDouble /= ( 250.0 + Settings502->DepthKoeff );
	}
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	return ( LONG ) R;
}


//    (  fifo   ).
LONG FifoBytesToMM( WORD FifoBytes, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	GetResource( X87 );

	RDouble = ( DOUBLE ) FifoBytes;
	RDouble *= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble /= ( DOUBLE ) 40000;
	if ( Settings502->DepthType == 1 )
	{
		R *= ( 250.0 + Settings502->DepthKoeff );
		R /= 500.0;
	}
	R = ( LONG ) RDouble;

	GetResource( X87 );

	return R;
}


//    (  fifo   ).
LONG FifoBytesToMMMulty10( WORD FifoBytes, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	GetResource( X87 );

	RDouble = ( DOUBLE ) FifoBytes;
	RDouble *= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble /= ( DOUBLE ) 4000;
	if ( Settings502->DepthType == 1 )
	{
		R *= ( 250.0 + Settings502->DepthKoeff );
		R /= 500.0;
	}
	R = ( LONG ) RDouble;

	GetResource( X87 );

	return R;
}


//  (  ->  * 10 ).
DWORD PixelsToMCSMulty10( WORD Pixels, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	GetResource( X87 );

	RDouble = ( DOUBLE ) Settings502->Delay[Settings502->ChannelNumber];
	RDouble -= ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		RDouble += ( DOUBLE ) ( Pixels / 2 );
	}
	else
	{
		RDouble += ( DOUBLE ) ( Pixels * Settings502->Unrolling[Settings502->ChannelNumber] );
	}
	RDouble *= 5.0;
	RDouble /= 10.0;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= ( 250.0 + Settings502->DepthKoeff );
		RDouble /= 500.0;
	}

	R = ( DWORD ) RDouble;
	FreeResource( X87 );

	return R;
}


//  (  fifo ->  * 10 ).
WORD FifoBytesToMCSMulty10( WORD FifoBytes )
{
DWORD R;

	R = FifoBytes;
	R *= 5;
	R /= 10;
	return ( WORD ) R;
}


DWORD MCSMulty10ToFifoBytes( WORD MCS )
{
DWORD R;

	R = MCS;
	R *= 10;
	R /= 5;
	return R;
}


DWORD MMToMCSMulty10( INT MM, struct SETTINGS502 *Settings502 )
{
LONG R;
LONG RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}
	RDouble = ( LONG ) MM;
	RDouble *= ( LONG ) 40000;
	RDouble /= ( LONG ) Settings502->UltrasonicSpeed;
	RDouble *= ( LONG ) 5;
	RDouble /= ( LONG ) 10;
	R = ( LONG ) RDouble;
	return R;
}


DWORD MM10ToMCS10( LONG MM, struct SETTINGS502 *Settings502 )
{
LONG R;
LONG RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}
	RDouble = ( LONG ) MM;
	RDouble *= ( LONG ) 4000;
	RDouble *= ( LONG ) 5;
	RDouble /= ( LONG ) Settings502->UltrasonicSpeed;
	RDouble /= ( LONG ) 10;
	R = ( LONG ) RDouble;
	return R;
}


//    ( cs*10 ->  )
LONG MCSMulty10ToMM( WORD MCS, struct SETTINGS502 *Settings502 )
{
LONG R;
LONG RDouble;

	RDouble = ( LONG ) MCS;
	RDouble *= ( LONG ) 10;
	RDouble *= ( LONG ) Settings502->UltrasonicSpeed;
	RDouble /= ( LONG ) 5;
	RDouble /= ( LONG ) 40000;
	R = ( LONG ) RDouble;
	return R;
}


//    ( cs*10 ->  )
LONG MCS10ToMM10( DWORD MCS, struct SETTINGS502 *Settings502 )
{
LONG R;
LONG RDouble;

	RDouble = ( LONG ) MCS;
	RDouble *= ( LONG ) 10;
	RDouble *= ( LONG ) Settings502->UltrasonicSpeed;
	RDouble /= ( LONG ) 5;
	RDouble /= ( LONG ) 4000;
	R = ( LONG ) RDouble;
	return R;
}


//    ( fifo bytes ->  ).
WORD FifoBytesToPixels( WORD FifoBytes, struct SETTINGS502 *Settings502 )
{
WORD R;

	if ( FifoBytes < Settings502->Delay[Settings502->ChannelNumber] )
	{
		R = 0xffff;
		goto quit_proc;
	}

	R = FifoBytes;
	R -= Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		R *= 2;
	}
	else
	{
		R /= Settings502->Unrolling[Settings502->ChannelNumber];
	}

quit_proc:
	return( R );
}


//         .
DWORD MMToPixels( INT MM, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}

	GetResource( X87 );

	RDouble = ( DOUBLE ) MM;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= ( 250.0 + Settings502->DepthKoeff );
		RDouble /= 500.0;
	}
	RDouble *= ( DOUBLE ) 40000;
	RDouble /= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble += ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];;
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	if ( R < Settings502->Delay[Settings502->ChannelNumber] )
	{
		R = 0xffff;
		goto quit_proc;
	}
	R -= Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		R *= 2;
	}
	else
	{
		R /= Settings502->Unrolling[Settings502->ChannelNumber];
	}

quit_proc:
	return R;
}


//          * 10.
DWORD MMMulty10ToPixels( INT MM, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}

	GetResource( X87 );

	RDouble = ( DOUBLE ) MM;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= ( 250.0 + Settings502->DepthKoeff );
		RDouble /= 500.0;
	}
	RDouble *= ( DOUBLE ) 40000;
	RDouble /= ( DOUBLE ) Settings502->UltrasonicSpeed;
	RDouble += ( DOUBLE ) Settings502->Depth0[Settings502->ChannelNumber];
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	if ( R < Settings502->Delay[Settings502->ChannelNumber] )
	{
		R = 0xffff;
		goto quit_proc;
	}
	R -= Settings502->Delay[Settings502->ChannelNumber];
	R *= 10;
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		R *= 2;
	}
	else
	{
		R /= Settings502->Unrolling[Settings502->ChannelNumber];
	}

quit_proc:
	return R;
}


//     fifo bytes    .
DWORD MMToFifoBytes( INT MM, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}

	GetResource( X87 );

	RDouble = ( DOUBLE ) MM;
	RDouble *= ( DOUBLE ) 40000;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= ( 250.0 + Settings502->DepthKoeff );
		RDouble /= 500.0;
	}
	RDouble /= ( DOUBLE ) Settings502->UltrasonicSpeed;
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	return R;
}


//     fifo bytes    .
DWORD MMMulty10ToFifoBytes( LONG MM, struct SETTINGS502 *Settings502 )
{
LONG R;
DOUBLE RDouble;

	if ( Settings502->UltrasonicSpeed == 0 )
	{
		SetTestSettings( 0, Settings502 );
	}

	GetResource( X87 );

	RDouble = ( DOUBLE ) MM;
	RDouble *= ( DOUBLE ) 4000;
	if ( Settings502->DepthType == 1 )
	{
		RDouble *= ( 250.0 + Settings502->DepthKoeff );
		RDouble /= 500.0;
	}
	RDouble /= ( DOUBLE ) Settings502->UltrasonicSpeed;
	R = ( LONG ) RDouble;

	FreeResource( X87 );

	return R;
}


WORD PixelsToFifoBytes( WORD Pixels, struct SETTINGS502 *Settings502 )
{
WORD R;

	R = Settings502->Delay[Settings502->ChannelNumber];
	if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
	{
		R += ( Pixels / 2 );
	}
	else
	{
		R += ( Pixels * Settings502->Unrolling[Settings502->ChannelNumber] );
	}

	return R;
}


DWORD PixelsToDBMulty10( DWORD Pixels, WORD BaseAmplifierKoeff )
{
DWORD A;
	if ( Pixels == 0 )
		Pixels = 1;

	GetResource( X87 );
	A = ( DWORD ) ( 200 * log10( ( double ) 200 / ( Pixels ) ) ) + BaseAmplifierKoeff * 10;
	FreeResource( X87 );

	return( A );
}


DWORD DBMulty10ToPixels( DWORD DB, WORD BaseAmplifierKoeff )
{
DWORD P;

	GetResource( X87 );
	P = ( DWORD ) ( 200 / pow( 10.0, ( double ) ( ( double ) DB - BaseAmplifierKoeff * 10 ) / 200.0 ) );
	FreeResource( X87 );

	return( P );
}


//   .
VOID UnrollingFormat( BYTE Unrolling, BYTEPTR Buffer )
{
	strcpy( Buffer, LeftArrowString );
	strcat( Buffer, SpaceString );
	strcat( Buffer, UnrollingStirngs[GetUnrollingOrder(Unrolling)] );
	strcat( Buffer, SpaceString );
	strcat( Buffer, MCSString );
	strcat( Buffer, SpaceString );
	strcat( Buffer, RightArrowString );
}


//   .
BYTE GetUnrollingOrder( BYTE UnrollingCode )
{
BYTE i;
	if ( UnrollingCode == 0 )
	{
		return( 0 );
	}

	for ( i=0;i<MAX_UNROLLING_NUMBER;i++ )
	{
		UnrollingCode >>= 1;
		if ( UnrollingCode == 0 ) break;
	}
	if ( i == MAX_UNROLLING_NUMBER ) ExitProgram( 3001 );
	return( i + 1 );
}


//   .
BYTE GetUnrollingCode( BYTE UnrollingOrder )
{
BYTE i;

	if ( UnrollingOrder == 0 )
	{
		return( 0 );
	}

	UnrollingOrder >>= 1;
	UnrollingOrder--;
	if ( UnrollingOrder > 6 )
	{
		UnrollingOrder = 6;
	}
	i = 1;
	i <<= UnrollingOrder;
	if ( i > MaxUnrolling )
	{
		i = MaxUnrolling >> 1;
	}
	else if ( i < MinUnrolling )
	{
		i = MinUnrolling << 1;
	}

	return( i );
}


VOID FormatWordDiv10( BYTEPTR Buffer, WORD Value )
{
WORD i;
WORD j;
BYTE Offset;
BOOL Flag;

	Offset = 0;
	Flag = FALSE;

	j = Value;
	i = j / 1000;
	if ( i != 0 )
	{
		Buffer[Offset] = ( BYTE ) ( i + 0x30 );
		Offset++;
		Flag = TRUE;
	}
	j = j - 1000 * i;

	i = j / 100;
	if ( i != 0 || Flag == TRUE )
	{
		Buffer[Offset] = ( BYTE ) ( i + 0x30 );
		Offset++;
		Flag = TRUE;
	}
	j = j - 100 * i;

	i = j / 10;
	Buffer[Offset] = ( BYTE ) ( i + 0x30 );
	Offset++;
	j = j - 10 * i;
	Buffer[Offset] = '.';
	Offset++;
	Buffer[Offset] = ( BYTE ) ( j + 0x30 );
	Offset++;
	Buffer[Offset] = 0;
}


VOID FormatRValue( BYTEPTR BytePtr, LONG LValue )
{
WORD i;
WORD j;

	if ( LValue < 1000 )
	{
		sprintf( BytePtr, "%d", ( WORD ) LValue );
		FormatDivideBy10( BytePtr );
	}
	else
	{
		sprintf( BytePtr, "%d", ( WORD ) LValue/10 );
	}
	i = strlen( BytePtr );
	if ( i < 4 && i != 0 )
	{
		for ( j=4;j>=i;j-- )
	 		BytePtr[j] = 0x20;
	}
	BytePtr[4] = 0x00;
}


VOID FormatXCValue( BYTEPTR BytePtr, LONG LValue )
{
WORD i;
WORD j;
WORD k;

	if ( LValue < 1000 && LValue >= 0 )
	{
		k = 4;
		sprintf( BytePtr, "%d", ( WORD ) LValue );
		FormatDivideBy10( BytePtr );
	}
	else if ( LValue >= 1000 )
	{
		k = 4;
		sprintf( BytePtr, "%d", ( WORD ) LValue/10 );
	}
	else if ( LValue < 0 )
	{
		k = 5;
		sprintf( BytePtr, "%d", ( WORD ) LValue );
		FormatDivideBy10( BytePtr );
	}
	i = strlen( BytePtr );
	if ( i < k && i != 0 )
	{
		for ( j=k;j>=i;j-- )
	 		BytePtr[j] = 0x20;
	}
	BytePtr[k] = 0x00;
}


VOID FormatNullValue( BYTEPTR OutputBuffer, WORD NullValue )
{
	sprintf( OutputBuffer, "%d", NullValue );
	if ( NullValue < 10 )
	{
		OutputBuffer[2] = OutputBuffer[0];
		OutputBuffer[0] = '0';
		OutputBuffer[1] = '.';
		OutputBuffer[3] = 0;
	}
	else if ( NullValue < 100 )
	{
		OutputBuffer[2] = OutputBuffer[1];
		OutputBuffer[1] = '.';
		OutputBuffer[3] = 0;
	}
	else
	{
		OutputBuffer[3] = OutputBuffer[2];
		OutputBuffer[2] = '.';
		OutputBuffer[4] = 0;
	}

}


VOID TurnOn( WORD Code )
{
	return;
}


VOID TurnOff( WORD Code )
{
	retrun;
}


VOID UpdateRadiusValue( WORD Number )
{
	//         
	if ( Number == 0 )
	{
		RadiusValue1Old = 0xff;
		RadiusValue2Old = 0xff;
	}
	if ( Number == 1 )
	{
		RadiusValue1Old = 0xff;
		RadiusValue1Clear = 0xff;
	}
	if ( Number == 2 )
	{
		RadiusValue2Old = 0xff;
		RadiusValue2Clear = 0xff;
	}
}


VOID ResetRadiusValue( WORD Number )
{
	//         
	if ( Number == 0 )
	{
		RadiusValue1Clear = 0xff;
		RadiusValue2Clear = 0xff;
	}
	if ( Number == 1 )
	{
		RadiusValue1Clear = 0xff;
	}
	if ( Number == 2 )
	{
		RadiusValue2Clear = 0xff;
	}
}


VOID ClearVRCHCurves( struct SETTINGS502 *Settings502 )
{
WORD LayerNumber;

	LayerNumber = GetLayer();
	SelectLayer( 3 );

	switch ( Settings502->VRCHLaw[Settings502->ChannelNumber] )
	{
		case R12_MODE:
		DrawCurve( &R12[0], BlackColor );
		break;

		case R32_MODE:
		DrawCurve( &R32[0], BlackColor );
		break;

		case ARD_MODE:
		DrawCurve( &ARD[0], BlackColor );
     		ClearEffectiveSquare();
		break;

		case DAC_MODE:
		DrawCurve( &DAC[0], BlackColor );
     		ClearEffectiveSquare();
		break;
	}

	SelectLayer( LayerNumber );
}


VOID DrawVRCHCurves( struct SETTINGS502 *Settings502 )
{
WORD LayerNumber;
WORD Retcode;

	LayerNumber = GetLayer();
	SelectLayer( 3 );

	switch ( Settings502->VRCHLaw[Settings502->ChannelNumber] )
	{
		case R12_MODE:
		GetResource( X87 );
	 	CalcR12Curve( Settings502 );
		FreeResource( X87 );
		DrawCurve( &R12[0], WhiteColor );
		break;

		case R32_MODE:
		GetResource( X87 );
	 	CalcR32Curve( Settings502 );
		FreeResource( X87 );
		DrawCurve( &R32[0], WhiteColor );
		break;

		case ARD_MODE:
		GetResource( X87 );
		Retcode = ReadARDCurve( Settings502 );
		if ( Retcode == 0 )
		{
	 		CalcARDKoeff( Settings502 );
		}
		FreeResource( X87 );
		if ( Retcode == 0 )
		{
			DrawCurve( &ARD[0], WhiteColor );
			DrawEffectiveSquare( Settings502->ARDEffectiveSquare[Settings502->ChannelNumber] );
		}
		break;

		case DAC_MODE:
		GetResource( X87 );
	 	CalcDACCurve( Settings502 );
		FreeResource( X87 );
	 	DrawCurve( &DAC[0], WhiteColor );
		DrawEffectiveSquare( Settings502->DACEffectiveSquare[Settings502->ChannelNumber] );
		break;

		case NO_VRCH_MODE:
		memset( &CurveData[0], 0, 64000 );
		break;
	}

	SelectLayer( LayerNumber );
}


VOID CalcVRCHCurves( struct SETTINGS502 *Settings502 )
{
WORD Retcode;

	switch ( Settings502->VRCHLaw[Settings502->ChannelNumber] )
	{
		case R12_MODE:
		GetResource( X87 );
	 	CalcR12Curve( Settings502 );
		FreeResource( X87 );
		break;

		case R32_MODE:
		GetResource( X87 );
	 	CalcR32Curve( Settings502 );
		FreeResource( X87 );
		break;

		case ARD_MODE:
		GetResource( X87 );
		Retcode = ReadARDCurve( Settings502 );
		if ( Retcode == 0 )
		{
	 		CalcARDKoeff( Settings502 );
		}
		FreeResource( X87 );
		break;

		case DAC_MODE:
		GetResource( X87 );
	 	CalcDACCurve( Settings502 );
		FreeResource( X87 );
		break;

		case NO_VRCH_MODE:
		memset( &CurveData[0], 0, 64000 );
		break;
	}
}


VOID ClearEffectiveSquare( VOID )
{
	ClearRectangle12( SqYCoor, SqXCoor, SqYCoor+14, MaxXRes );
}


VOID DrawEffectiveSquare( WORD EffectiveSquare )
{
	ClearRectangle12( SqYCoor, SqXCoor, SqYCoor+14, MaxXRes );
	strcpy( &OutputBuffer[0], SquareString );
 	FormatWordDiv10( &OutputBuffer[strlen( SquareString )], EffectiveSquare );
	OutString7x9( SqYCoor+2, SqXCoor+2, OutputBuffer, WhiteColor );
	DrawHorizontalLine12( SqYCoor+9, SqXCoor+9, SqXCoor+10, WhiteColor );
	DrawHorizontalLine12( SqYCoor+11, SqXCoor+9, SqXCoor+11, WhiteColor );
	DrawHorizontalLine12( SqYCoor+13, SqXCoor+9, SqXCoor+10, WhiteColor );
	SetPixel12( SqYCoor+10, SqXCoor+11, WhiteColor );
	SetPixel12( SqYCoor+12, SqXCoor+11, WhiteColor );
}


VOID DrawZoomDevice( BYTE Color )
{
	if ( Color == WhiteColor )
	{
		DrawCycle( 210, 6, 6, Color );
		DrawCycle( 210, 6, 5, Color );
		SetPixel12( 208, 8, Color );
		SetPixel12( 209, 9, Color );
		SetPixel12( 210, 9, Color );
		DrawRectangle( 215, 4, 225, 8, Color );
		DrawHorizontalLine12( 219, 4, 8, Color );
		DrawHorizontalLine12( 222, 4, 8, Color );
	}
	else
	{
		ClearRectangle12( 204, 0, 225, 12 );
	}
}


/*******************************************************************************
	R12
*******************************************************************************/
VOID CalcR12Curve( struct SETTINGS502 *Settings502 )
{
WORD i;
DWORD j;

	if ( Settings502->R12PointsNumber[Settings502->ChannelNumber] == 0 )
	{
		memset( &R12[0], 0, 250 );
		memset( &CurveData[0], 0, 64000 );
	}
	else if ( Settings502->R12PointsNumber[Settings502->ChannelNumber] == 1 )
	{
		j = ( DWORD ) 1260 - Settings502->R12YPoints[Settings502->ChannelNumber][0];
		for ( i=0;i<16000;i++ )
		{
			CurveData[i] = j;
		}
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &R12[0] );
	}
	else
	{
		CalcR12Law( Settings502 );
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &R12[0] );
	}

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == R12_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &R12[0], Mmax, 250 );
	}
}


VOID CalcR12Koeff( struct SETTINGS502 *Settings502 )
{
	ConvertLawToVisualPoints( Settings502, &CurveData[0], &R12[0] );

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == R12_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &R12[0], Mmax, 250 );
	}
}


VOID CalcR12Law( struct SETTINGS502 *Settings502 )
{
WORD i,k;
LONG YPtr[2];
LONG XPtr[2];
double Y1,Y2,X1,X2;
double A;
double B;
double YCoor;

	if ( Settings502->R12PointsNumber[Settings502->ChannelNumber] < 2 )
	{
		memset( &CurveData[0], 0, 64000 );
		goto quit_proc;
	}

	for ( i=0;i<Settings502->R12PointsNumber[Settings502->ChannelNumber];i++ )
	{
		YPtr[i] = 1260 - Settings502->R12YPoints[Settings502->ChannelNumber][i];
		XPtr[i] = Settings502->R12XPoints[Settings502->ChannelNumber][i];
	}

	//   R12
	GetResource( X87 );

	Y1 = ( double ) /*YPtr[0];*/DBMulty10ToPixels( 1260 - YPtr[0], Settings502->VRCHAmplifierCoeffSave );
	Y2 = ( double ) /*YPtr[1];*/DBMulty10ToPixels( 1260 - YPtr[1], Settings502->VRCHAmplifierCoeffSave );
	X1 = ( double ) XPtr[0];
	X2 = ( double ) XPtr[1];
	if ( Settings502->DepthType == 1 )
	{
		X1 *= ( 250 + Settings502->DepthKoeff );
		X1 /= 500;
		X2 *= ( 250 + Settings502->DepthKoeff );
		X2 /= 500;
	}

	B = ( Y1 * X1 * X1 - Y2 * X2 * X2 ) / ( Y2 - Y1 );
	A = Y1 * ( X1 * X1 + B );

	FreeResource( X87 );

	for ( i=0;i<=(WORD)X1;i++ )
	{
		CurveData[i] = YPtr[0];
	}
	GetResource( X87 );
	for ( ;i<(WORD)X2;i++ )
	{
		YCoor = A / ( ( double ) i * ( double ) i + B );
		CurveData[i] = ( DWORD ) /*YCoor;*/1260 - PixelsToDBMulty10( ( DWORD ) YCoor, Settings502->VRCHAmplifierCoeffSave );
		if ( CurveData[i] <= ( DWORD ) YPtr[1] )
			break;
	}
	FreeResource( X87 );
	for ( ;i<16000;i++ )
	{
		CurveData[i] = YPtr[1];
	}

quit_proc:
	return;
}


/*******************************************************************************
	R32
*******************************************************************************/
VOID CalcR32Curve( struct SETTINGS502 *Settings502 )
{
WORD i;
DWORD j;

	if ( Settings502->R32PointsNumber[Settings502->ChannelNumber] == 0 )
	{
		memset( &R32[0], 0, 250 );
		return;
	}
	else if ( Settings502->R32PointsNumber[Settings502->ChannelNumber] == 1 )
	{
		j = ( DWORD ) 1260 - Settings502->R32YPoints[Settings502->ChannelNumber][0];
		for ( i=0;i<16000;i++ )
		{
			CurveData[i] = j;
		}
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &R32[0] );
	}
	else
	{
		CalcR32Law( Settings502 );
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &R32[0] );
	}


	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == R32_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &R32[0], Mmax, 250 );
	}
}


VOID CalcR32Koeff( struct SETTINGS502 *Settings502 )
{
	ConvertLawToVisualPoints( Settings502, &CurveData[0], &R32[0] );

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == R32_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &R32[0], Mmax, 250 );
	}
}


VOID CalcR32Law( struct SETTINGS502 *Settings502 )
{
WORD i,k;
INT YPtr[2];
INT XPtr[2];
double Y1,Y2,X1,X2;
double A, B;
double YCoor;

	if ( Settings502->R32PointsNumber[Settings502->ChannelNumber] < 2 )
	{
		memset( &CurveData[0], 0, 64000 );
		goto quit_proc;
	}

	for ( i=0;i<Settings502->R32PointsNumber[Settings502->ChannelNumber];i++ )
	{
		YPtr[i] = 1260 - Settings502->R32YPoints[Settings502->ChannelNumber][i];
		XPtr[i] = Settings502->R32XPoints[Settings502->ChannelNumber][i];
	}

	//   R32
	GetResource( X87 );

	Y1 = ( double ) /*YPtr[0];*/DBMulty10ToPixels( 1260 - ( DWORD ) YPtr[0], Settings502->VRCHAmplifierCoeffSave );
	Y2 = ( double ) /*YPtr[1];*/DBMulty10ToPixels( 1260 - ( DWORD ) YPtr[1], Settings502->VRCHAmplifierCoeffSave );
	X1 = ( double ) XPtr[0];
	X2 = ( double ) XPtr[1];
	if ( Settings502->DepthType == 1 )
	{
		X1 *= ( 250 + Settings502->DepthKoeff );
		X1 /= 500;
		X2 *= ( 250 + Settings502->DepthKoeff );
		X2 /= 500;
	}

	B = ( Y1 * X1 * sqrt( X1 ) - Y2 * X2 * sqrt( X2 ) ) / ( Y2 - Y1 );
	A = Y1 * ( X1 * sqrt( X1 ) + B );

	FreeResource( X87 );

	for ( i=0;i<=(WORD)X1;i++ )
	{
		CurveData[i] = YPtr[0];
	}
	GetResource( X87 );
	for ( ;i<(WORD)X2;i++ )
	{
		YCoor = A / ( ( ( double ) i ) * sqrt( ( double ) i ) + B );
		CurveData[i] = 1260 - ( DWORD ) /*YCoor;*/PixelsToDBMulty10( ( DWORD ) YCoor, Settings502->VRCHAmplifierCoeffSave );
		if ( CurveData[i] <= ( DWORD ) YPtr[1] )
			break;
	}
	FreeResource( X87 );
	for ( ;i<16000;i++ )
	{
		CurveData[i] = YPtr[1];
	}

quit_proc:
	return;
}


VOID CalcARDKoeff( struct SETTINGS502 *Settings502 )
{
	ConvertLawToVisualPoints( Settings502, &CurveData[0], &ARD[0] );

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == ARD_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &ARD[0], Mmax, 250 );
	}
}


WORD ReadARDCurve( struct SETTINGS502 *Settings502 )
{
DWORD i;
DWORD j;
DWORD k;
WORDPTR WordPtr;
WORD Retcode;
DWORD Offset;
struct FILES *File;

	Offset = 1 + ( DWORD ) Settings502->ARDCurveNumber[Settings502->ChannelNumber] * 16004L;

	GetResource( X87 );
	sprintf( &OutputBuffer[0], "%s%sARD%3.3d.DAT", &ProgramPath[0], PEPPath, Settings502->SensorNumber[Settings502->ChannelNumber] );
	FreeResource( X87 );

	File = OpenFileAmx( &OutputBuffer[0], O_RDONLY );
	if ( File == NULL )
	{
		memset( &CurveData[0], 0, 64000 );
		Retcode = 2;
		goto quit_proc;
	}

	SeekFileAmx( File, Offset );
	ReadFileAmx( File, ( BYTEPTR ) &j, 4 );
	ReadFileAmx( File, ( BYTEPTR ) &CurveData[12000], 16000L );
	CloseFileAmx( File );

	Settings502->ARDEffectiveSquare[Settings502->ChannelNumber] = ( WORD ) j & 0x0000ffff;
	if ( Settings502->ARDEffectiveSquare[Settings502->ChannelNumber] > 999 )
		Settings502->ARDEffectiveSquare[Settings502->ChannelNumber] = 999;
	j >>= 16;
	WordPtr = ( WORDPTR ) &CurveData[12000];
	for ( i=0;i<8000;i++ )
	{
		k = 1260 - ( DWORD ) *WordPtr - j;
		CurveData[i*2] = k;
		CurveData[i*2+1] = k;
		WordPtr++;
	}

	Retcode = 0;

quit_proc:
	return( Retcode );
}


/*******************************************************************************
	DAC
*******************************************************************************/
VOID CalcDACCurve( struct SETTINGS502 *Settings502 )
{
WORD i;
DWORD j;

	if ( Settings502->DACPointsNumber[Settings502->ChannelNumber] == 0 )
	{
		memset( &DAC[0], 0, 250 );
		return;
	}
	else if ( Settings502->DACPointsNumber[Settings502->ChannelNumber] == 1 )
	{
		j = ( DWORD ) 1260 - Settings502->DACYPoints[Settings502->ChannelNumber][0];
		for ( i=0;i<16000;i++ )
		{
			CurveData[i] = j;
		}
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &DAC[0] );
	}
	else
	{
		CalcDACLaw( Settings502 );
		ConvertLawToVisualPoints( Settings502, &CurveData[0], &DAC[0] );
	}

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &DAC[0], Mmax, 250 );
	}
}


VOID CalcDACKoeff( struct SETTINGS502 *Settings502 )
{
	ConvertLawToVisualPoints( Settings502, &CurveData[0], &DAC[0] );

	if ( Settings502->VRCHSubMode == TRUE && Settings502->VRCHLaw[Settings502->ChannelNumber] == DAC_MODE )
	{
		Mmax = GetMmaxAmplificationCode( Settings502 );
		memset( &DAC[0], Mmax, 250 );
	}
}


VOID CalcDACLaw( struct SETTINGS502 *Settings502 )
{
DWORD YBegin;
DWORD XBegin;
DWORD YEnd;
DWORD XEnd;
LONG DeltaY;
LONG DeltaX;
LONG XDir;
LONG Temp;
WORD i;
DWORD j;
WORD k;
DWORD l;
INT YPtr[MAX_NUMBER_OF_DAC_POINTS];
INT XPtr[MAX_NUMBER_OF_DAC_POINTS];
int handle;
int bytes;

	if ( Settings502->DACPointsNumber[Settings502->ChannelNumber] < 2 )
	{
		memset( &CurveData[0], 0, 64000 );
		goto quit_proc;
	}

	for ( i=0;i<Settings502->DACPointsNumber[Settings502->ChannelNumber];i++ )
	{
		YPtr[i] = 1260 - Settings502->DACYPoints[Settings502->ChannelNumber][i];
		XPtr[i] = Settings502->DACXPoints[Settings502->ChannelNumber][i];
	}

	for ( i=0;i<=XPtr[0];i++ )
	{
		CurveData[i] = YPtr[0];
	}

	for ( k=0;k<Settings502->DACPointsNumber[Settings502->ChannelNumber]-1;k++ )
	{
		YBegin = /*YPtr[k];*/DBMulty10ToPixels( 1260 - ( DWORD ) YPtr[k], Settings502->VRCHAmplifierCoeffSave );
		XBegin = XPtr[k];
		YEnd = /*YPtr[k+1];*/DBMulty10ToPixels( 1260 - ( DWORD ) YPtr[k+1], Settings502->VRCHAmplifierCoeffSave );
		XEnd = XPtr[k+1];
		if ( Settings502->DepthType == 1 )
		{
			XBegin *= ( 250 + Settings502->DepthKoeff );
			XBegin /= 500;
			XEnd *= ( 250 + Settings502->DepthKoeff );
			XEnd /= 500;
		}

		if ( YBegin > YEnd )
		{
			Temp = YBegin;
			YBegin = YEnd;
			YEnd = Temp;
			Temp = XBegin;
			XBegin = XEnd;
			XEnd = Temp;
		}

		DeltaY = YEnd - YBegin;
		if ( DeltaY < 0 ) DeltaY = -DeltaY;
		DeltaX = XEnd - XBegin;
		if ( DeltaX < 0 )
		{
			XDir = -1;
			DeltaX = -DeltaX;
		}
		else XDir = 1;

		//  ,    : ,
		//   .
		if ( DeltaY == 0 )
		{
			if ( XDir == -1 )
			{
				Temp = XBegin;
				XBegin = XEnd;
				XEnd = Temp;
			}
			for ( l=XBegin;l<=XEnd;l++ )
			{
				CurveData[l] = YBegin;
			}
		}
		else if ( DeltaY == DeltaX )
		{
			for ( l=YBegin,j=XBegin;l<=YEnd;l++,j+=XDir )
			{
				CurveData[j] = l;
			}
		}
		//     .
		else
		{
			if ( XDir == 1 )
			{
				if ( DeltaX > DeltaY )
					CalcHugeOctant0( YBegin, XBegin, DeltaY, DeltaX, 1, &CurveData[0] );
				else
					CalcHugeOctant1( YBegin, XBegin, DeltaY, DeltaX, 1, &CurveData[0] );
			}
			else
			{
				if ( DeltaX > DeltaY )
					CalcHugeOctant0( YBegin, XBegin, DeltaY, DeltaX, -1, &CurveData[0] );
				else
					CalcHugeOctant1( YBegin, XBegin, DeltaY, DeltaX, -1, &CurveData[0] );
			}
		}

		for ( j=XBegin,l=0;l<=DeltaX;j+=XDir,l++ )
		{
			CurveData[j] = 1260 - PixelsToDBMulty10( ( DWORD ) CurveData[j], Settings502->VRCHAmplifierCoeffSave );
		}
	}

	XBegin = XPtr[k];
	if ( Settings502->DepthType == 1 )
	{
		XBegin *= ( 250 + Settings502->DepthKoeff );
		XBegin /= 500;
	}
	for ( i=(WORD)XBegin;i<16000;i++ )
	{
		CurveData[i] = YPtr[k];
	}
quit_proc:
	return;
}


VOID CalcHugeOctant0( DWORD YBegin, DWORD XBegin, DWORD DeltaY, DWORD DeltaX, INT XDirection, DWORDPTR Data )
{
LONG DeltaYx2;
LONG DeltaYx2minusDeltaXx2;
LONG ErrorTerm;

	DeltaYx2 = DeltaY * 2;
	DeltaYx2minusDeltaXx2 = DeltaYx2 - ( LONG ) ( DeltaX * 2 );
	ErrorTerm = DeltaYx2 - ( LONG ) DeltaX;
	//  1- .
	Data[XBegin] = YBegin;

	//   .
	while ( DeltaX-- )
	{
		if ( ErrorTerm >= 0 )
		{
			YBegin++;
			ErrorTerm += DeltaYx2minusDeltaXx2;
		}
		else ErrorTerm += DeltaYx2;
		XBegin += XDirection;
		Data[XBegin] = YBegin;
	}
}


VOID CalcHugeOctant1( DWORD YBegin, DWORD XBegin, DWORD DeltaY, DWORD DeltaX, INT XDirection, DWORDPTR Data )
{
LONG DeltaXx2;
LONG DeltaXx2minusDeltaYx2;
LONG ErrorTerm;

	DeltaXx2 = DeltaX * 2;
	DeltaXx2minusDeltaYx2 = DeltaXx2 - ( LONG ) ( DeltaY * 2 );
	ErrorTerm = DeltaXx2 - ( LONG ) DeltaY;
	//  1- .
	Data[XBegin] = YBegin;

	//   .
	while ( DeltaY-- )
	{
		if ( ErrorTerm >= 0 )
		{
			XBegin += XDirection;
			ErrorTerm += DeltaXx2minusDeltaYx2;
 			Data[XBegin] = YBegin + 1;
		}
		else ErrorTerm += DeltaXx2;
		YBegin++;
	}
}


VOID DrawCrossHair( WORD YCoor, WORD XCoor, BYTE Color )
{
WORD XCoorLeft;
WORD XCoorRight;
WORD YCoorTop;
WORD YCoorBottom;

	if ( XCoor > 250 )
		return;

	XCoorLeft = 2;
	XCoorRight = 2;
	YCoorTop = 2;
	YCoorBottom = 2;

	if ( XCoor == 0 )
		XCoorLeft = 0;
	if ( XCoor == 1 )
		XCoorLeft = 1;
	if ( XCoor == 249 )
		XCoorRight = 1;
	if ( XCoor == 250 )
		XCoorRight = 0;
	if ( YCoor == 0 )
		YCoorBottom = 0;
	if ( YCoor == 1 )
		YCoorBottom = 1;
	if ( YCoor == 199 )
		YCoorTop = 1;
	if ( YCoor == 200 )
		YCoorTop = 0;

	DrawRectangle( BEGIN_YCOOR+200-YCoor-YCoorTop, BEGIN_XCOOR+XCoor-XCoorLeft, BEGIN_YCOOR+200-YCoor+YCoorBottom, BEGIN_XCOOR+XCoor+XCoorRight, Color );
	DrawVerticalLine12( BEGIN_XCOOR+1+XCoor, BEGIN_YCOOR, BEGIN_YCOOR+200, Color );

}


VOID DrawCrossHairWOLine( WORD YCoor, WORD XCoor, BYTE Color )
{
WORD XCoorLeft;
WORD XCoorRight;
WORD YCoorTop;
WORD YCoorBottom;

	if ( XCoor > 250 )
		return;

	XCoorLeft = 2;
	XCoorRight = 2;
	YCoorTop = 2;
	YCoorBottom = 2;

	if ( XCoor == 0 )
		XCoorLeft = 0;
	if ( XCoor == 1 )
		XCoorLeft = 1;
	if ( XCoor == 249 )
		XCoorRight = 1;
	if ( XCoor == 250 )
		XCoorRight = 0;
	if ( YCoor == 0 )
		YCoorBottom = 0;
	if ( YCoor == 1 )
		YCoorBottom = 1;
	if ( YCoor == 199 )
		YCoorTop = 1;
	if ( YCoor == 200 )
		YCoorTop = 0;

	DrawRectangle( BEGIN_YCOOR+200-YCoor-YCoorTop, BEGIN_XCOOR+XCoor-XCoorLeft, BEGIN_YCOOR+200-YCoor+YCoorBottom, BEGIN_XCOOR+XCoor+XCoorRight, Color );
}


VOID DrawE( BYTE Color )
{
	DrawHorizontalLine12( SqYCoor+9, SqXCoor+9, SqXCoor+10, Color );
	DrawHorizontalLine12( SqYCoor+11, SqXCoor+9, SqXCoor+11, Color );
	DrawHorizontalLine12( SqYCoor+13, SqXCoor+9, SqXCoor+10, Color );
	SetPixel12( SqYCoor+10, SqXCoor+11, Color );
	SetPixel12( SqYCoor+12, SqXCoor+11, Color );
}


/*******************************************************************************
	  
*******************************************************************************/
VOID DrawCurve( BYTEPTR Data, BYTE Color )
{
WORD i;
	for ( i=0;i<250-1;i++ )
	{
		DrawPointToPointLine( Data[i], i, Data[i+1], i+1, Color );
	}
}


VOID ConvertLawToVisualPoints( struct SETTINGS502 *Settings502, DWORDPTR DBData, BYTEPTR Data )
{
WORD i,j,k;
DWORD DB;

	j = Settings502->Delay[Settings502->ChannelNumber];
	for ( i=0;i<250;i++ )
	{
		if ( Settings502->Unrolling[Settings502->ChannelNumber] == 0 )
			k = ( WORD ) i / 2;
		else
			k = ( WORD ) i * Settings502->Unrolling[Settings502->ChannelNumber];

		DB = DBMulty10ToPixels( ( DWORD ) ( 1260 - ( WORD ) DBData[j+k] ), ( WORD ) Settings502->AmplifierKoeff[Settings502->ChannelNumber] );
		if ( DB <= 200 )
			Data[i] = ( BYTE ) DB;
		else
			Data[i] = 200;
	}
}


WORD GetMmaxAmplificationCode( struct SETTINGS502 *Settings502 )
{
WORD i;
DWORD MaxCode;

	MaxCode = 0;

	for ( i=0;i<16000;i++ )
	{
		if ( MaxCode < CurveData[i] && CurveData[i] < 1260 )
			MaxCode = CurveData[i];
	}

	MaxDBCode = MaxCode;

	MaxCode = DBMulty10ToPixels( 1260 - MaxCode, Settings502->AmplifierKoeff[Settings502->ChannelNumber] );
	if ( MaxCode > 200 )
		MaxCode = 200;

quit_proc:
	return( ( WORD ) MaxCode );
}







//   ()
VOID SendVRCHLawToDSP( BYTE ChannelNumber )
{
	return;
}
VOID UpdateMCSettingsOnDSP( BYTE SettingsNumber )
{
	return;
}
VOID UpdateSettingsOnDSP( struct SETTINGS502 *Settings502 )
{
	return;
}
VOID UpdateRzArrayOnDSP( BYTEPTR Data, BYTE ChannelNumber )
{
	return;
}
VOID GetResource( WORD Number )
{
	return;
}
VOID FreeResource( WORD Number )
{
	return;
}
BYTE GetLayer( VOID )
{
	return;
}
VOID SelectLayer( BYTE )
{
	return;
}


